/******************************************************************************
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2010-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * This header file was automatically generated by:
 *
 *     /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/expr/mkkind /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/expr/kind_template.h /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/builtin/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/booleans/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/uf/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/arith/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/bv/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/ff/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/fp/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/arrays/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/datatypes/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/sep/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/sets/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/bags/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/strings/kinds /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/theory/quantifiers/kinds
 *
 * for the cvc5 project.
 */

/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */

/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */

/* Edit the template file instead:                     */
/* /builddir/build/BUILD/cvc5-1.2.1-build/cvc5-cvc5-1.2.1/src/expr/kind_template.h */

/******************************************************************************
 * Top contributors (to current version):
 *   Aina Niemetz, Andres Noetzli, Mathias Preiner
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Template for the Node kind header.
 */

#include "cvc5_public.h"

#ifndef CVC5__KIND_H
#define CVC5__KIND_H

#include <iosfwd>

#include "base/exception.h"
#include "theory/theory_id.h"

namespace cvc5::internal {
namespace kind {

enum class Kind_t
{
  UNDEFINED_KIND = -1, /**< undefined */
  NULL_EXPR,           /**< Null kind */
  // clang-format off
  
  /* from builtin */
  SORT_TYPE, /**< specifies types of user-declared 'uninterpreted' sorts (1) */
  INSTANTIATED_SORT_TYPE, /**< instantiated uninterpreted sort (2) */
  UNINTERPRETED_SORT_VALUE, /**< util/uninterpreted_sort_value.h (3) */
  BUILTIN, /**< expr/kind.h (4) */
  EQUAL, /**< equality (two parameters only, sorts must match) (5) */
  DISTINCT, /**< disequality (N-ary, sorts must match) (6) */
  VARIABLE, /**< a variable (not permitted in bindings) (7) */
  BOUND_VARIABLE, /**< a bound variable (permitted in bindings and the associated lambda and quantifier bodies only) (8) */
  SKOLEM, /**< a Skolem variable (9) */
  DUMMY_SKOLEM, /**< a Skolem variable (internal only) (10) */
  SEXPR, /**< a symbolic expression (any arity) (11) */
  WITNESS, /**< a witness expression; first parameter is a BOUND_VAR_LIST, second is the witness body (12) */
  TYPE_CONSTANT, /**< expr/kind.h (13) */
  RAW_SYMBOL, /**< a variable that is not quoted in the smt2 printer (internal only) (14) */
  ABSTRACT_TYPE, /**< theory/builtin/abstract_type.h (15) */
  APPLY_INDEXED_SYMBOLIC_OP, /**< theory/builtin/generic_op.h (16) */
  APPLY_INDEXED_SYMBOLIC, /**< generic indexed operator, whose arguments are the list of terms corresponding to (symbolic) indices to the operator followed by its normal arguments (17) */
  SORT_TO_TERM, /**< expr/sort_to_term.h (18) */
  TYPE_OF, /**< the type of an expression, used internally for RARE (19) */

  /* from booleans */
  CONST_BOOLEAN, /**< util/bool.h (20) */
  NOT, /**< logical not (21) */
  AND, /**< logical and (N-ary) (22) */
  IMPLIES, /**< logical implication (exactly two parameters) (23) */
  OR, /**< logical or (N-ary) (24) */
  XOR, /**< exclusive or (exactly two parameters) (25) */
  ITE, /**< if-then-else, used for both Boolean and term ITE constructs; first parameter is (Boolean-sorted) condition, second is 'then', third is 'else' and these two parameters must have same base sort (26) */

  /* from uf */
  APPLY_UF, /**< application of an uninterpreted function; first parameter is the function, remaining ones are parameters to that function (27) */
  FUNCTION_TYPE, /**< a function type (28) */
  LAMBDA, /**< a lambda expression; first parameter is a BOUND_VAR_LIST, second is lambda body (29) */
  HO_APPLY, /**< higher-order (partial) function application (30) */
  CARDINALITY_CONSTRAINT_OP, /**< expr/cardinality_constraint.h (31) */
  CARDINALITY_CONSTRAINT, /**< a fixed upper bound on the cardinality of an uninterpreted sort (32) */
  COMBINED_CARDINALITY_CONSTRAINT_OP, /**< expr/cardinality_constraint.h (33) */
  COMBINED_CARDINALITY_CONSTRAINT, /**< a fixed upper bound on the sum of cardinalities of uninterpreted sorts (34) */
  FUNCTION_ARRAY_CONST, /**< expr/function_array_const.h (35) */
  BITVECTOR_TO_NAT, /**< bit-vector conversion to (nonnegative) integer; parameter is a bit-vector (36) */
  INT_TO_BITVECTOR_OP, /**< util/bitvector.h (37) */
  INT_TO_BITVECTOR, /**< integer conversion to bit-vector; first parameter is an INT_TO_BITVECTOR_OP, second is an integer term (38) */

  /* from arith */
  ADD, /**< arithmetic addition (N-ary) (39) */
  MULT, /**< arithmetic multiplication (N-ary) (40) */
  NONLINEAR_MULT, /**< synonym for MULT (41) */
  SUB, /**< arithmetic binary subtraction operator (42) */
  NEG, /**< arithmetic unary negation (43) */
  DIVISION, /**< real division, division by 0 undefined (user symbol) (44) */
  DIVISION_TOTAL, /**< real division with interpreted division by 0 (internal symbol) (45) */
  INTS_DIVISION, /**< integer division, division by 0 undefined (user symbol) (46) */
  INTS_DIVISION_TOTAL, /**< integer division with interpreted division by 0 (internal symbol) (47) */
  INTS_MODULUS, /**< integer modulus, division by 0 undefined (user symbol) (48) */
  INTS_MODULUS_TOTAL, /**< integer modulus with interpreted division by 0 (internal symbol) (49) */
  ABS, /**< absolute value (50) */
  DIVISIBLE, /**< divisibility-by-k predicate; first parameter is a DIVISIBLE_OP, second is integer term (51) */
  POW, /**< arithmetic power (52) */
  POW2, /**< arithmetic power of 2 (53) */
  INTS_ISPOW2, /**< test if an integer is a power of 2 (54) */
  INTS_LOG2, /**< integer logarithm base 2 (round down to power of 2) (55) */
  EXPONENTIAL, /**< exponential (56) */
  SINE, /**< sine (57) */
  COSINE, /**< consine (58) */
  TANGENT, /**< tangent (59) */
  COSECANT, /**< cosecant (60) */
  SECANT, /**< secant (61) */
  COTANGENT, /**< cotangent (62) */
  ARCSINE, /**< arc sine (63) */
  ARCCOSINE, /**< arc consine (64) */
  ARCTANGENT, /**< arc tangent (65) */
  ARCCOSECANT, /**< arc cosecant (66) */
  ARCSECANT, /**< arc secant (67) */
  ARCCOTANGENT, /**< arc cotangent (68) */
  SQRT, /**< square root (69) */
  DIVISIBLE_OP, /**< util/divisible.h (70) */
  CONST_RATIONAL, /**< util/rational.h (71) */
  CONST_INTEGER, /**< util/rational.h (72) */
  REAL_ALGEBRAIC_NUMBER_OP, /**< util/real_algebraic_number.h (73) */
  REAL_ALGEBRAIC_NUMBER, /**< a real algebraic number constant; payload is an instance of the cvc5::internal::RealAlgebraicNumber class (74) */
  LT, /**< less than, x < y (75) */
  LEQ, /**< less than or equal, x <= y (76) */
  GT, /**< greater than, x > y (77) */
  GEQ, /**< greater than or equal, x >= y (78) */
  INDEXED_ROOT_PREDICATE_OP, /**< util/indexed_root_predicate.h (79) */
  INDEXED_ROOT_PREDICATE, /**< indexed root predicate; first parameter is a INDEXED_ROOT_PREDICATE_OP, second is a real variable compared to zero, third is a polynomial (80) */
  IS_INTEGER, /**< term-is-integer predicate (parameter is a real-sorted term) (81) */
  TO_INTEGER, /**< convert term to integer by the floor function (parameter is a real-sorted term) (82) */
  TO_REAL, /**< cast term to real (parameter is an integer-sorted term) (83) */
  PI, /**< pi (84) */
  IAND_OP, /**< util/iand.h (85) */
  IAND, /**< integer version of AND operator; first parameter is an IAND_OP, second and third are integer terms (86) */

  /* from bv */
  BITVECTOR_TYPE, /**< util/bitvector.h (87) */
  CONST_BITVECTOR, /**< util/bitvector.h (88) */
  BITVECTOR_FROM_BOOLS, /**< create bit-vector from vector of Booleans (89) */
  BITVECTOR_SIZE, /**< Size of bitvector (90) */
  CONST_BITVECTOR_SYMBOLIC, /**< A symbolic bitvector constant. The first argument is its value (an integer), and the second value is its size (also an integer). (91) */
  BITVECTOR_CONCAT, /**< concatenation of two or more bit-vectors (92) */
  BITVECTOR_AND, /**< bitwise and of two or more bit-vectors (93) */
  BITVECTOR_COMP, /**< equality comparison of two bit-vectors (returns one bit) (94) */
  BITVECTOR_OR, /**< bitwise or of two or more bit-vectors (95) */
  BITVECTOR_XOR, /**< bitwise xor of two or more bit-vectors (96) */
  BITVECTOR_NOT, /**< bitwise not of a bit-vector (97) */
  BITVECTOR_NAND, /**< bitwise nand of two bit-vectors (98) */
  BITVECTOR_NOR, /**< bitwise nor of two bit-vectors (99) */
  BITVECTOR_XNOR, /**< bitwise xnor of two bit-vectors (100) */
  BITVECTOR_MULT, /**< multiplication of two or more bit-vectors (101) */
  BITVECTOR_NEG, /**< unary negation of a bit-vector (102) */
  BITVECTOR_ADD, /**< addition of two or more bit-vectors (103) */
  BITVECTOR_SUB, /**< subtraction of two bit-vectors (104) */
  BITVECTOR_UDIV, /**< unsigned division of two bit-vectors, truncating towards 0 (defined to be the all-ones bit pattern, if divisor is 0) (105) */
  BITVECTOR_UREM, /**< unsigned remainder from truncating division of two bit-vectors (defined to be equal to the dividend, if divisor is 0) (106) */
  BITVECTOR_SDIV, /**< 2's complement signed division (107) */
  BITVECTOR_SMOD, /**< 2's complement signed remainder (sign follows divisor) (108) */
  BITVECTOR_SREM, /**< 2's complement signed remainder (sign follows dividend) (109) */
  BITVECTOR_ASHR, /**< bit-vector arithmetic shift right (the two bit-vector parameters must have same width) (110) */
  BITVECTOR_LSHR, /**< bit-vector logical shift right (the two bit-vector parameters must have same width) (111) */
  BITVECTOR_SHL, /**< bit-vector shift left (the two bit-vector parameters must have same width) (112) */
  BITVECTOR_ULE, /**< bit-vector unsigned less than or equal (the two bit-vector parameters must have same width) (113) */
  BITVECTOR_ULT, /**< bit-vector unsigned less than (the two bit-vector parameters must have same width) (114) */
  BITVECTOR_UGE, /**< bit-vector unsigned greater than or equal (the two bit-vector parameters must have same width) (115) */
  BITVECTOR_UGT, /**< bit-vector unsigned greater than (the two bit-vector parameters must have same width) (116) */
  BITVECTOR_SLE, /**< bit-vector signed less than or equal (the two bit-vector parameters must have same width) (117) */
  BITVECTOR_SLT, /**< bit-vector signed less than (the two bit-vector parameters must have same width) (118) */
  BITVECTOR_SGE, /**< bit-vector signed greater than or equal (the two bit-vector parameters must have same width) (119) */
  BITVECTOR_SGT, /**< bit-vector signed greater than (the two bit-vector parameters must have same width) (120) */
  BITVECTOR_ULTBV, /**< bit-vector unsigned less than but returns bv of size 1 instead of boolean (121) */
  BITVECTOR_SLTBV, /**< bit-vector signed less than but returns bv of size 1 instead of boolean (122) */
  BITVECTOR_REDAND, /**< bit-vector redand (123) */
  BITVECTOR_REDOR, /**< bit-vector redor (124) */
  BITVECTOR_NEGO, /**< bit-vector negation overflow predicate (125) */
  BITVECTOR_UADDO, /**< bit-vector unsigned addition overflow predicate (126) */
  BITVECTOR_SADDO, /**< bit-vector signed addition overflow predicate (127) */
  BITVECTOR_UMULO, /**< bit-vector unsigned multiplication overflow predicate (128) */
  BITVECTOR_SMULO, /**< bit-vector signed multiplication overflow predicate (129) */
  BITVECTOR_USUBO, /**< bit-vector unsigned subtraction overflow predicate (130) */
  BITVECTOR_SSUBO, /**< bit-vector signed subtraction overflow predicate (131) */
  BITVECTOR_SDIVO, /**< bit-vector signed division overflow predicate (132) */
  BITVECTOR_ITE, /**< same semantics as regular ITE, but condition is bv of size 1 instead of Boolean (133) */
  BITVECTOR_ACKERMANNIZE_UDIV, /**< term to be treated as a variable; used for eager bit-blasting Ackermann expansion of bvudiv (internal-only symbol) (134) */
  BITVECTOR_ACKERMANNIZE_UREM, /**< term to be treated as a variable; used for eager bit-blasting Ackermann expansion of bvurem (internal-only symbol) (135) */
  BITVECTOR_EAGER_ATOM, /**< formula to be treated as a bv atom via eager bit-blasting (internal-only symbol) (136) */
  BITVECTOR_BIT_OP, /**< util/bitvector.h (137) */
  BITVECTOR_BIT, /**< bit-vector boolean bit extract; first parameter is a BITVECTOR_BIT_OP, second is a bit-vector term (138) */
  BITVECTOR_EXTRACT_OP, /**< util/bitvector.h (139) */
  BITVECTOR_EXTRACT, /**< bit-vector extract; first parameter is a BITVECTOR_EXTRACT_OP, second is a bit-vector term (140) */
  BITVECTOR_REPEAT_OP, /**< util/bitvector.h (141) */
  BITVECTOR_REPEAT, /**< bit-vector repeat; first parameter is a BITVECTOR_REPEAT_OP, second is a bit-vector term (142) */
  BITVECTOR_ROTATE_LEFT_OP, /**< util/bitvector.h (143) */
  BITVECTOR_ROTATE_LEFT, /**< bit-vector rotate left; first parameter is a BITVECTOR_ROTATE_LEFT_OP, second is a bit-vector term (144) */
  BITVECTOR_ROTATE_RIGHT_OP, /**< util/bitvector.h (145) */
  BITVECTOR_ROTATE_RIGHT, /**< bit-vector rotate right; first parameter is a BITVECTOR_ROTATE_RIGHT_OP, second is a bit-vector term (146) */
  BITVECTOR_SIGN_EXTEND_OP, /**< util/bitvector.h (147) */
  BITVECTOR_SIGN_EXTEND, /**< bit-vector sign-extend; first parameter is a BITVECTOR_SIGN_EXTEND_OP, second is a bit-vector term (148) */
  BITVECTOR_ZERO_EXTEND_OP, /**< util/bitvector.h (149) */
  BITVECTOR_ZERO_EXTEND, /**< bit-vector zero-extend; first parameter is a BITVECTOR_ZERO_EXTEND_OP, second is a bit-vector term (150) */

  /* from ff */
  FINITE_FIELD_TYPE, /**< util/finite_field_value.h (151) */
  CONST_FINITE_FIELD, /**< util/finite_field_value.h (152) */
  FINITE_FIELD_MULT, /**< multiplication of two or more field elements (153) */
  FINITE_FIELD_NEG, /**< unary negation of a field element (154) */
  FINITE_FIELD_ADD, /**< addition of two or more field elements (155) */
  FINITE_FIELD_BITSUM, /**< bitsum of field elements (156) */

  /* from fp */
  CONST_FLOATINGPOINT, /**< util/floatingpoint.h (157) */
  CONST_ROUNDINGMODE, /**< util/roundingmode.h (158) */
  FLOATINGPOINT_TYPE, /**< util/floatingpoint.h (159) */
  FLOATINGPOINT_FP, /**< construct a floating-point literal from bit vectors (160) */
  FLOATINGPOINT_EQ, /**< floating-point equality (161) */
  FLOATINGPOINT_ABS, /**< floating-point absolute value (162) */
  FLOATINGPOINT_NEG, /**< floating-point negation (163) */
  FLOATINGPOINT_ADD, /**< floating-point addition (164) */
  FLOATINGPOINT_SUB, /**< floating-point sutraction (165) */
  FLOATINGPOINT_MULT, /**< floating-point multiply (166) */
  FLOATINGPOINT_DIV, /**< floating-point division (167) */
  FLOATINGPOINT_FMA, /**< floating-point fused multiply and add (168) */
  FLOATINGPOINT_SQRT, /**< floating-point square root (169) */
  FLOATINGPOINT_REM, /**< floating-point remainder (170) */
  FLOATINGPOINT_RTI, /**< floating-point round to integral (171) */
  FLOATINGPOINT_MIN, /**< floating-point minimum (172) */
  FLOATINGPOINT_MAX, /**< floating-point maximum (173) */
  FLOATINGPOINT_MIN_TOTAL, /**< floating-point minimum (defined for all inputs) (174) */
  FLOATINGPOINT_MAX_TOTAL, /**< floating-point maximum (defined for all inputs) (175) */
  FLOATINGPOINT_LEQ, /**< floating-point less than or equal (176) */
  FLOATINGPOINT_LT, /**< floating-point less than (177) */
  FLOATINGPOINT_GEQ, /**< floating-point greater than or equal (178) */
  FLOATINGPOINT_GT, /**< floating-point greater than (179) */
  FLOATINGPOINT_IS_NORMAL, /**< floating-point is normal (180) */
  FLOATINGPOINT_IS_SUBNORMAL, /**< floating-point is sub-normal (181) */
  FLOATINGPOINT_IS_ZERO, /**< floating-point is zero (182) */
  FLOATINGPOINT_IS_INF, /**< floating-point is infinite (183) */
  FLOATINGPOINT_IS_NAN, /**< floating-point is NaN (184) */
  FLOATINGPOINT_IS_NEG, /**< floating-point is negative (185) */
  FLOATINGPOINT_IS_POS, /**< floating-point is positive (186) */
  FLOATINGPOINT_TO_FP_FROM_IEEE_BV_OP, /**< util/floatingpoint.h (187) */
  FLOATINGPOINT_TO_FP_FROM_IEEE_BV, /**< convert an IEEE-754 bit vector to floating-point (188) */
  FLOATINGPOINT_TO_FP_FROM_FP_OP, /**< util/floatingpoint.h (189) */
  FLOATINGPOINT_TO_FP_FROM_FP, /**< convert between floating-point sorts (190) */
  FLOATINGPOINT_TO_FP_FROM_REAL_OP, /**< util/floatingpoint.h (191) */
  FLOATINGPOINT_TO_FP_FROM_REAL, /**< convert a real to floating-point (192) */
  FLOATINGPOINT_TO_FP_FROM_SBV_OP, /**< util/floatingpoint.h (193) */
  FLOATINGPOINT_TO_FP_FROM_SBV, /**< convert a signed bit vector to floating-point (194) */
  FLOATINGPOINT_TO_FP_FROM_UBV_OP, /**< util/floatingpoint.h (195) */
  FLOATINGPOINT_TO_FP_FROM_UBV, /**< convert an unsigned bit vector to floating-point (196) */
  FLOATINGPOINT_TO_UBV_OP, /**< util/floatingpoint.h (197) */
  FLOATINGPOINT_TO_UBV, /**< convert a floating-point value to an unsigned bit vector (198) */
  FLOATINGPOINT_TO_UBV_TOTAL_OP, /**< util/floatingpoint.h (199) */
  FLOATINGPOINT_TO_UBV_TOTAL, /**< convert a floating-point value to an unsigned bit vector (defined for all inputs) (200) */
  FLOATINGPOINT_TO_SBV_OP, /**< util/floatingpoint.h (201) */
  FLOATINGPOINT_TO_SBV, /**< convert a floating-point value to a signed bit vector (202) */
  FLOATINGPOINT_TO_SBV_TOTAL_OP, /**< util/floatingpoint.h (203) */
  FLOATINGPOINT_TO_SBV_TOTAL, /**< convert a floating-point value to a signed bit vector (defined for all inputs) (204) */
  FLOATINGPOINT_TO_REAL, /**< floating-point to real (205) */
  FLOATINGPOINT_TO_REAL_TOTAL, /**< floating-point to real (defined for all inputs) (206) */
  FLOATINGPOINT_COMPONENT_NAN, /**< NaN component of a word-blasted floating-point number (207) */
  FLOATINGPOINT_COMPONENT_INF, /**< Inf component of a word-blasted floating-point number (208) */
  FLOATINGPOINT_COMPONENT_ZERO, /**< Zero component of a word-blasted floating-point number (209) */
  FLOATINGPOINT_COMPONENT_SIGN, /**< Sign component of a word-blasted floating-point number (210) */
  FLOATINGPOINT_COMPONENT_EXPONENT, /**< Exponent component of a word-blasted floating-point number (211) */
  FLOATINGPOINT_COMPONENT_SIGNIFICAND, /**< Significand component of a word-blasted floating-point number (212) */
  ROUNDINGMODE_BITBLAST, /**< The bit-vector for a non-deterministic rounding mode (213) */

  /* from arrays */
  ARRAY_TYPE, /**< array type (214) */
  SELECT, /**< array select; first parameter is an array term, second is the selection index (215) */
  STORE, /**< array store; first parameter is an array term, second is the store index, third is the term to store at the index (216) */
  EQ_RANGE, /**< equality of two arrays over an index range lower/upper (217) */
  STORE_ALL, /**< expr/array_store_all.h (218) */
  ARRAY_LAMBDA, /**< array lambda (internal-only symbol) (219) */

  /* from datatypes */
  CONSTRUCTOR_TYPE, /**< constructor (220) */
  SELECTOR_TYPE, /**< selector (221) */
  TESTER_TYPE, /**< tester (222) */
  UPDATER_TYPE, /**< datatype update (223) */
  APPLY_CONSTRUCTOR, /**< constructor application; first parameter is the constructor, remaining parameters (if any) are parameters to the constructor (224) */
  APPLY_SELECTOR, /**< selector application; parameter is a datatype term (undefined if mis-applied) (225) */
  APPLY_TESTER, /**< tester application; first parameter is a tester, second is a datatype term (226) */
  APPLY_UPDATER, /**< datatype updater application; first parameter is an update, second is a datatype term to update, third is the value to update with (227) */
  DATATYPE_TYPE, /**<  (228) */
  PARAMETRIC_DATATYPE, /**< parametric datatype (229) */
  TUPLE_TYPE, /**< tuple type (230) */
  APPLY_TYPE_ASCRIPTION, /**< type ascription, for datatype constructor applications; first parameter is an ASCRIPTION_TYPE, second is the datatype constructor application being ascribed (231) */
  ASCRIPTION_TYPE, /**< expr/ascription_type.h (232) */
  DT_SIZE, /**< datatypes size (233) */
  DT_HEIGHT_BOUND, /**< datatypes height bound (234) */
  DT_SIZE_BOUND, /**< datatypes height bound (235) */
  DT_SYGUS_BOUND, /**< datatypes sygus bound (236) */
  DT_SYGUS_EVAL, /**< datatypes sygus evaluation function (237) */
  MATCH, /**< match construct (238) */
  MATCH_CASE, /**< a match case (239) */
  MATCH_BIND_CASE, /**< a match case with bound variables (240) */
  TUPLE_PROJECT_OP, /**< theory/datatypes/project_op.h (241) */
  TUPLE_PROJECT, /**< projects a tuple from an existing tuple using indices passed in TupleProjectOp (242) */
  CODATATYPE_BOUND_VARIABLE, /**< expr/codatatype_bound_variable.h (243) */
  NULLABLE_TYPE, /**< nullable type (244) */
  NULLABLE_LIFT, /**< application of lift operator; first parameter is the lift operator, remaining ones are its arguments (245) */

  /* from sep */
  SEP_NIL, /**< separation nil (246) */
  SEP_EMP, /**< separation logic empty heap constraint (247) */
  SEP_PTO, /**< points to relation (248) */
  SEP_STAR, /**< separation star (249) */
  SEP_WAND, /**< separation magic wand (250) */
  SEP_LABEL, /**< separation label (internal use only) (251) */

  /* from sets */
  SET_EMPTY, /**< expr/emptyset.h (252) */
  SET_TYPE, /**< set type, takes as parameter the type of the elements (253) */
  SET_UNION, /**< set union (254) */
  SET_INTER, /**< set intersection (255) */
  SET_MINUS, /**< set subtraction (256) */
  SET_SUBSET, /**< subset predicate; first parameter a subset of second (257) */
  SET_MEMBER, /**< set membership predicate; first parameter a member of second (258) */
  SET_SINGLETON, /**< constructs a set of a single element. First parameter is a term (259) */
  SET_INSERT, /**< set obtained by inserting elements (first N-1 parameters) into a set (the last parameter) (260) */
  SET_CARD, /**< set cardinality operator (261) */
  SET_COMPLEMENT, /**< set complement (with respect to finite universe) (262) */
  SET_UNIVERSE, /**< (finite) universe set, all set variables must be interpreted as subsets of it. (263) */
  SET_COMPREHENSION, /**< set comprehension specified by a bound variable list, a predicate, and a term. (264) */
  SET_CHOOSE, /**< return an element in the set given as a parameter (265) */
  SET_IS_EMPTY, /**< return whether the given set is empty (266) */
  SET_IS_SINGLETON, /**< return whether the given set is a singleton (267) */
  SET_MAP, /**< set map function (268) */
  SET_FILTER, /**< set filter operator (269) */
  SET_ALL, /**< set all operator (270) */
  SET_SOME, /**< set some operator (271) */
  SET_FOLD, /**< set fold operator (272) */
  RELATION_GROUP_OP, /**< theory/datatypes/project_op.h (273) */
  RELATION_GROUP, /**< relation group (274) */
  RELATION_AGGREGATE_OP, /**< theory/datatypes/project_op.h (275) */
  RELATION_AGGREGATE, /**< relation aggregate (276) */
  RELATION_PROJECT_OP, /**< theory/datatypes/project_op.h (277) */
  RELATION_PROJECT, /**< relation projection (278) */
  RELATION_JOIN, /**< relation join (279) */
  RELATION_PRODUCT, /**< relation cartesian product (280) */
  RELATION_TRANSPOSE, /**< relation transpose (281) */
  RELATION_TCLOSURE, /**< relation transitive closure (282) */
  RELATION_JOIN_IMAGE, /**< relation join image (283) */
  RELATION_IDEN, /**< relation identity (284) */
  RELATION_TABLE_JOIN_OP, /**< theory/datatypes/project_op.h (285) */
  RELATION_TABLE_JOIN, /**< relation table join (286) */
  SET_EMPTY_OF_TYPE, /**< the empty set whose argument represents its type (287) */

  /* from bags */
  BAG_EMPTY, /**< expr/emptybag.h (288) */
  BAG_TYPE, /**< bag type, takes as parameter the type of the elements (289) */
  BAG_UNION_MAX, /**< union for bags (max) (290) */
  BAG_UNION_DISJOINT, /**< disjoint union for bags (sum) (291) */
  BAG_INTER_MIN, /**< bag intersection (min) (292) */
  BAG_DIFFERENCE_SUBTRACT, /**< bag difference1 (subtracts multiplicities) (293) */
  BAG_DIFFERENCE_REMOVE, /**< bag difference remove (removes shared elements) (294) */
  BAG_SUBBAG, /**< inclusion predicate for bags (less than or equal multiplicities) (295) */
  BAG_COUNT, /**< multiplicity of an element in a bag (296) */
  BAG_MEMBER, /**< bag membership predicate; is first parameter a member of second? (297) */
  BAG_SETOF, /**< eliminate duplicates in a bag (also known as the delta operator,or the squash operator) (298) */
  BAG_MAKE, /**< constructs a bag from one element along with its multiplicity (299) */
  BAG_CARD, /**< bag cardinality operator (300) */
  BAG_CHOOSE, /**< return an element in the bag given as a parameter (301) */
  BAG_MAP, /**< bag map function (302) */
  BAG_FILTER, /**< bag filter operator (303) */
  BAG_FOLD, /**< bag fold operator (304) */
  BAG_PARTITION, /**< bag partition operator (305) */
  TABLE_PRODUCT, /**< table cross product (306) */
  TABLE_PROJECT_OP, /**< theory/datatypes/project_op.h (307) */
  TABLE_PROJECT, /**< table projection (308) */
  TABLE_AGGREGATE_OP, /**< theory/datatypes/project_op.h (309) */
  TABLE_AGGREGATE, /**< table aggregate (310) */
  TABLE_JOIN_OP, /**< theory/datatypes/project_op.h (311) */
  TABLE_JOIN, /**< table join (312) */
  TABLE_GROUP_OP, /**< theory/datatypes/project_op.h (313) */
  TABLE_GROUP, /**< table group (314) */

  /* from strings */
  STRING_CONCAT, /**< string concat (N-ary) (315) */
  STRING_IN_REGEXP, /**< membership (316) */
  STRING_LENGTH, /**< string length (317) */
  STRING_SUBSTR, /**< string substr (318) */
  STRING_UPDATE, /**< string update (319) */
  STRING_CHARAT, /**< string charat (320) */
  STRING_CONTAINS, /**< string contains (321) */
  STRING_LT, /**< string less than (322) */
  STRING_LEQ, /**< string less than or equal (323) */
  STRING_INDEXOF, /**< string index of substring (324) */
  STRING_INDEXOF_RE, /**< string index of regular expression match (325) */
  STRING_REPLACE, /**< string replace (326) */
  STRING_REPLACE_ALL, /**< string replace all (327) */
  STRING_REPLACE_RE, /**< string replace regular expression match (328) */
  STRING_REPLACE_RE_ALL, /**< string replace all regular expression matches (329) */
  STRING_PREFIX, /**< string prefixof (330) */
  STRING_SUFFIX, /**< string suffixof (331) */
  STRING_IS_DIGIT, /**< string isdigit, returns true if argument is a string of length one that represents a digit (332) */
  STRING_ITOS, /**< integer to string (333) */
  STRING_STOI, /**< string to integer (total function) (334) */
  STRING_TO_CODE, /**< string to code, returns the code of the first character of the string if it has length one, -1 otherwise (335) */
  STRING_FROM_CODE, /**< string from code, returns a string containing a single character whose code point matches the argument to this function, empty string if the argument is not a valid code point (336) */
  STRING_UNIT, /**< string unit, returns a string containing a single character whose code point matches the argument to this function, arbitrary string of length one if the argument is not a valid code point (337) */
  STRING_TO_LOWER, /**< string to lowercase conversion (338) */
  STRING_TO_UPPER, /**< string to uppercase conversion (339) */
  STRING_REV, /**< string reverse (340) */
  CONST_STRING, /**< util/string.h (341) */
  SEQUENCE_TYPE, /**< sequence type, takes as parameter the type of the elements (342) */
  CONST_SEQUENCE, /**< expr/sequence.h (343) */
  SEQ_UNIT, /**< a sequence of length one. First parameter is a term (344) */
  SEQ_NTH, /**< The nth element of a sequence (345) */
  STRING_TO_REGEXP, /**< convert string to regexp (346) */
  REGEXP_CONCAT, /**< regexp concat (347) */
  REGEXP_UNION, /**< regexp union (348) */
  REGEXP_INTER, /**< regexp intersection (349) */
  REGEXP_DIFF, /**< regexp difference (350) */
  REGEXP_STAR, /**< regexp * (351) */
  REGEXP_PLUS, /**< regexp + (352) */
  REGEXP_OPT, /**< regexp ? (353) */
  REGEXP_RANGE, /**< regexp range (354) */
  REGEXP_COMPLEMENT, /**< regexp complement (355) */
  REGEXP_NONE, /**< regexp empty (356) */
  REGEXP_ALL, /**< regexp all (357) */
  REGEXP_ALLCHAR, /**< regexp all characters (358) */
  REGEXP_REPEAT_OP, /**< util/regexp.h (359) */
  REGEXP_REPEAT, /**< regular expression repeat; first parameter is a REGEXP_REPEAT_OP, second is a regular expression term (360) */
  REGEXP_LOOP_OP, /**< util/regexp.h (361) */
  REGEXP_LOOP, /**< regular expression loop; first parameter is a REGEXP_LOOP_OP, second is a regular expression term (362) */
  REGEXP_RV, /**< regexp rv (internal use only) (363) */
  SEQ_EMPTY_OF_TYPE, /**< the empty sequence whose argument represents its type (364) */

  /* from quantifiers */
  FORALL, /**< universally quantified formula; first parameter is an BOUND_VAR_LIST, second is quantifier body, and an optional third parameter is an INST_PATTERN_LIST (365) */
  EXISTS, /**< existentially quantified formula; first parameter is an BOUND_VAR_LIST, second is quantifier body, and an optional third parameter is an INST_PATTERN_LIST (366) */
  INST_CONSTANT, /**< instantiation constant (367) */
  ORACLE, /**< oracle (368) */
  BOUND_VAR_LIST, /**< a list of bound variables (used to bind variables under a quantifier) (369) */
  INST_PATTERN, /**< instantiation pattern (370) */
  INST_NO_PATTERN, /**< instantiation no-pattern (371) */
  INST_ATTRIBUTE, /**< instantiation attribute (372) */
  INST_POOL, /**< instantiation pool (373) */
  INST_ADD_TO_POOL, /**< instantiation add to pool (374) */
  SKOLEM_ADD_TO_POOL, /**< skolemization add to pool (375) */
  ORACLE_FORMULA_GEN, /**< oracle interface (376) */
  INST_PATTERN_LIST, /**< a list of instantiation patterns (377) */
 LAST_KIND /**< marks the upper-bound of this enumeration */
  // clang-format on

}; /* enum Kind_t */

}  // namespace kind

// import Kind into the "cvc5" namespace but keep the individual kind
// constants under kind::
typedef cvc5::internal::kind::Kind_t Kind;

namespace kind {

/**
 * Converts an kind to a string. Note: This function is also used in
 * `safe_print()`. Changing this functions name or signature will result in
 * `safe_print()` printing "<unsupported>" instead of the proper strings for
 * the enum values.
 *
 * @param k The kind
 * @return The name of the kind
 */
const char* toString(cvc5::internal::Kind k);

/**
 * Writes a kind name to a stream.
 *
 * @param out The stream to write to
 * @param k The kind to write to the stream
 * @return The stream
 */
std::ostream& operator<<(std::ostream&, cvc5::internal::Kind);

/** Returns true if the given kind is associative. This is used by ExprManager to
 * decide whether it's safe to modify big expressions by changing the grouping of
 * the arguments. */
/* TODO: This could be generated. */
bool isAssociative(cvc5::internal::Kind k);
std::string kindToString(cvc5::internal::Kind k);

/** Return true if k is a closure kind. */
bool isClosureKind(cvc5::internal::Kind k);

struct KindHashFunction
{
  inline size_t operator()(cvc5::internal::Kind k) const
  {
    return static_cast<size_t>(k);
  }
}; /* struct KindHashFunction */

}  // namespace kind

/**
 * The enumeration for the built-in atomic types.
 */
enum TypeConstant
{
  // clang-format off
    BUILTIN_OPERATOR_TYPE, /**< the type for built-in operators */
  SEXPR_TYPE, /**< the type of a symbolic expression */
  BOOLEAN_TYPE, /**< Boolean type */
  REAL_TYPE, /**< real type */
  INTEGER_TYPE, /**< integer type */
  ROUNDINGMODE_TYPE, /**< floating-point rounding mode */
  STRING_TYPE, /**< String type */
  REGEXP_TYPE, /**< RegExp type */
  BOUND_VAR_LIST_TYPE, /**< the type of bound variable lists */
  INST_PATTERN_TYPE, /**< instantiation pattern type */
  INST_PATTERN_LIST_TYPE, /**< the type of instantiation pattern lists */
 LAST_TYPE
  // clang-format on
}; /* enum TypeConstant */

/**
 * We hash the constants with their values.
 */
struct TypeConstantHashFunction
{
  inline size_t operator()(TypeConstant tc) const { return tc; }
}; /* struct TypeConstantHashFunction */

const char* toString(TypeConstant tc);
std::ostream& operator<<(std::ostream& out, TypeConstant typeConstant);

namespace theory {

cvc5::internal::theory::TheoryId kindToTheoryId(cvc5::internal::Kind k);
cvc5::internal::theory::TheoryId typeConstantToTheoryId(
    cvc5::internal::TypeConstant typeConstant);

}  // namespace theory
}  // namespace cvc5::internal

#endif /* CVC5__KIND_H */
