/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_arith_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node t1 = NodeManager::mkBoundVar("t1", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(t1);
Node s2 = NodeManager::mkBoundVar("s2", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(s2);
Node t3 = NodeManager::mkBoundVar("t3", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(t3);
Node s4 = NodeManager::mkBoundVar("s4", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(s4);
Node t5 = NodeManager::mkBoundVar("t5", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s6 = NodeManager::mkBoundVar("s6", nm->realType());
Node t7 = NodeManager::mkBoundVar("t7", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s8 = NodeManager::mkBoundVar("s8", nm->integerType());
Node t9 = NodeManager::mkBoundVar("t9", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t10 = NodeManager::mkBoundVar("t10", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t11 = NodeManager::mkBoundVar("t11", nm->integerType());
Node s12 = NodeManager::mkBoundVar("s12", nm->integerType());
Node t13 = NodeManager::mkBoundVar("t13", nm->integerType());
Node t14 = NodeManager::mkBoundVar("t14", nm->integerType());
Node t15 = NodeManager::mkBoundVar("t15", nm->integerType());
Node s16 = NodeManager::mkBoundVar("s16", nm->integerType());
Node t17 = NodeManager::mkBoundVar("t17", nm->integerType());
Node t18 = NodeManager::mkBoundVar("t18", nm->integerType());
Node t19 = NodeManager::mkBoundVar("t19", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s20 = NodeManager::mkBoundVar("s20", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t21 = NodeManager::mkBoundVar("t21", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s22 = NodeManager::mkBoundVar("s22", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t23 = NodeManager::mkBoundVar("t23", nm->integerType());
Node s24 = NodeManager::mkBoundVar("s24", nm->integerType());
Node t25 = NodeManager::mkBoundVar("t25", nm->integerType());
Node s26 = NodeManager::mkBoundVar("s26", nm->integerType());
Node t27 = NodeManager::mkBoundVar("t27", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s28 = NodeManager::mkBoundVar("s28", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t29 = NodeManager::mkBoundVar("t29", nm->integerType());
Node s30 = NodeManager::mkBoundVar("s30", nm->integerType());
Node t31 = NodeManager::mkBoundVar("t31", nm->integerType());
Node s32 = NodeManager::mkBoundVar("s32", nm->integerType());
Node t33 = NodeManager::mkBoundVar("t33", nm->integerType());
Node s34 = NodeManager::mkBoundVar("s34", nm->integerType());
Node t35 = NodeManager::mkBoundVar("t35", nm->realType());
Node s36 = NodeManager::mkBoundVar("s36", nm->realType());
Node t37 = NodeManager::mkBoundVar("t37", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s38 = NodeManager::mkBoundVar("s38", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t39 = NodeManager::mkBoundVar("t39", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t40 = NodeManager::mkBoundVar("t40", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t41 = NodeManager::mkBoundVar("t41", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t42 = NodeManager::mkBoundVar("t42", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t43 = NodeManager::mkBoundVar("t43", nm->realType());
Node s44 = NodeManager::mkBoundVar("s44", nm->realType());
Node t45 = NodeManager::mkBoundVar("t45", nm->integerType());
Node s46 = NodeManager::mkBoundVar("s46", nm->integerType());
Node xs47 = NodeManager::mkBoundVar("xs47", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(xs47);
Node w48 = NodeManager::mkBoundVar("w48", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node ys49 = NodeManager::mkBoundVar("ys49", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(ys49);
Node zs50 = NodeManager::mkBoundVar("zs50", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(zs50);
Node t78 = NodeManager::mkBoundVar("t78", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs51 = NodeManager::mkBoundVar("xs51", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(xs51);
Node w52 = NodeManager::mkBoundVar("w52", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node ys53 = NodeManager::mkBoundVar("ys53", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(ys53);
Node zs54 = NodeManager::mkBoundVar("zs54", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(zs54);
Node t79 = NodeManager::mkBoundVar("t79", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x55 = NodeManager::mkBoundVar("x55", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y56 = NodeManager::mkBoundVar("y56", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z57 = NodeManager::mkBoundVar("z57", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node w58 = NodeManager::mkBoundVar("w58", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(w58);
Node t80 = NodeManager::mkBoundVar("t80", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x59 = NodeManager::mkBoundVar("x59", nm->integerType());
Node x60 = NodeManager::mkBoundVar("x60", nm->realType());
Node x61 = NodeManager::mkBoundVar("x61", nm->realType());
Node x62 = NodeManager::mkBoundVar("x62", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x63 = NodeManager::mkBoundVar("x63", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y64 = NodeManager::mkBoundVar("y64", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x65 = NodeManager::mkBoundVar("x65", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y66 = NodeManager::mkBoundVar("y66", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x67 = NodeManager::mkBoundVar("x67", nm->realType());
Node x68 = NodeManager::mkBoundVar("x68", nm->realType());
Node x69 = NodeManager::mkBoundVar("x69", nm->realType());
Node x70 = NodeManager::mkBoundVar("x70", nm->realType());
Node x71 = NodeManager::mkBoundVar("x71", nm->realType());
Node x72 = NodeManager::mkBoundVar("x72", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y73 = NodeManager::mkBoundVar("y73", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x74 = NodeManager::mkBoundVar("x74", nm->integerType());
Node y75 = NodeManager::mkBoundVar("y75", nm->integerType());
Node x76 = NodeManager::mkBoundVar("x76", nm->realType());
Node y77 = NodeManager::mkBoundVar("y77", nm->realType());

  // Definitions
Node e81 = nm->mkNode(Kind::NEG, { x76 });
Node e82 = nm->mkNode(Kind::NEG, { y77 });
Node e83 = nm->mkNode(Kind::GEQ, { y77,nm->mkConstReal(internal::Rational("0/1")) });
Node e84 = nm->mkConstReal(internal::Rational("0/1"));
Node e85 = nm->mkNode(Kind::NEG, { x74 });
Node e86 = nm->mkNode(Kind::NEG, { y75 });
Node e87 = nm->mkNode(Kind::GEQ, { y75,nm->mkConstInt(Rational(0)) });
Node e88 = nm->mkConstInt(Rational(0));
Node e89 = nm->mkConst(true);
Node e90 = nm->mkConstReal(internal::Rational("1/1"));
Node e91 = nm->mkNullaryOperator(nm->realType(), Kind::PI);
Node e92 = nm->mkNode(Kind::MULT, { nm->mkConstReal(internal::Rational("1/2")),nm->mkNullaryOperator(nm->realType(), Kind::PI) });
Node e93 = nm->mkConst(false);
Node e94 = nm->mkConstInt(Rational(1));

  // Rules

        {
            // from rewrites-arith-rewrites.cpp
            db.addRule(ProofRewriteRule::ARITH_MUL_ONE, { t1, s2 }, nm->mkNode(Kind::MULT, { t1,e94,s2 }), nm->mkNode(Kind::MULT, { t1,s2 }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_MUL_ZERO, { t3, s4 }, nm->mkNode(Kind::MULT, { t3,e88,s4 }), e88, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_DIV_TOTAL_REAL, { t5, s6 }, nm->mkNode(Kind::DIVISION, { t5,s6 }), nm->mkNode(Kind::DIVISION_TOTAL, { t5,s6 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s6,e84 }) }), Node::null());
db.addRule(ProofRewriteRule::ARITH_DIV_TOTAL_INT, { t7, s8 }, nm->mkNode(Kind::DIVISION, { t7,s8 }), nm->mkNode(Kind::DIVISION_TOTAL, { t7,s8 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s8,e88 }) }), Node::null());
db.addRule(ProofRewriteRule::ARITH_DIV_TOTAL_ZERO_REAL, { t9 }, nm->mkNode(Kind::DIVISION_TOTAL, { t9,e84 }), e84, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_DIV_TOTAL_ZERO_INT, { t10 }, nm->mkNode(Kind::DIVISION_TOTAL, { t10,e88 }), e84, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_DIV_TOTAL, { t11, s12 }, nm->mkNode(Kind::INTS_DIVISION, { t11,s12 }), nm->mkNode(Kind::INTS_DIVISION_TOTAL, { t11,s12 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s12,e88 }) }), Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_DIV_TOTAL_ONE, { t13 }, nm->mkNode(Kind::INTS_DIVISION_TOTAL, { t13,e94 }), t13, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_DIV_TOTAL_ZERO, { t14 }, nm->mkNode(Kind::INTS_DIVISION_TOTAL, { t14,e88 }), e88, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_MOD_TOTAL, { t15, s16 }, nm->mkNode(Kind::INTS_MODULUS, { t15,s16 }), nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t15,s16 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s16,e88 }) }), Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_MOD_TOTAL_ONE, { t17 }, nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t17,e94 }), e88, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_MOD_TOTAL_ZERO, { t18 }, nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t18,e88 }), t18, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_ELIM_GT, { t19, s20 }, nm->mkNode(Kind::GT, { t19,s20 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::LEQ, { t19,s20 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_ELIM_LT, { t21, s22 }, nm->mkNode(Kind::LT, { t21,s22 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::GEQ, { t21,s22 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_ELIM_INT_GT, { t23, s24 }, nm->mkNode(Kind::GT, { t23,s24 }), nm->mkNode(Kind::GEQ, { t23,nm->mkNode(Kind::ADD, { s24,e94 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_ELIM_INT_LT, { t25, s26 }, nm->mkNode(Kind::LT, { t25,s26 }), nm->mkNode(Kind::GEQ, { s26,nm->mkNode(Kind::ADD, { t25,e94 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_ELIM_LEQ, { t27, s28 }, nm->mkNode(Kind::LEQ, { t27,s28 }), nm->mkNode(Kind::GEQ, { s28,t27 }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_LEQ_NORM, { t29, s30 }, nm->mkNode(Kind::LEQ, { t29,s30 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::GEQ, { t29,nm->mkNode(Kind::ADD, { s30,e94 }) }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_GEQ_TIGHTEN, { t31, s32 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::GEQ, { t31,s32 }) }), nm->mkNode(Kind::GEQ, { s32,nm->mkNode(Kind::ADD, { t31,e94 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_GEQ_NORM1_INT, { t33, s34 }, nm->mkNode(Kind::GEQ, { t33,s34 }), nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::SUB, { t33,s34 }),e88 }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_GEQ_NORM1_REAL, { t35, s36 }, nm->mkNode(Kind::GEQ, { t35,s36 }), nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::SUB, { t35,s36 }),e84 }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_GEQ_NORM2, { t37, s38 }, nm->mkNode(Kind::GEQ, { t37,s38 }), nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::NEG, { t37 }),nm->mkNode(Kind::NEG, { s38 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_REFL_LEQ, { t39 }, nm->mkNode(Kind::LEQ, { t39,t39 }), e89, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_REFL_LT, { t40 }, nm->mkNode(Kind::LT, { t40,t40 }), e93, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_REFL_GEQ, { t41 }, nm->mkNode(Kind::GEQ, { t41,t41 }), e89, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_REFL_GT, { t42 }, nm->mkNode(Kind::GT, { t42,t42 }), e93, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_EQ_ELIM_REAL, { t43, s44 }, nm->mkNode(Kind::EQUAL, { t43,s44 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { t43,s44 }),nm->mkNode(Kind::LEQ, { t43,s44 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_EQ_ELIM_INT, { t45, s46 }, nm->mkNode(Kind::EQUAL, { t45,s46 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { t45,s46 }),nm->mkNode(Kind::LEQ, { t45,s46 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_PLUS_FLATTEN, { xs47, w48, ys49, zs50 }, nm->mkNode(Kind::ADD, { xs47,nm->mkNode(Kind::ADD, { w48,ys49 }),zs50 }), nm->mkNode(Kind::ADD, { xs47,w48,ys49,zs50 }), e89, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t78 }),t78 }));
db.addRule(ProofRewriteRule::ARITH_MULT_FLATTEN, { xs51, w52, ys53, zs54 }, nm->mkNode(Kind::MULT, { xs51,nm->mkNode(Kind::MULT, { w52,ys53 }),zs54 }), nm->mkNode(Kind::MULT, { xs51,w52,ys53,zs54 }), e89, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t79 }),t79 }));
db.addRule(ProofRewriteRule::ARITH_MULT_DIST, { x55, y56, z57, w58 }, nm->mkNode(Kind::MULT, { x55,nm->mkNode(Kind::ADD, { y56,z57,w58 }) }), nm->mkNode(Kind::ADD, { nm->mkNode(Kind::MULT, { x55,y56 }),nm->mkNode(Kind::MULT, { x55,nm->mkNode(Kind::ADD, { z57,w58 }) }) }), e89, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t80 }),t80 }));
db.addRule(ProofRewriteRule::ARITH_ABS_ELIM_INT, { x59 }, nm->mkNode(Kind::ABS, { x59 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::LT, { x59,e88 }),nm->mkNode(Kind::NEG, { x59 }),x59 }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_ABS_ELIM_REAL, { x60 }, nm->mkNode(Kind::ABS, { x60 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::LT, { x60,e84 }),nm->mkNode(Kind::NEG, { x60 }),x60 }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_TO_REAL_ELIM, { x61 }, nm->mkNode(Kind::TO_REAL, { x61 }), x61, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_TO_INT_ELIM_TO_REAL, { x62 }, nm->mkNode(Kind::TO_INTEGER, { nm->mkNode(Kind::TO_REAL, { x62 }) }), nm->mkNode(Kind::TO_INTEGER, { x62 }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_DIV_ELIM_TO_REAL1, { x63, y64 }, nm->mkNode(Kind::DIVISION, { nm->mkNode(Kind::TO_REAL, { x63 }),y64 }), nm->mkNode(Kind::DIVISION, { x63,y64 }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_DIV_ELIM_TO_REAL2, { x65, y66 }, nm->mkNode(Kind::DIVISION, { x65,nm->mkNode(Kind::TO_REAL, { y66 }) }), nm->mkNode(Kind::DIVISION, { x65,y66 }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_SINE_ZERO, {  }, nm->mkNode(Kind::SINE, { e84 }), e84, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_SINE_PI2, {  }, nm->mkNode(Kind::SINE, { e92 }), e90, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_COSINE_ELIM, { x67 }, nm->mkNode(Kind::COSINE, { x67 }), nm->mkNode(Kind::SINE, { nm->mkNode(Kind::SUB, { e92,x67 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_TANGENT_ELIM, { x68 }, nm->mkNode(Kind::TANGENT, { x68 }), nm->mkNode(Kind::DIVISION, { nm->mkNode(Kind::SINE, { x68 }),nm->mkNode(Kind::COSINE, { x68 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_SECENT_ELIM, { x69 }, nm->mkNode(Kind::SECANT, { x69 }), nm->mkNode(Kind::DIVISION, { e90,nm->mkNode(Kind::SINE, { x69 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_COSECENT_ELIM, { x70 }, nm->mkNode(Kind::COSECANT, { x70 }), nm->mkNode(Kind::DIVISION, { e90,nm->mkNode(Kind::COSINE, { x70 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_COTANGENT_ELIM, { x71 }, nm->mkNode(Kind::COTANGENT, { x71 }), nm->mkNode(Kind::DIVISION, { nm->mkNode(Kind::COSINE, { x71 }),nm->mkNode(Kind::SINE, { x71 }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_PI_NOT_INT, {  }, nm->mkNode(Kind::IS_INTEGER, { e91 }), e93, e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_ABS_EQ, { x72, y73 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::ABS, { x72 }),nm->mkNode(Kind::ABS, { y73 }) }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::EQUAL, { x72,y73 }),nm->mkNode(Kind::EQUAL, { x72,nm->mkNode(Kind::NEG, { y73 }) }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_ABS_INT_GT, { x74, y75 }, nm->mkNode(Kind::GT, { nm->mkNode(Kind::ABS, { x74 }),nm->mkNode(Kind::ABS, { y75 }) }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::GEQ, { x74,e88 }),nm->mkNode(Kind::ITE, { e87,nm->mkNode(Kind::GT, { x74,y75 }),nm->mkNode(Kind::GT, { x74,e86 }) }),nm->mkNode(Kind::ITE, { e87,nm->mkNode(Kind::GT, { e85,y75 }),nm->mkNode(Kind::GT, { e85,e86 }) }) }), e89, Node::null());
db.addRule(ProofRewriteRule::ARITH_ABS_REAL_GT, { x76, y77 }, nm->mkNode(Kind::GT, { nm->mkNode(Kind::ABS, { x76 }),nm->mkNode(Kind::ABS, { y77 }) }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::GEQ, { x76,e84 }),nm->mkNode(Kind::ITE, { e83,nm->mkNode(Kind::GT, { x76,y77 }),nm->mkNode(Kind::GT, { x76,e82 }) }),nm->mkNode(Kind::ITE, { e83,nm->mkNode(Kind::GT, { e81,y77 }),nm->mkNode(Kind::GT, { e81,e82 }) }) }), e89, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
