/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_arrays_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node t95 = NodeManager::mkBoundVar("t95", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i96 = NodeManager::mkBoundVar("i96", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e97 = NodeManager::mkBoundVar("e97", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t98 = NodeManager::mkBoundVar("t98", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i99 = NodeManager::mkBoundVar("i99", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node j100 = NodeManager::mkBoundVar("j100", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e101 = NodeManager::mkBoundVar("e101", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t102 = NodeManager::mkBoundVar("t102", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i103 = NodeManager::mkBoundVar("i103", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e104 = NodeManager::mkBoundVar("e104", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node f105 = NodeManager::mkBoundVar("f105", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t106 = NodeManager::mkBoundVar("t106", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i107 = NodeManager::mkBoundVar("i107", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t108 = NodeManager::mkBoundVar("t108", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i109 = NodeManager::mkBoundVar("i109", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e110 = NodeManager::mkBoundVar("e110", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node j111 = NodeManager::mkBoundVar("j111", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t117 = NodeManager::mkBoundVar("t117", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t112 = NodeManager::mkBoundVar("t112", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i113 = NodeManager::mkBoundVar("i113", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node j114 = NodeManager::mkBoundVar("j114", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e115 = NodeManager::mkBoundVar("e115", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node f116 = NodeManager::mkBoundVar("f116", nm->mkAbstractType(Kind::ABSTRACT_TYPE));

  // Definitions
Node e118 = nm->mkConst(true);

  // Rules

        {
            // from rewrites-arrays-rewrites.cpp
            db.addRule(ProofRewriteRule::ARRAY_READ_OVER_WRITE, { t95, i96, e97 }, nm->mkNode(Kind::SELECT, { nm->mkNode(Kind::STORE, { t95,i96,e97 }),i96 }), e97, e118, Node::null());
db.addRule(ProofRewriteRule::ARRAY_READ_OVER_WRITE2, { t98, i99, j100, e101 }, nm->mkNode(Kind::SELECT, { nm->mkNode(Kind::STORE, { t98,i99,e101 }),j100 }), nm->mkNode(Kind::SELECT, { t98,j100 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { i99,j100 }) }), Node::null());
db.addRule(ProofRewriteRule::ARRAY_STORE_OVERWRITE, { t102, i103, e104, f105 }, nm->mkNode(Kind::STORE, { nm->mkNode(Kind::STORE, { t102,i103,e104 }),i103,f105 }), nm->mkNode(Kind::STORE, { t102,i103,f105 }), e118, Node::null());
db.addRule(ProofRewriteRule::ARRAY_STORE_SELF, { t106, i107 }, nm->mkNode(Kind::STORE, { t106,i107,nm->mkNode(Kind::SELECT, { t106,i107 }) }), t106, e118, Node::null());
db.addRule(ProofRewriteRule::ARRAY_READ_OVER_WRITE_SPLIT, { t108, i109, e110, j111 }, nm->mkNode(Kind::SELECT, { nm->mkNode(Kind::STORE, { t108,j111,e110 }),i109 }), nm->mkNode(Kind::SELECT, { t108,i109 }), e118, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t117 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { i109,j111 }),e110,t117 }) }));
db.addRule(ProofRewriteRule::ARRAY_STORE_SWAP, { t112, i113, j114, e115, f116 }, nm->mkNode(Kind::STORE, { nm->mkNode(Kind::STORE, { t112,i113,e115 }),j114,f116 }), nm->mkNode(Kind::STORE, { nm->mkNode(Kind::STORE, { t112,j114,f116 }),i113,e115 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { i113,j114 }) }), Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
