/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_booleans_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node t119 = NodeManager::mkBoundVar("t119", nm->booleanType());
Node t120 = NodeManager::mkBoundVar("t120", nm->booleanType());
Node t121 = NodeManager::mkBoundVar("t121", nm->booleanType());
Node t122 = NodeManager::mkBoundVar("t122", nm->booleanType());
Node t123 = NodeManager::mkBoundVar("t123", nm->booleanType());
Node x124 = NodeManager::mkBoundVar("x124", nm->booleanType());
Node t125 = NodeManager::mkBoundVar("t125", nm->booleanType());
Node t126 = NodeManager::mkBoundVar("t126", nm->booleanType());
Node t127 = NodeManager::mkBoundVar("t127", nm->booleanType());
Node t128 = NodeManager::mkBoundVar("t128", nm->booleanType());
Node t129 = NodeManager::mkBoundVar("t129", nm->booleanType());
Node s130 = NodeManager::mkBoundVar("s130", nm->booleanType());
Node xs131 = NodeManager::mkBoundVar("xs131", nm->booleanType());expr::markListVar(xs131);
Node ys132 = NodeManager::mkBoundVar("ys132", nm->booleanType());expr::markListVar(ys132);
Node xs133 = NodeManager::mkBoundVar("xs133", nm->booleanType());expr::markListVar(xs133);
Node b134 = NodeManager::mkBoundVar("b134", nm->booleanType());
Node ys135 = NodeManager::mkBoundVar("ys135", nm->booleanType());expr::markListVar(ys135);
Node zs136 = NodeManager::mkBoundVar("zs136", nm->booleanType());expr::markListVar(zs136);
Node t210 = NodeManager::mkBoundVar("t210", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs137 = NodeManager::mkBoundVar("xs137", nm->booleanType());expr::markListVar(xs137);
Node ys138 = NodeManager::mkBoundVar("ys138", nm->booleanType());expr::markListVar(ys138);
Node xs139 = NodeManager::mkBoundVar("xs139", nm->booleanType());expr::markListVar(xs139);
Node b140 = NodeManager::mkBoundVar("b140", nm->booleanType());
Node ys141 = NodeManager::mkBoundVar("ys141", nm->booleanType());expr::markListVar(ys141);
Node zs142 = NodeManager::mkBoundVar("zs142", nm->booleanType());expr::markListVar(zs142);
Node t211 = NodeManager::mkBoundVar("t211", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs143 = NodeManager::mkBoundVar("xs143", nm->booleanType());expr::markListVar(xs143);
Node w144 = NodeManager::mkBoundVar("w144", nm->booleanType());
Node ys145 = NodeManager::mkBoundVar("ys145", nm->booleanType());expr::markListVar(ys145);
Node zs146 = NodeManager::mkBoundVar("zs146", nm->booleanType());expr::markListVar(zs146);
Node xs147 = NodeManager::mkBoundVar("xs147", nm->booleanType());expr::markListVar(xs147);
Node w148 = NodeManager::mkBoundVar("w148", nm->booleanType());
Node ys149 = NodeManager::mkBoundVar("ys149", nm->booleanType());expr::markListVar(ys149);
Node zs150 = NodeManager::mkBoundVar("zs150", nm->booleanType());expr::markListVar(zs150);
Node xs151 = NodeManager::mkBoundVar("xs151", nm->booleanType());expr::markListVar(xs151);
Node w152 = NodeManager::mkBoundVar("w152", nm->booleanType());
Node ys153 = NodeManager::mkBoundVar("ys153", nm->booleanType());expr::markListVar(ys153);
Node zs154 = NodeManager::mkBoundVar("zs154", nm->booleanType());expr::markListVar(zs154);
Node xs155 = NodeManager::mkBoundVar("xs155", nm->booleanType());expr::markListVar(xs155);
Node w156 = NodeManager::mkBoundVar("w156", nm->booleanType());
Node ys157 = NodeManager::mkBoundVar("ys157", nm->booleanType());expr::markListVar(ys157);
Node zs158 = NodeManager::mkBoundVar("zs158", nm->booleanType());expr::markListVar(zs158);
Node x159 = NodeManager::mkBoundVar("x159", nm->booleanType());
Node y160 = NodeManager::mkBoundVar("y160", nm->booleanType());
Node zs161 = NodeManager::mkBoundVar("zs161", nm->booleanType());expr::markListVar(zs161);
Node t212 = NodeManager::mkBoundVar("t212", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x162 = NodeManager::mkBoundVar("x162", nm->booleanType());
Node y163 = NodeManager::mkBoundVar("y163", nm->booleanType());
Node x164 = NodeManager::mkBoundVar("x164", nm->booleanType());
Node y165 = NodeManager::mkBoundVar("y165", nm->booleanType());
Node zs166 = NodeManager::mkBoundVar("zs166", nm->booleanType());expr::markListVar(zs166);
Node t213 = NodeManager::mkBoundVar("t213", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y1167 = NodeManager::mkBoundVar("y1167", nm->booleanType());
Node y2168 = NodeManager::mkBoundVar("y2168", nm->booleanType());
Node y3169 = NodeManager::mkBoundVar("y3169", nm->booleanType());expr::markListVar(y3169);
Node zs170 = NodeManager::mkBoundVar("zs170", nm->booleanType());expr::markListVar(zs170);
Node t214 = NodeManager::mkBoundVar("t214", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x171 = NodeManager::mkBoundVar("x171", nm->booleanType());
Node x172 = NodeManager::mkBoundVar("x172", nm->booleanType());
Node x173 = NodeManager::mkBoundVar("x173", nm->booleanType());
Node x174 = NodeManager::mkBoundVar("x174", nm->booleanType());
Node x175 = NodeManager::mkBoundVar("x175", nm->booleanType());
Node y176 = NodeManager::mkBoundVar("y176", nm->booleanType());
Node x177 = NodeManager::mkBoundVar("x177", nm->booleanType());
Node y178 = NodeManager::mkBoundVar("y178", nm->booleanType());
Node x179 = NodeManager::mkBoundVar("x179", nm->booleanType());
Node y180 = NodeManager::mkBoundVar("y180", nm->booleanType());
Node x181 = NodeManager::mkBoundVar("x181", nm->booleanType());
Node y182 = NodeManager::mkBoundVar("y182", nm->booleanType());
Node x183 = NodeManager::mkBoundVar("x183", nm->booleanType());
Node y184 = NodeManager::mkBoundVar("y184", nm->booleanType());
Node c185 = NodeManager::mkBoundVar("c185", nm->booleanType());
Node x186 = NodeManager::mkBoundVar("x186", nm->booleanType());
Node y187 = NodeManager::mkBoundVar("y187", nm->booleanType());
Node c188 = NodeManager::mkBoundVar("c188", nm->booleanType());
Node x189 = NodeManager::mkBoundVar("x189", nm->booleanType());
Node c190 = NodeManager::mkBoundVar("c190", nm->booleanType());
Node x191 = NodeManager::mkBoundVar("x191", nm->booleanType());
Node c192 = NodeManager::mkBoundVar("c192", nm->booleanType());
Node x193 = NodeManager::mkBoundVar("x193", nm->booleanType());
Node c194 = NodeManager::mkBoundVar("c194", nm->booleanType());
Node x195 = NodeManager::mkBoundVar("x195", nm->booleanType());
Node c196 = NodeManager::mkBoundVar("c196", nm->booleanType());
Node x197 = NodeManager::mkBoundVar("x197", nm->booleanType());
Node c198 = NodeManager::mkBoundVar("c198", nm->booleanType());
Node x199 = NodeManager::mkBoundVar("x199", nm->booleanType());
Node c200 = NodeManager::mkBoundVar("c200", nm->booleanType());
Node x201 = NodeManager::mkBoundVar("x201", nm->booleanType());
Node c202 = NodeManager::mkBoundVar("c202", nm->booleanType());
Node x203 = NodeManager::mkBoundVar("x203", nm->booleanType());
Node c204 = NodeManager::mkBoundVar("c204", nm->booleanType());
Node x205 = NodeManager::mkBoundVar("x205", nm->booleanType());
Node y206 = NodeManager::mkBoundVar("y206", nm->booleanType());
Node c207 = NodeManager::mkBoundVar("c207", nm->booleanType());
Node x208 = NodeManager::mkBoundVar("x208", nm->booleanType());
Node y209 = NodeManager::mkBoundVar("y209", nm->booleanType());

  // Definitions
Node e215 = nm->mkConst(true);
Node e216 = nm->mkConst(false);

  // Rules

        {
            // from rewrites-booleans-rewrites.cpp
            db.addRule(ProofRewriteRule::BOOL_DOUBLE_NOT_ELIM, { t119 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::NOT, { t119 }) }), t119, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_NOT_TRUE, { t120 }, nm->mkNode(Kind::NOT, { t120 }), e215, nm->mkNode(Kind::EQUAL, { t120,e216 }), Node::null());
db.addRule(ProofRewriteRule::BOOL_NOT_FALSE, { t121 }, nm->mkNode(Kind::NOT, { t121 }), e216, nm->mkNode(Kind::EQUAL, { t121,e215 }), Node::null());
db.addRule(ProofRewriteRule::BOOL_EQ_TRUE, { t122 }, nm->mkNode(Kind::EQUAL, { t122,e215 }), t122, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_EQ_FALSE, { t123 }, nm->mkNode(Kind::EQUAL, { t123,e216 }), nm->mkNode(Kind::NOT, { t123 }), e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_EQ_NREFL, { x124 }, nm->mkNode(Kind::EQUAL, { x124,nm->mkNode(Kind::NOT, { x124 }) }), e216, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_IMPL_FALSE1, { t125 }, nm->mkNode(Kind::IMPLIES, { t125,e216 }), nm->mkNode(Kind::NOT, { t125 }), e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_IMPL_FALSE2, { t126 }, nm->mkNode(Kind::IMPLIES, { e216,t126 }), e215, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_IMPL_TRUE1, { t127 }, nm->mkNode(Kind::IMPLIES, { t127,e215 }), e215, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_IMPL_TRUE2, { t128 }, nm->mkNode(Kind::IMPLIES, { e215,t128 }), t128, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_IMPL_ELIM, { t129, s130 }, nm->mkNode(Kind::IMPLIES, { t129,s130 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::NOT, { t129 }),s130 }), e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_OR_TRUE, { xs131, ys132 }, nm->mkNode(Kind::OR, { xs131,e215,ys132 }), e215, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_OR_FLATTEN, { xs133, b134, ys135, zs136 }, nm->mkNode(Kind::OR, { xs133,nm->mkNode(Kind::OR, { b134,ys135 }),zs136 }), nm->mkNode(Kind::OR, { xs133,b134,ys135,zs136 }), e215, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t210 }),t210 }));
db.addRule(ProofRewriteRule::BOOL_AND_FALSE, { xs137, ys138 }, nm->mkNode(Kind::AND, { xs137,e216,ys138 }), e216, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_AND_FLATTEN, { xs139, b140, ys141, zs142 }, nm->mkNode(Kind::AND, { xs139,nm->mkNode(Kind::AND, { b140,ys141 }),zs142 }), nm->mkNode(Kind::AND, { xs139,b140,ys141,zs142 }), e215, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t211 }),t211 }));
db.addRule(ProofRewriteRule::BOOL_AND_CONF, { xs143, w144, ys145, zs146 }, nm->mkNode(Kind::AND, { xs143,w144,ys145,nm->mkNode(Kind::NOT, { w144 }),zs146 }), e216, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_AND_CONF2, { xs147, w148, ys149, zs150 }, nm->mkNode(Kind::AND, { xs147,nm->mkNode(Kind::NOT, { w148 }),ys149,w148,zs150 }), e216, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_OR_TAUT, { xs151, w152, ys153, zs154 }, nm->mkNode(Kind::OR, { xs151,w152,ys153,nm->mkNode(Kind::NOT, { w152 }),zs154 }), e215, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_OR_TAUT2, { xs155, w156, ys157, zs158 }, nm->mkNode(Kind::OR, { xs155,nm->mkNode(Kind::NOT, { w156 }),ys157,w156,zs158 }), e215, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_OR_DE_MORGAN, { x159, y160, zs161 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::OR, { x159,y160,zs161 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::OR, { y160,zs161 }) }), e215, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t212 }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { x159 }),t212 }) }));
db.addRule(ProofRewriteRule::BOOL_IMPLIES_DE_MORGAN, { x162, y163 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::IMPLIES, { x162,y163 }) }), nm->mkNode(Kind::AND, { x162,nm->mkNode(Kind::NOT, { y163 }) }), e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_AND_DE_MORGAN, { x164, y165, zs166 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::AND, { x164,y165,zs166 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::AND, { y165,zs166 }) }), e215, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t213 }),nm->mkNode(Kind::OR, { nm->mkNode(Kind::NOT, { x164 }),t213 }) }));
db.addRule(ProofRewriteRule::BOOL_OR_AND_DISTRIB, { y1167, y2168, y3169, zs170 }, nm->mkNode(Kind::OR, { nm->mkNode(Kind::AND, { y1167,y2168,y3169 }),zs170 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::AND, { y2168,y3169 }),zs170 }), e215, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t214 }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { y1167,zs170 }),t214 }) }));
db.addRule(ProofRewriteRule::BOOL_XOR_REFL, { x171 }, nm->mkNode(Kind::XOR, { x171,x171 }), e216, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_XOR_NREFL, { x172 }, nm->mkNode(Kind::XOR, { x172,nm->mkNode(Kind::NOT, { x172 }) }), e215, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_XOR_FALSE, { x173 }, nm->mkNode(Kind::XOR, { x173,e216 }), x173, e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_XOR_TRUE, { x174 }, nm->mkNode(Kind::XOR, { x174,e215 }), nm->mkNode(Kind::NOT, { x174 }), e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_XOR_COMM, { x175, y176 }, nm->mkNode(Kind::XOR, { x175,y176 }), nm->mkNode(Kind::XOR, { y176,x175 }), e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_XOR_ELIM, { x177, y178 }, nm->mkNode(Kind::XOR, { x177,y178 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::NOT, { x177 }),y178 }), e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_NOT_XOR_ELIM, { x179, y180 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::XOR, { x179,y180 }) }), nm->mkNode(Kind::EQUAL, { x179,y180 }), e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_NOT_EQ_ELIM1, { x181, y182 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { x181,y182 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::NOT, { x181 }),y182 }), e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_NOT_EQ_ELIM2, { x183, y184 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { x183,y184 }) }), nm->mkNode(Kind::EQUAL, { x183,nm->mkNode(Kind::NOT, { y184 }) }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_NEG_BRANCH, { c185, x186, y187 }, nm->mkNode(Kind::ITE, { c185,x186,y187 }), nm->mkNode(Kind::EQUAL, { c185,x186 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::NOT, { y187 }),x186 }), Node::null());
db.addRule(ProofRewriteRule::ITE_THEN_TRUE, { c188, x189 }, nm->mkNode(Kind::ITE, { c188,e215,x189 }), nm->mkNode(Kind::OR, { c188,x189 }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_ELSE_FALSE, { c190, x191 }, nm->mkNode(Kind::ITE, { c190,x191,e216 }), nm->mkNode(Kind::AND, { c190,x191 }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_THEN_FALSE, { c192, x193 }, nm->mkNode(Kind::ITE, { c192,e216,x193 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { c192 }),x193 }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_ELSE_TRUE, { c194, x195 }, nm->mkNode(Kind::ITE, { c194,x195,e215 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::NOT, { c194 }),x195 }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_THEN_LOOKAHEAD_SELF, { c196, x197 }, nm->mkNode(Kind::ITE, { c196,c196,x197 }), nm->mkNode(Kind::ITE, { c196,e215,x197 }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_ELSE_LOOKAHEAD_SELF, { c198, x199 }, nm->mkNode(Kind::ITE, { c198,x199,c198 }), nm->mkNode(Kind::ITE, { c198,x199,e216 }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_THEN_LOOKAHEAD_NOT_SELF, { c200, x201 }, nm->mkNode(Kind::ITE, { c200,nm->mkNode(Kind::NOT, { c200 }),x201 }), nm->mkNode(Kind::ITE, { c200,e216,x201 }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_ELSE_LOOKAHEAD_NOT_SELF, { c202, x203 }, nm->mkNode(Kind::ITE, { c202,x203,nm->mkNode(Kind::NOT, { c202 }) }), nm->mkNode(Kind::ITE, { c202,x203,e215 }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_EXPAND, { c204, x205, y206 }, nm->mkNode(Kind::ITE, { c204,x205,y206 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { nm->mkNode(Kind::NOT, { c204 }),x205 }),nm->mkNode(Kind::OR, { c204,y206 }) }), e215, Node::null());
db.addRule(ProofRewriteRule::BOOL_NOT_ITE_ELIM, { c207, x208, y209 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::ITE, { c207,x208,y209 }) }), nm->mkNode(Kind::ITE, { c207,nm->mkNode(Kind::NOT, { x208 }),nm->mkNode(Kind::NOT, { y209 }) }), e215, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
