/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_builtin_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node x217 = NodeManager::mkBoundVar("x217", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y218 = NodeManager::mkBoundVar("y218", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x219 = NodeManager::mkBoundVar("x219", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y220 = NodeManager::mkBoundVar("y220", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c221 = NodeManager::mkBoundVar("c221", nm->booleanType());
Node x222 = NodeManager::mkBoundVar("x222", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y223 = NodeManager::mkBoundVar("y223", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c224 = NodeManager::mkBoundVar("c224", nm->booleanType());
Node x225 = NodeManager::mkBoundVar("x225", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c226 = NodeManager::mkBoundVar("c226", nm->booleanType());
Node x227 = NodeManager::mkBoundVar("x227", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y228 = NodeManager::mkBoundVar("y228", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z229 = NodeManager::mkBoundVar("z229", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c230 = NodeManager::mkBoundVar("c230", nm->booleanType());
Node x231 = NodeManager::mkBoundVar("x231", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y232 = NodeManager::mkBoundVar("y232", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z233 = NodeManager::mkBoundVar("z233", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c234 = NodeManager::mkBoundVar("c234", nm->booleanType());
Node x235 = NodeManager::mkBoundVar("x235", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y236 = NodeManager::mkBoundVar("y236", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z237 = NodeManager::mkBoundVar("z237", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c238 = NodeManager::mkBoundVar("c238", nm->booleanType());
Node x239 = NodeManager::mkBoundVar("x239", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y240 = NodeManager::mkBoundVar("y240", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z241 = NodeManager::mkBoundVar("z241", nm->mkAbstractType(Kind::ABSTRACT_TYPE));

  // Definitions
Node e242 = nm->mkConst(true);

  // Rules

        {
            // from rewrites-builtin-rewrites.cpp
            db.addRule(ProofRewriteRule::ITE_TRUE_COND, { x217, y218 }, nm->mkNode(Kind::ITE, { e242,x217,y218 }), x217, e242, Node::null());
db.addRule(ProofRewriteRule::ITE_FALSE_COND, { x219, y220 }, nm->mkNode(Kind::ITE, { nm->mkConst(false),x219,y220 }), y220, e242, Node::null());
db.addRule(ProofRewriteRule::ITE_NOT_COND, { c221, x222, y223 }, nm->mkNode(Kind::ITE, { nm->mkNode(Kind::NOT, { c221 }),x222,y223 }), nm->mkNode(Kind::ITE, { c221,y223,x222 }), e242, Node::null());
db.addRule(ProofRewriteRule::ITE_EQ_BRANCH, { c224, x225 }, nm->mkNode(Kind::ITE, { c224,x225,x225 }), x225, e242, Node::null());
db.addRule(ProofRewriteRule::ITE_THEN_LOOKAHEAD, { c226, x227, y228, z229 }, nm->mkNode(Kind::ITE, { c226,nm->mkNode(Kind::ITE, { c226,x227,y228 }),z229 }), nm->mkNode(Kind::ITE, { c226,x227,z229 }), e242, Node::null());
db.addRule(ProofRewriteRule::ITE_ELSE_LOOKAHEAD, { c230, x231, y232, z233 }, nm->mkNode(Kind::ITE, { c230,x231,nm->mkNode(Kind::ITE, { c230,y232,z233 }) }), nm->mkNode(Kind::ITE, { c230,x231,z233 }), e242, Node::null());
db.addRule(ProofRewriteRule::ITE_THEN_NEG_LOOKAHEAD, { c234, x235, y236, z237 }, nm->mkNode(Kind::ITE, { c234,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::NOT, { c234 }),x235,y236 }),z237 }), nm->mkNode(Kind::ITE, { c234,y236,z237 }), e242, Node::null());
db.addRule(ProofRewriteRule::ITE_ELSE_NEG_LOOKAHEAD, { c238, x239, y240, z241 }, nm->mkNode(Kind::ITE, { c238,x239,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::NOT, { c238 }),y240,z241 }) }), nm->mkNode(Kind::ITE, { c238,x239,y240 }), e242, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
