/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_bv_rewrites_elimination(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node x496 = NodeManager::mkBoundVar("x496", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y497 = NodeManager::mkBoundVar("y497", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x498 = NodeManager::mkBoundVar("x498", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y499 = NodeManager::mkBoundVar("y499", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x500 = NodeManager::mkBoundVar("x500", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y501 = NodeManager::mkBoundVar("y501", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x502 = NodeManager::mkBoundVar("x502", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y503 = NodeManager::mkBoundVar("y503", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x504 = NodeManager::mkBoundVar("x504", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y505 = NodeManager::mkBoundVar("y505", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w506 = NodeManager::mkBoundVar("w506", nm->integerType());
Node x507 = NodeManager::mkBoundVar("x507", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y508 = NodeManager::mkBoundVar("y508", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x509 = NodeManager::mkBoundVar("x509", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w510 = NodeManager::mkBoundVar("w510", nm->integerType());
Node x511 = NodeManager::mkBoundVar("x511", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w512 = NodeManager::mkBoundVar("w512", nm->integerType());
Node x513 = NodeManager::mkBoundVar("x513", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y514 = NodeManager::mkBoundVar("y514", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x515 = NodeManager::mkBoundVar("x515", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y516 = NodeManager::mkBoundVar("y516", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x517 = NodeManager::mkBoundVar("x517", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount518 = NodeManager::mkBoundVar("amount518", nm->integerType());
Node u1519 = NodeManager::mkBoundVar("u1519", nm->integerType());
Node u2520 = NodeManager::mkBoundVar("u2520", nm->integerType());
Node l2521 = NodeManager::mkBoundVar("l2521", nm->integerType());
Node x522 = NodeManager::mkBoundVar("x522", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount523 = NodeManager::mkBoundVar("amount523", nm->integerType());
Node x524 = NodeManager::mkBoundVar("x524", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount525 = NodeManager::mkBoundVar("amount525", nm->integerType());
Node u1526 = NodeManager::mkBoundVar("u1526", nm->integerType());
Node u2527 = NodeManager::mkBoundVar("u2527", nm->integerType());
Node l2528 = NodeManager::mkBoundVar("l2528", nm->integerType());
Node x529 = NodeManager::mkBoundVar("x529", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount530 = NodeManager::mkBoundVar("amount530", nm->integerType());
Node x531 = NodeManager::mkBoundVar("x531", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y532 = NodeManager::mkBoundVar("y532", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x533 = NodeManager::mkBoundVar("x533", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y534 = NodeManager::mkBoundVar("y534", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x535 = NodeManager::mkBoundVar("x535", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y536 = NodeManager::mkBoundVar("y536", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x537 = NodeManager::mkBoundVar("x537", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y538 = NodeManager::mkBoundVar("y538", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node nm1539 = NodeManager::mkBoundVar("nm1539", nm->integerType());
Node x540 = NodeManager::mkBoundVar("x540", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y541 = NodeManager::mkBoundVar("y541", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node nm1542 = NodeManager::mkBoundVar("nm1542", nm->integerType());
Node x543 = NodeManager::mkBoundVar("x543", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n544 = NodeManager::mkBoundVar("n544", nm->integerType());
Node x545 = NodeManager::mkBoundVar("x545", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n546 = NodeManager::mkBoundVar("n546", nm->integerType());
Node wm1547 = NodeManager::mkBoundVar("wm1547", nm->integerType());
Node x548 = NodeManager::mkBoundVar("x548", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y549 = NodeManager::mkBoundVar("y549", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w550 = NodeManager::mkBoundVar("w550", nm->integerType());
Node x551 = NodeManager::mkBoundVar("x551", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y552 = NodeManager::mkBoundVar("y552", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node wm1553 = NodeManager::mkBoundVar("wm1553", nm->integerType());
Node x554 = NodeManager::mkBoundVar("x554", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y555 = NodeManager::mkBoundVar("y555", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w556 = NodeManager::mkBoundVar("w556", nm->integerType());
Node wm1557 = NodeManager::mkBoundVar("wm1557", nm->integerType());
Node x558 = NodeManager::mkBoundVar("x558", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y559 = NodeManager::mkBoundVar("y559", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w560 = NodeManager::mkBoundVar("w560", nm->integerType());
Node wm1561 = NodeManager::mkBoundVar("wm1561", nm->integerType());
Node x562 = NodeManager::mkBoundVar("x562", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y563 = NodeManager::mkBoundVar("y563", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w564 = NodeManager::mkBoundVar("w564", nm->integerType());
Node wm1565 = NodeManager::mkBoundVar("wm1565", nm->integerType());
Node x566 = NodeManager::mkBoundVar("x566", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y567 = NodeManager::mkBoundVar("y567", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node nm1568 = NodeManager::mkBoundVar("nm1568", nm->integerType());
Node x569 = NodeManager::mkBoundVar("x569", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y570 = NodeManager::mkBoundVar("y570", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node nm1571 = NodeManager::mkBoundVar("nm1571", nm->integerType());
Node x572 = NodeManager::mkBoundVar("x572", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y573 = NodeManager::mkBoundVar("y573", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n574 = NodeManager::mkBoundVar("n574", nm->integerType());
Node x575 = NodeManager::mkBoundVar("x575", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y576 = NodeManager::mkBoundVar("y576", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node nm1577 = NodeManager::mkBoundVar("nm1577", nm->integerType());

  // Definitions
Node e578 = nm->mkConstInt(Rational(1));
Node e579 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) });
Node e580 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm->mkConstInt(Rational(1)) });
Node e581 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1577,nm1577,nm->mkNode(Kind::BITVECTOR_SUB, { x575,y576 }) });
Node e582 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1577,nm1577,y576 });
Node e583 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1577,nm1577,x575 });
Node e584 = nm->mkConstInt(Rational(0));
Node e585 = nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm1571 }) });
Node e586 = nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { x569,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm1571 }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x569 }),x569 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { y570,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm1571 }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y570 }),y570 }) });
Node e587 = nm->mkNode(Kind::BITVECTOR_UGE, { x569,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm1571 }) }) });
Node e588 = nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1568,nm1568,x566 }),nm->mkNode(Kind::BITVECTOR_NEG, { x566 }),x566 }),nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1568,nm1568,y567 }),nm->mkNode(Kind::BITVECTOR_NEG, { y567 }),y567 }) });
Node e589 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1568,nm1568,x566 });
Node e590 = nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),wm1565 }) });
Node e591 = nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { x562,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),wm1565 }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x562 }),x562 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { y563,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),wm1565 }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y563 }),y563 }) });
Node e592 = nm->mkNode(Kind::BITVECTOR_UGE, { y563,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),wm1565 }) }) });
Node e593 = nm->mkNode(Kind::BITVECTOR_UGE, { x562,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),wm1565 }) }) });
Node e594 = nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { x562,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),wm1565 }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x562 }),x562 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { y563,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),wm1565 }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y563 }),y563 }) }) });
Node e595 = nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_UGE, { y563,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),wm1565 }) }) }) });
Node e596 = nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_UGE, { x562,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),wm1565 }) }) }) });
Node e597 = nm->mkNode(Kind::BITVECTOR_SIZE, { x562 });
Node e598 = nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1561,wm1561,x558 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x558 }),x558 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1561,wm1561,y559 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y559 }),y559 }) });
Node e599 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1561,wm1561,y559 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) });
Node e600 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1561,wm1561,x558 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) });
Node e601 = nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1561,wm1561,x558 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x558 }),x558 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1561,wm1561,y559 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y559 }),y559 }) }) });
Node e602 = nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1561,wm1561,y559 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) }) });
Node e603 = nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1561,wm1561,x558 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) }) });
Node e604 = nm->mkNode(Kind::BITVECTOR_SIZE, { x558 });
Node e605 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1553,wm1553,nm->mkNode(Kind::BITVECTOR_ADD, { x551,y552 }) });
Node e606 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1553,wm1553,y552 });
Node e607 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1553,wm1553,x551 });
Node e608 = nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm1542 }) });
Node e609 = nm->mkNode(Kind::BITVECTOR_UDIV, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { x540,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm1542 }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x540 }),x540 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { y541,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm1542 }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y541 }),y541 }) });
Node e610 = nm->mkNode(Kind::BITVECTOR_UGE, { y541,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm1542 }) }) });
Node e611 = nm->mkNode(Kind::BITVECTOR_UGE, { x540,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm1542 }) }) });
Node e612 = nm->mkNode(Kind::BITVECTOR_UDIV, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1539,nm1539,x537 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x537 }),x537 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1539,nm1539,y538 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y538 }),y538 }) });
Node e613 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1539,nm1539,y538 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) });
Node e614 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1539,nm1539,x537 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) });
Node e615 = nm->mkConst(true);
Node e616 = nm->mkNode(Kind::BITVECTOR_SIZE, { x524 });
Node e617 = nm->mkNode(Kind::INTS_MODULUS, { amount525,nm->mkNode(Kind::BITVECTOR_SIZE, { x524 }) });
Node e618 = nm->mkNode(Kind::BITVECTOR_SIZE, { x517 });
Node e619 = nm->mkNode(Kind::INTS_MODULUS, { amount518,nm->mkNode(Kind::BITVECTOR_SIZE, { x517 }) });
Node e620 = nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),w506 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x504 }),nm->mkConstInt(Rational(1)) }),w506 }) });
Node e621 = nm->mkNode(Kind::BITVECTOR_SIZE, { x504 });

  // Rules

        {
            // from rewrites-bv-rewrites-elimination.cpp
            db.addRule(ProofRewriteRule::BV_UGT_ELIMINATE, { x496, y497 }, nm->mkNode(Kind::BITVECTOR_UGT, { x496,y497 }), nm->mkNode(Kind::BITVECTOR_ULT, { y497,x496 }), e615, Node::null());
db.addRule(ProofRewriteRule::BV_UGE_ELIMINATE, { x498, y499 }, nm->mkNode(Kind::BITVECTOR_UGE, { x498,y499 }), nm->mkNode(Kind::BITVECTOR_ULE, { y499,x498 }), e615, Node::null());
db.addRule(ProofRewriteRule::BV_SGT_ELIMINATE, { x500, y501 }, nm->mkNode(Kind::BITVECTOR_SGT, { x500,y501 }), nm->mkNode(Kind::BITVECTOR_SLT, { y501,x500 }), e615, Node::null());
db.addRule(ProofRewriteRule::BV_SGE_ELIMINATE, { x502, y503 }, nm->mkNode(Kind::BITVECTOR_SGE, { x502,y503 }), nm->mkNode(Kind::BITVECTOR_SLE, { y503,x502 }), e615, Node::null());
db.addRule(ProofRewriteRule::BV_SLT_ELIMINATE, { x504, y505, w506 }, nm->mkNode(Kind::BITVECTOR_SLT, { x504,y505 }), nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::BITVECTOR_ADD, { x504,e620 }),nm->mkNode(Kind::BITVECTOR_ADD, { y505,e620 }) }), nm->mkNode(Kind::EQUAL, { w506,e621 }), Node::null());
db.addRule(ProofRewriteRule::BV_SLE_ELIMINATE, { x507, y508 }, nm->mkNode(Kind::BITVECTOR_SLE, { x507,y508 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_SLT, { y508,x507 }) }), e615, Node::null());
db.addRule(ProofRewriteRule::BV_REDOR_ELIMINATE, { x509, w510 }, nm->mkNode(Kind::BITVECTOR_REDOR, { x509 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_COMP, { x509,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e584,w510 }) }) }), nm->mkNode(Kind::EQUAL, { w510,nm->mkNode(Kind::BITVECTOR_SIZE, { x509 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_REDAND_ELIMINATE, { x511, w512 }, nm->mkNode(Kind::BITVECTOR_REDAND, { x511 }), nm->mkNode(Kind::BITVECTOR_COMP, { x511,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e584,w512 }) }) }), nm->mkNode(Kind::EQUAL, { w512,nm->mkNode(Kind::BITVECTOR_SIZE, { x511 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ULE_ELIMINATE, { x513, y514 }, nm->mkNode(Kind::BITVECTOR_ULE, { x513,y514 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_ULT, { y514,x513 }) }), e615, Node::null());
db.addRule(ProofRewriteRule::BV_COMP_ELIMINATE, { x515, y516 }, nm->mkNode(Kind::BITVECTOR_COMP, { x515,y516 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { x515,y516 }),e579,e580 }), e615, Node::null());
db.addRule(ProofRewriteRule::BV_ROTATE_LEFT_ELIMINATE_1, { x517, amount518, u1519, u2520, l2521 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ROTATE_LEFT)),amount518,x517 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u1519,e584,x517 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u2520,l2521,x517 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { e619,e584 }) }),nm->mkNode(Kind::EQUAL, { u1519,nm->mkNode(Kind::SUB, { e618,nm->mkNode(Kind::ADD, { e578,e619 }) }) }),nm->mkNode(Kind::EQUAL, { u2520,nm->mkNode(Kind::SUB, { e618,e578 }) }),nm->mkNode(Kind::EQUAL, { l2521,nm->mkNode(Kind::SUB, { e618,e619 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ROTATE_LEFT_ELIMINATE_2, { x522, amount523 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ROTATE_LEFT)),amount523,x522 }), x522, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::INTS_MODULUS, { amount523,nm->mkNode(Kind::BITVECTOR_SIZE, { x522 }) }),e584 }), Node::null());
db.addRule(ProofRewriteRule::BV_ROTATE_RIGHT_ELIMINATE_1, { x524, amount525, u1526, u2527, l2528 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ROTATE_RIGHT)),amount525,x524 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u1526,e584,x524 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u2527,l2528,x524 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { e617,e584 }) }),nm->mkNode(Kind::EQUAL, { u1526,nm->mkNode(Kind::SUB, { e617,e578 }) }),nm->mkNode(Kind::EQUAL, { u2527,nm->mkNode(Kind::SUB, { e616,e578 }) }),nm->mkNode(Kind::EQUAL, { l2528,e617 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ROTATE_RIGHT_ELIMINATE_2, { x529, amount530 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ROTATE_RIGHT)),amount530,x529 }), x529, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::INTS_MODULUS, { amount530,nm->mkNode(Kind::BITVECTOR_SIZE, { x529 }) }),e584 }), Node::null());
db.addRule(ProofRewriteRule::BV_NAND_ELIMINATE, { x531, y532 }, nm->mkNode(Kind::BITVECTOR_NAND, { x531,y532 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_AND, { x531,y532 }) }), e615, Node::null());
db.addRule(ProofRewriteRule::BV_NOR_ELIMINATE, { x533, y534 }, nm->mkNode(Kind::BITVECTOR_NOR, { x533,y534 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_OR, { x533,y534 }) }), e615, Node::null());
db.addRule(ProofRewriteRule::BV_XNOR_ELIMINATE, { x535, y536 }, nm->mkNode(Kind::BITVECTOR_XNOR, { x535,y536 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { x535,y536 }) }), e615, Node::null());
db.addRule(ProofRewriteRule::BV_SDIV_ELIMINATE, { x537, y538, nm1539 }, nm->mkNode(Kind::BITVECTOR_SDIV, { x537,y538 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::XOR, { e614,e613 }),nm->mkNode(Kind::BITVECTOR_NEG, { e612 }),e612 }), nm->mkNode(Kind::EQUAL, { nm1539,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x537 }),e578 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SDIV_ELIMINATE_FEWER_BITWISE_OPS, { x540, y541, nm1542 }, nm->mkNode(Kind::BITVECTOR_SDIV, { x540,y541 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::XOR, { e611,e610 }),nm->mkNode(Kind::BITVECTOR_NEG, { e609 }),e609 }), nm->mkNode(Kind::EQUAL, { nm1542,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x540 }),e578 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_ELIMINATE, { x543, n544 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),n544,x543 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e584,n544 }),x543 }), e615, Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ELIMINATE, { x545, n546, wm1547 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),n546,x545 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),n546,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1547,wm1547,x545 }) }),x545 }), nm->mkNode(Kind::EQUAL, { wm1547,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x545 }),e578 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_UADDO_ELIMINATE, { x548, y549, w550 }, nm->mkNode(Kind::BITVECTOR_UADDO, { x548,y549 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),w550,w550,nm->mkNode(Kind::BITVECTOR_ADD, { nm->mkNode(Kind::BITVECTOR_CONCAT, { e580,x548 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { e580,y549 }) }) }),e579 }), nm->mkNode(Kind::EQUAL, { w550,nm->mkNode(Kind::BITVECTOR_SIZE, { x548 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SADDO_ELIMINATE, { x551, y552, wm1553 }, nm->mkNode(Kind::BITVECTOR_SADDO, { x551,y552 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { e607,e579 }),nm->mkNode(Kind::EQUAL, { e606,e579 }) }),nm->mkNode(Kind::EQUAL, { e605,e580 }) }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { e607,e580 }),nm->mkNode(Kind::EQUAL, { e606,e580 }) }),nm->mkNode(Kind::EQUAL, { e605,e579 }) }) }), nm->mkNode(Kind::EQUAL, { wm1553,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x551 }),e578 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SDIVO_ELIMINATE, { x554, y555, w556, wm1557 }, nm->mkNode(Kind::BITVECTOR_SDIVO, { x554,y555 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { x554,nm->mkNode(Kind::BITVECTOR_CONCAT, { e579,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e584,wm1557 }) }) }),nm->mkNode(Kind::EQUAL, { y555,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e584,w556 }) }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { wm1557,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x554 }),e578 }) }),nm->mkNode(Kind::EQUAL, { w556,nm->mkNode(Kind::BITVECTOR_SIZE, { y555 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SMOD_ELIMINATE, { x558, y559, w560, wm1561 }, nm->mkNode(Kind::BITVECTOR_SMOD, { x558,y559 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { e598,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e584,w560 }) }),e598,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e603,e602 }),e598,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e600,e602 }),nm->mkNode(Kind::BITVECTOR_ADD, { e601,y559 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e603,e599 }),nm->mkNode(Kind::BITVECTOR_ADD, { e598,y559 }),e601 }) }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { w560,e604 }),nm->mkNode(Kind::EQUAL, { wm1561,nm->mkNode(Kind::SUB, { e604,e578 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SMOD_ELIMINATE_FEWER_BITWISE_OPS, { x562, y563, w564, wm1565 }, nm->mkNode(Kind::BITVECTOR_SMOD, { x562,y563 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { e591,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e584,w564 }) }),e591,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e596,e595 }),e591,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e593,e595 }),nm->mkNode(Kind::BITVECTOR_ADD, { e594,y563 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e596,e592 }),nm->mkNode(Kind::BITVECTOR_ADD, { e591,y563 }),e594 }) }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { w564,e597 }),nm->mkNode(Kind::EQUAL, { wm1565,nm->mkNode(Kind::SUB, { e597,e578 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SREM_ELIMINATE, { x566, y567, nm1568 }, nm->mkNode(Kind::BITVECTOR_SREM, { x566,y567 }), nm->mkNode(Kind::BITVECTOR_ITE, { e589,nm->mkNode(Kind::BITVECTOR_NEG, { e588 }),e588 }), nm->mkNode(Kind::EQUAL, { nm1568,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x566 }),e578 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SREM_ELIMINATE_FEWER_BITWISE_OPS, { x569, y570, nm1571 }, nm->mkNode(Kind::BITVECTOR_SREM, { x569,y570 }), nm->mkNode(Kind::ITE, { e587,nm->mkNode(Kind::BITVECTOR_NEG, { e586 }),e586 }), nm->mkNode(Kind::EQUAL, { nm1571,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x569 }),e578 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_USUBO_ELIMINATE, { x572, y573, n574 }, nm->mkNode(Kind::BITVECTOR_USUBO, { x572,y573 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),n574,n574,nm->mkNode(Kind::BITVECTOR_SUB, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),e578,x572 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),e578,y573 }) }) }),e579 }), nm->mkNode(Kind::EQUAL, { n574,nm->mkNode(Kind::BITVECTOR_SIZE, { x572 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SSUBO_ELIMINATE, { x575, y576, nm1577 }, nm->mkNode(Kind::BITVECTOR_SSUBO, { x575,y576 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { e583,e579 }),nm->mkNode(Kind::EQUAL, { e582,e580 }) }),nm->mkNode(Kind::EQUAL, { e581,e580 }) }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { e583,e580 }),nm->mkNode(Kind::EQUAL, { e582,e579 }) }),nm->mkNode(Kind::EQUAL, { e581,e579 }) }) }), nm->mkNode(Kind::EQUAL, { nm1577,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x575 }),e578 }) }), Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
