/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_bv_rewrites_simplification(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node c622 = NodeManager::mkBoundVar("c622", nm->mkBitVectorType(1));
Node x623 = NodeManager::mkBoundVar("x623", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c624 = NodeManager::mkBoundVar("c624", nm->mkBitVectorType(1));
Node c625 = NodeManager::mkBoundVar("c625", nm->mkBitVectorType(1));
Node c0626 = NodeManager::mkBoundVar("c0626", nm->mkBitVectorType(1));
Node t0627 = NodeManager::mkBoundVar("t0627", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e0628 = NodeManager::mkBoundVar("e0628", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1629 = NodeManager::mkBoundVar("e1629", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0630 = NodeManager::mkBoundVar("c0630", nm->mkBitVectorType(1));
Node t0631 = NodeManager::mkBoundVar("t0631", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t1632 = NodeManager::mkBoundVar("t1632", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1633 = NodeManager::mkBoundVar("e1633", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0634 = NodeManager::mkBoundVar("c0634", nm->mkBitVectorType(1));
Node t0635 = NodeManager::mkBoundVar("t0635", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e0636 = NodeManager::mkBoundVar("e0636", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t1637 = NodeManager::mkBoundVar("t1637", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1638 = NodeManager::mkBoundVar("e1638", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0639 = NodeManager::mkBoundVar("c0639", nm->mkBitVectorType(1));
Node c1640 = NodeManager::mkBoundVar("c1640", nm->mkBitVectorType(1));
Node t1641 = NodeManager::mkBoundVar("t1641", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1642 = NodeManager::mkBoundVar("e1642", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0643 = NodeManager::mkBoundVar("c0643", nm->mkBitVectorType(1));
Node c1644 = NodeManager::mkBoundVar("c1644", nm->mkBitVectorType(1));
Node t1645 = NodeManager::mkBoundVar("t1645", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1646 = NodeManager::mkBoundVar("e1646", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0647 = NodeManager::mkBoundVar("c0647", nm->mkBitVectorType(1));
Node c1648 = NodeManager::mkBoundVar("c1648", nm->mkBitVectorType(1));
Node t0649 = NodeManager::mkBoundVar("t0649", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1650 = NodeManager::mkBoundVar("e1650", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0651 = NodeManager::mkBoundVar("c0651", nm->mkBitVectorType(1));
Node c1652 = NodeManager::mkBoundVar("c1652", nm->mkBitVectorType(1));
Node t1653 = NodeManager::mkBoundVar("t1653", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t0654 = NodeManager::mkBoundVar("t0654", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x655 = NodeManager::mkBoundVar("x655", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node sz656 = NodeManager::mkBoundVar("sz656", nm->integerType());
Node x657 = NodeManager::mkBoundVar("x657", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount658 = NodeManager::mkBoundVar("amount658", nm->integerType());
Node sz659 = NodeManager::mkBoundVar("sz659", nm->integerType());
Node en660 = NodeManager::mkBoundVar("en660", nm->integerType());
Node x661 = NodeManager::mkBoundVar("x661", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount662 = NodeManager::mkBoundVar("amount662", nm->integerType());
Node sz663 = NodeManager::mkBoundVar("sz663", nm->integerType());
Node w664 = NodeManager::mkBoundVar("w664", nm->integerType());
Node x665 = NodeManager::mkBoundVar("x665", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node sz666 = NodeManager::mkBoundVar("sz666", nm->integerType());
Node x667 = NodeManager::mkBoundVar("x667", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount668 = NodeManager::mkBoundVar("amount668", nm->integerType());
Node sz669 = NodeManager::mkBoundVar("sz669", nm->integerType());
Node nm1670 = NodeManager::mkBoundVar("nm1670", nm->integerType());
Node x671 = NodeManager::mkBoundVar("x671", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount672 = NodeManager::mkBoundVar("amount672", nm->integerType());
Node sz673 = NodeManager::mkBoundVar("sz673", nm->integerType());
Node x674 = NodeManager::mkBoundVar("x674", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node sz675 = NodeManager::mkBoundVar("sz675", nm->integerType());
Node x676 = NodeManager::mkBoundVar("x676", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount677 = NodeManager::mkBoundVar("amount677", nm->integerType());
Node sz678 = NodeManager::mkBoundVar("sz678", nm->integerType());
Node nm1679 = NodeManager::mkBoundVar("nm1679", nm->integerType());
Node x680 = NodeManager::mkBoundVar("x680", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount681 = NodeManager::mkBoundVar("amount681", nm->integerType());
Node sz682 = NodeManager::mkBoundVar("sz682", nm->integerType());
Node nm1683 = NodeManager::mkBoundVar("nm1683", nm->integerType());
Node rn684 = NodeManager::mkBoundVar("rn684", nm->integerType());
Node x685 = NodeManager::mkBoundVar("x685", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y686 = NodeManager::mkBoundVar("y686", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z687 = NodeManager::mkBoundVar("z687", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys688 = NodeManager::mkBoundVar("ys688", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys688);
Node nxm1689 = NodeManager::mkBoundVar("nxm1689", nm->integerType());
Node ny690 = NodeManager::mkBoundVar("ny690", nm->integerType());
Node nym1691 = NodeManager::mkBoundVar("nym1691", nm->integerType());
Node x692 = NodeManager::mkBoundVar("x692", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y693 = NodeManager::mkBoundVar("y693", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z694 = NodeManager::mkBoundVar("z694", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys695 = NodeManager::mkBoundVar("ys695", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys695);
Node nxm1696 = NodeManager::mkBoundVar("nxm1696", nm->integerType());
Node ny697 = NodeManager::mkBoundVar("ny697", nm->integerType());
Node nym1698 = NodeManager::mkBoundVar("nym1698", nm->integerType());
Node x699 = NodeManager::mkBoundVar("x699", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y700 = NodeManager::mkBoundVar("y700", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z701 = NodeManager::mkBoundVar("z701", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys702 = NodeManager::mkBoundVar("ys702", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys702);
Node nxm1703 = NodeManager::mkBoundVar("nxm1703", nm->integerType());
Node ny704 = NodeManager::mkBoundVar("ny704", nm->integerType());
Node nym1705 = NodeManager::mkBoundVar("nym1705", nm->integerType());
Node x706 = NodeManager::mkBoundVar("x706", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x707 = NodeManager::mkBoundVar("x707", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x708 = NodeManager::mkBoundVar("x708", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n709 = NodeManager::mkBoundVar("n709", nm->integerType());
Node x710 = NodeManager::mkBoundVar("x710", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n711 = NodeManager::mkBoundVar("n711", nm->integerType());
Node w712 = NodeManager::mkBoundVar("w712", nm->integerType());
Node x713 = NodeManager::mkBoundVar("x713", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n714 = NodeManager::mkBoundVar("n714", nm->integerType());
Node w715 = NodeManager::mkBoundVar("w715", nm->integerType());
Node x716 = NodeManager::mkBoundVar("x716", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w717 = NodeManager::mkBoundVar("w717", nm->integerType());
Node xs718 = NodeManager::mkBoundVar("xs718", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs718);
Node zs719 = NodeManager::mkBoundVar("zs719", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs719);
Node n720 = NodeManager::mkBoundVar("n720", nm->integerType());
Node w721 = NodeManager::mkBoundVar("w721", nm->integerType());
Node xs722 = NodeManager::mkBoundVar("xs722", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs722);
Node zs723 = NodeManager::mkBoundVar("zs723", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs723);
Node n724 = NodeManager::mkBoundVar("n724", nm->integerType());
Node x725 = NodeManager::mkBoundVar("x725", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w726 = NodeManager::mkBoundVar("w726", nm->integerType());
Node x727 = NodeManager::mkBoundVar("x727", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w728 = NodeManager::mkBoundVar("w728", nm->integerType());
Node x729 = NodeManager::mkBoundVar("x729", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y730 = NodeManager::mkBoundVar("y730", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x731 = NodeManager::mkBoundVar("x731", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x732 = NodeManager::mkBoundVar("x732", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n733 = NodeManager::mkBoundVar("n733", nm->integerType());
Node x734 = NodeManager::mkBoundVar("x734", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n735 = NodeManager::mkBoundVar("n735", nm->integerType());
Node x736 = NodeManager::mkBoundVar("x736", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x737 = NodeManager::mkBoundVar("x737", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x738 = NodeManager::mkBoundVar("x738", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x739 = NodeManager::mkBoundVar("x739", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n740 = NodeManager::mkBoundVar("n740", nm->integerType());
Node x741 = NodeManager::mkBoundVar("x741", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n742 = NodeManager::mkBoundVar("n742", nm->integerType());
Node x743 = NodeManager::mkBoundVar("x743", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x744 = NodeManager::mkBoundVar("x744", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n745 = NodeManager::mkBoundVar("n745", nm->integerType());
Node w746 = NodeManager::mkBoundVar("w746", nm->integerType());
Node x747 = NodeManager::mkBoundVar("x747", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y748 = NodeManager::mkBoundVar("y748", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x749 = NodeManager::mkBoundVar("x749", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y750 = NodeManager::mkBoundVar("y750", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x751 = NodeManager::mkBoundVar("x751", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y752 = NodeManager::mkBoundVar("y752", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs753 = NodeManager::mkBoundVar("xs753", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs753);
Node ys754 = NodeManager::mkBoundVar("ys754", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys754);
Node z755 = NodeManager::mkBoundVar("z755", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node size756 = NodeManager::mkBoundVar("size756", nm->integerType());
Node n757 = NodeManager::mkBoundVar("n757", nm->integerType());
Node exponent758 = NodeManager::mkBoundVar("exponent758", nm->integerType());
Node u759 = NodeManager::mkBoundVar("u759", nm->integerType());
Node xs760 = NodeManager::mkBoundVar("xs760", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs760);
Node ys761 = NodeManager::mkBoundVar("ys761", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys761);
Node z762 = NodeManager::mkBoundVar("z762", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node size763 = NodeManager::mkBoundVar("size763", nm->integerType());
Node n764 = NodeManager::mkBoundVar("n764", nm->integerType());
Node exponent765 = NodeManager::mkBoundVar("exponent765", nm->integerType());
Node u766 = NodeManager::mkBoundVar("u766", nm->integerType());
Node z767 = NodeManager::mkBoundVar("z767", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node size768 = NodeManager::mkBoundVar("size768", nm->integerType());
Node n769 = NodeManager::mkBoundVar("n769", nm->integerType());
Node exponent770 = NodeManager::mkBoundVar("exponent770", nm->integerType());
Node u771 = NodeManager::mkBoundVar("u771", nm->integerType());
Node high772 = NodeManager::mkBoundVar("high772", nm->integerType());
Node low773 = NodeManager::mkBoundVar("low773", nm->integerType());
Node x1i774 = NodeManager::mkBoundVar("x1i774", nm->integerType());
Node x1in775 = NodeManager::mkBoundVar("x1in775", nm->integerType());
Node x2776 = NodeManager::mkBoundVar("x2776", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y1i777 = NodeManager::mkBoundVar("y1i777", nm->integerType());
Node y1in778 = NodeManager::mkBoundVar("y1in778", nm->integerType());
Node y2779 = NodeManager::mkBoundVar("y2779", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w780 = NodeManager::mkBoundVar("w780", nm->integerType());
Node x781 = NodeManager::mkBoundVar("x781", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node v782 = NodeManager::mkBoundVar("v782", nm->integerType());
Node n783 = NodeManager::mkBoundVar("n783", nm->integerType());
Node power784 = NodeManager::mkBoundVar("power784", nm->integerType());
Node nm1785 = NodeManager::mkBoundVar("nm1785", nm->integerType());
Node x786 = NodeManager::mkBoundVar("x786", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n787 = NodeManager::mkBoundVar("n787", nm->integerType());
Node x788 = NodeManager::mkBoundVar("x788", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n789 = NodeManager::mkBoundVar("n789", nm->integerType());
Node x790 = NodeManager::mkBoundVar("x790", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node v791 = NodeManager::mkBoundVar("v791", nm->integerType());
Node n792 = NodeManager::mkBoundVar("n792", nm->integerType());
Node nmp793 = NodeManager::mkBoundVar("nmp793", nm->integerType());
Node pm1794 = NodeManager::mkBoundVar("pm1794", nm->integerType());
Node x795 = NodeManager::mkBoundVar("x795", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n796 = NodeManager::mkBoundVar("n796", nm->integerType());
Node x797 = NodeManager::mkBoundVar("x797", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w798 = NodeManager::mkBoundVar("w798", nm->integerType());
Node a799 = NodeManager::mkBoundVar("a799", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n800 = NodeManager::mkBoundVar("n800", nm->integerType());
Node a801 = NodeManager::mkBoundVar("a801", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n802 = NodeManager::mkBoundVar("n802", nm->integerType());
Node a803 = NodeManager::mkBoundVar("a803", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n804 = NodeManager::mkBoundVar("n804", nm->integerType());
Node y805 = NodeManager::mkBoundVar("y805", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x806 = NodeManager::mkBoundVar("x806", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w807 = NodeManager::mkBoundVar("w807", nm->integerType());
Node x808 = NodeManager::mkBoundVar("x808", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n809 = NodeManager::mkBoundVar("n809", nm->integerType());
Node x810 = NodeManager::mkBoundVar("x810", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n811 = NodeManager::mkBoundVar("n811", nm->integerType());
Node nm1812 = NodeManager::mkBoundVar("nm1812", nm->integerType());
Node x813 = NodeManager::mkBoundVar("x813", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i814 = NodeManager::mkBoundVar("i814", nm->integerType());
Node j815 = NodeManager::mkBoundVar("j815", nm->integerType());
Node k816 = NodeManager::mkBoundVar("k816", nm->integerType());
Node x817 = NodeManager::mkBoundVar("x817", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i818 = NodeManager::mkBoundVar("i818", nm->integerType());
Node j819 = NodeManager::mkBoundVar("j819", nm->integerType());
Node k820 = NodeManager::mkBoundVar("k820", nm->integerType());
Node x821 = NodeManager::mkBoundVar("x821", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i822 = NodeManager::mkBoundVar("i822", nm->integerType());
Node n0823 = NodeManager::mkBoundVar("n0823", nm->integerType());
Node x824 = NodeManager::mkBoundVar("x824", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m825 = NodeManager::mkBoundVar("m825", nm->integerType());
Node c826 = NodeManager::mkBoundVar("c826", nm->integerType());
Node nm827 = NodeManager::mkBoundVar("nm827", nm->integerType());
Node mp1828 = NodeManager::mkBoundVar("mp1828", nm->integerType());
Node nm1829 = NodeManager::mkBoundVar("nm1829", nm->integerType());
Node nmm1830 = NodeManager::mkBoundVar("nmm1830", nm->integerType());
Node x831 = NodeManager::mkBoundVar("x831", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m832 = NodeManager::mkBoundVar("m832", nm->integerType());
Node c833 = NodeManager::mkBoundVar("c833", nm->integerType());
Node nm834 = NodeManager::mkBoundVar("nm834", nm->integerType());
Node mp1835 = NodeManager::mkBoundVar("mp1835", nm->integerType());
Node nm1836 = NodeManager::mkBoundVar("nm1836", nm->integerType());
Node nmm1837 = NodeManager::mkBoundVar("nmm1837", nm->integerType());
Node x838 = NodeManager::mkBoundVar("x838", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m839 = NodeManager::mkBoundVar("m839", nm->integerType());
Node c840 = NodeManager::mkBoundVar("c840", nm->integerType());
Node nm841 = NodeManager::mkBoundVar("nm841", nm->integerType());
Node nm1842 = NodeManager::mkBoundVar("nm1842", nm->integerType());
Node nmm1843 = NodeManager::mkBoundVar("nmm1843", nm->integerType());
Node x844 = NodeManager::mkBoundVar("x844", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m845 = NodeManager::mkBoundVar("m845", nm->integerType());
Node c846 = NodeManager::mkBoundVar("c846", nm->integerType());
Node nm847 = NodeManager::mkBoundVar("nm847", nm->integerType());
Node nm1848 = NodeManager::mkBoundVar("nm1848", nm->integerType());
Node nmm1849 = NodeManager::mkBoundVar("nmm1849", nm->integerType());
Node x850 = NodeManager::mkBoundVar("x850", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m851 = NodeManager::mkBoundVar("m851", nm->integerType());
Node c852 = NodeManager::mkBoundVar("c852", nm->integerType());
Node nm853 = NodeManager::mkBoundVar("nm853", nm->integerType());
Node nm1854 = NodeManager::mkBoundVar("nm1854", nm->integerType());
Node x855 = NodeManager::mkBoundVar("x855", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m856 = NodeManager::mkBoundVar("m856", nm->integerType());
Node c857 = NodeManager::mkBoundVar("c857", nm->integerType());
Node nm858 = NodeManager::mkBoundVar("nm858", nm->integerType());
Node nm1859 = NodeManager::mkBoundVar("nm1859", nm->integerType());
Node x860 = NodeManager::mkBoundVar("x860", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m861 = NodeManager::mkBoundVar("m861", nm->integerType());
Node c862 = NodeManager::mkBoundVar("c862", nm->integerType());
Node nm863 = NodeManager::mkBoundVar("nm863", nm->integerType());
Node nm1864 = NodeManager::mkBoundVar("nm1864", nm->integerType());
Node x865 = NodeManager::mkBoundVar("x865", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m866 = NodeManager::mkBoundVar("m866", nm->integerType());
Node c867 = NodeManager::mkBoundVar("c867", nm->integerType());
Node nm868 = NodeManager::mkBoundVar("nm868", nm->integerType());
Node nm1869 = NodeManager::mkBoundVar("nm1869", nm->integerType());

  // Definitions
Node e870 = nm->mkConstInt(Rational(1));
Node e871 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x865 }),nm->mkConstInt(Rational(1)) });
Node e872 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c867,nm868 });
Node e873 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x865 }),nm->mkConstInt(Rational(1)) }),nm868 });
Node e874 = nm->mkConstInt(Rational(0));
Node e875 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c862,nm863 });
Node e876 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x860 }),nm->mkConstInt(Rational(1)) });
Node e877 = nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm863 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x860 }),nm->mkConstInt(Rational(1)) }),nm863 }) });
Node e878 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x855 }),nm->mkConstInt(Rational(1)) });
Node e879 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c857,nm858 });
Node e880 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x855 }),nm->mkConstInt(Rational(1)) }),nm858 });
Node e881 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c852,nm853 });
Node e882 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x850 }),nm->mkConstInt(Rational(1)) });
Node e883 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x850 }),nm->mkConstInt(Rational(1)) }),nm853 });
Node e884 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c846,nm847 });
Node e885 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c840,nm841 });
Node e886 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c833,nm834 });
Node e887 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),mp1835 });
Node e888 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nmm1837,nm1836,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c833,nm834 }) });
Node e889 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c826,nm827 });
Node e890 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),mp1828 });
Node e891 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nmm1830,nm1829,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c826,nm827 }) });
Node e892 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) });
Node e893 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),w807 });
Node e894 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n804 });
Node e895 = nm->mkConst(true);
Node e896 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n802 });
Node e897 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n800 });
Node e898 = nm->mkNode(Kind::INTS_LOG2, { v791 });
Node e899 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n787 });
Node e900 = nm->mkNode(Kind::ADD, { x1in775,nm->mkNode(Kind::BITVECTOR_SIZE, { x2776 }) });
Node e901 = nm->mkNode(Kind::INTS_LOG2, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { size768 }),n769 }) });
Node e902 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { size768 }),n769 });
Node e903 = nm->mkNode(Kind::INTS_LOG2, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { size763 }),n764 }) });
Node e904 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { size763 }),n764 });
Node e905 = nm->mkNode(Kind::INTS_LOG2, { n757 });
Node e906 = nm->mkNode(Kind::BITVECTOR_SIZE, { x744 });
Node e907 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n740 });
Node e908 = nm->mkConst(false);
Node e909 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n733 });
Node e910 = nm->mkNode(Kind::BITVECTOR_SIZE, { x713 });
Node e911 = nm->mkNode(Kind::BITVECTOR_SIZE, { x710 });
Node e912 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n709 });
Node e913 = nm->mkNode(Kind::BITVECTOR_SIZE, { y700 });
Node e914 = nm->mkNode(Kind::BITVECTOR_SIZE, { y693 });
Node e915 = nm->mkNode(Kind::BITVECTOR_SIZE, { y686 });
Node e916 = nm->mkNode(Kind::BITVECTOR_SIZE, { x680 });
Node e917 = nm->mkNode(Kind::BITVECTOR_SIZE, { x676 });
Node e918 = nm->mkNode(Kind::BITVECTOR_SIZE, { x667 });
Node e919 = nm->mkNode(Kind::BITVECTOR_SIZE, { x661 });
Node e920 = nm->mkNode(Kind::BITVECTOR_SIZE, { x657 });
Node e921 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm->mkConstInt(Rational(1)) });

  // Rules

        {
            // from rewrites-bv-rewrites-simplification.cpp
            db.addRule(ProofRewriteRule::BV_ITE_EQUAL_CHILDREN, { c622, x623 }, nm->mkNode(Kind::BITVECTOR_ITE, { c622,x623,x623 }), x623, e895, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_CONST_CHILDREN_1, { c624 }, nm->mkNode(Kind::BITVECTOR_ITE, { c624,e921,e892 }), nm->mkNode(Kind::BITVECTOR_NOT, { c624 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_CONST_CHILDREN_2, { c625 }, nm->mkNode(Kind::BITVECTOR_ITE, { c625,e892,e921 }), c625, e895, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_EQUAL_COND_1, { c0626, t0627, e0628, e1629 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0626,nm->mkNode(Kind::BITVECTOR_ITE, { c0626,t0627,e0628 }),e1629 }), nm->mkNode(Kind::BITVECTOR_ITE, { c0626,t0627,e1629 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_EQUAL_COND_2, { c0630, t0631, t1632, e1633 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0630,t0631,nm->mkNode(Kind::BITVECTOR_ITE, { c0630,t1632,e1633 }) }), nm->mkNode(Kind::BITVECTOR_ITE, { c0630,t0631,e1633 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_EQUAL_COND_3, { c0634, t0635, e0636, t1637, e1638 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0634,nm->mkNode(Kind::BITVECTOR_ITE, { c0634,t0635,e0636 }),nm->mkNode(Kind::BITVECTOR_ITE, { c0634,t1637,e1638 }) }), nm->mkNode(Kind::BITVECTOR_ITE, { c0634,t0635,e1638 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_MERGE_THEN_IF, { c0639, c1640, t1641, e1642 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0639,nm->mkNode(Kind::BITVECTOR_ITE, { c1640,t1641,e1642 }),t1641 }), nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::BITVECTOR_AND, { c0639,nm->mkNode(Kind::BITVECTOR_NOT, { c1640 }) }),e1642,t1641 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_MERGE_ELSE_IF, { c0643, c1644, t1645, e1646 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0643,nm->mkNode(Kind::BITVECTOR_ITE, { c1644,t1645,e1646 }),e1646 }), nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::BITVECTOR_AND, { c0643,c1644 }),t1645,e1646 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_MERGE_THEN_ELSE, { c0647, c1648, t0649, e1650 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0647,t0649,nm->mkNode(Kind::BITVECTOR_ITE, { c1648,t0649,e1650 }) }), nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::BITVECTOR_NOR, { c0647,c1648 }),e1650,t0649 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_MERGE_ELSE_ELSE, { c0651, c1652, t1653, t0654 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0651,t0654,nm->mkNode(Kind::BITVECTOR_ITE, { c1652,t1653,t0654 }) }), nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::BITVECTOR_NOT, { c0651 }),c1652 }),t1653,t0654 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_SHL_BY_CONST_0, { x655, sz656 }, nm->mkNode(Kind::BITVECTOR_SHL, { x655,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,sz656 }) }), x655, e895, Node::null());
db.addRule(ProofRewriteRule::BV_SHL_BY_CONST_1, { x657, amount658, sz659, en660 }, nm->mkNode(Kind::BITVECTOR_SHL, { x657,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount658,sz659 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),en660,e874,x657 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,amount658 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { amount658,e920 }),nm->mkNode(Kind::EQUAL, { en660,nm->mkNode(Kind::SUB, { e920,nm->mkNode(Kind::ADD, { e870,amount658 }) }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SHL_BY_CONST_2, { x661, amount662, sz663, w664 }, nm->mkNode(Kind::BITVECTOR_SHL, { x661,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount662,sz663 }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,w664 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { amount662,e919 }),nm->mkNode(Kind::EQUAL, { w664,e919 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_LSHR_BY_CONST_0, { x665, sz666 }, nm->mkNode(Kind::BITVECTOR_LSHR, { x665,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,sz666 }) }), x665, e895, Node::null());
db.addRule(ProofRewriteRule::BV_LSHR_BY_CONST_1, { x667, amount668, sz669, nm1670 }, nm->mkNode(Kind::BITVECTOR_LSHR, { x667,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount668,sz669 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,amount668 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1670,amount668,x667 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { amount668,e918 }),nm->mkNode(Kind::EQUAL, { nm1670,nm->mkNode(Kind::SUB, { e918,e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_LSHR_BY_CONST_2, { x671, amount672, sz673 }, nm->mkNode(Kind::BITVECTOR_LSHR, { x671,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount672,sz673 }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,sz673 }), nm->mkNode(Kind::GEQ, { amount672,nm->mkNode(Kind::BITVECTOR_SIZE, { x671 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ASHR_BY_CONST_0, { x674, sz675 }, nm->mkNode(Kind::BITVECTOR_ASHR, { x674,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,sz675 }) }), x674, e895, Node::null());
db.addRule(ProofRewriteRule::BV_ASHR_BY_CONST_1, { x676, amount677, sz678, nm1679 }, nm->mkNode(Kind::BITVECTOR_ASHR, { x676,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount677,sz678 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),amount677,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1679,nm1679,x676 }) }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1679,amount677,x676 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { amount677,e917 }),nm->mkNode(Kind::EQUAL, { nm1679,nm->mkNode(Kind::SUB, { e917,e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ASHR_BY_CONST_2, { x680, amount681, sz682, nm1683, rn684 }, nm->mkNode(Kind::BITVECTOR_ASHR, { x680,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount681,sz682 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),rn684,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1683,nm1683,x680 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { amount681,e916 }),nm->mkNode(Kind::EQUAL, { nm1683,nm->mkNode(Kind::SUB, { e916,e870 }) }),nm->mkNode(Kind::EQUAL, { rn684,e916 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_AND_CONCAT_PULLUP, { x685, y686, z687, ys688, nxm1689, ny690, nym1691 }, nm->mkNode(Kind::BITVECTOR_AND, { x685,nm->mkNode(Kind::BITVECTOR_CONCAT, { ys688,z687,y686 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nxm1689,ny690,x685 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { ys688,z687 }) }),nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nym1691,e874,x685 }),y686 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { ny690,e915 }),nm->mkNode(Kind::EQUAL, { nxm1689,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x685 }),e870 }) }),nm->mkNode(Kind::EQUAL, { nym1691,nm->mkNode(Kind::SUB, { e915,e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_OR_CONCAT_PULLUP, { x692, y693, z694, ys695, nxm1696, ny697, nym1698 }, nm->mkNode(Kind::BITVECTOR_OR, { x692,nm->mkNode(Kind::BITVECTOR_CONCAT, { ys695,z694,y693 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nxm1696,ny697,x692 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { ys695,z694 }) }),nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nym1698,e874,x692 }),y693 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { ny697,e914 }),nm->mkNode(Kind::EQUAL, { nxm1696,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x692 }),e870 }) }),nm->mkNode(Kind::EQUAL, { nym1698,nm->mkNode(Kind::SUB, { e914,e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_XOR_CONCAT_PULLUP, { x699, y700, z701, ys702, nxm1703, ny704, nym1705 }, nm->mkNode(Kind::BITVECTOR_XOR, { x699,nm->mkNode(Kind::BITVECTOR_CONCAT, { ys702,z701,y700 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nxm1703,ny704,x699 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { ys702,z701 }) }),nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nym1705,e874,x699 }),y700 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { ny704,e913 }),nm->mkNode(Kind::EQUAL, { nxm1703,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x699 }),e870 }) }),nm->mkNode(Kind::EQUAL, { nym1705,nm->mkNode(Kind::SUB, { e913,e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_BITWISE_IDEMP_1, { x706 }, nm->mkNode(Kind::BITVECTOR_AND, { x706,x706 }), x706, e895, Node::null());
db.addRule(ProofRewriteRule::BV_BITWISE_IDEMP_2, { x707 }, nm->mkNode(Kind::BITVECTOR_OR, { x707,x707 }), x707, e895, Node::null());
db.addRule(ProofRewriteRule::BV_AND_ZERO, { x708, n709 }, nm->mkNode(Kind::BITVECTOR_AND, { x708,e912 }), e912, e895, Node::null());
db.addRule(ProofRewriteRule::BV_AND_ONE, { x710, n711, w712 }, nm->mkNode(Kind::BITVECTOR_AND, { x710,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n711,w712 }) }), x710, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { w712,e911 }),nm->mkNode(Kind::EQUAL, { n711,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { e911 }),e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_OR_ONE, { x713, n714, w715 }, nm->mkNode(Kind::BITVECTOR_OR, { x713,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n714,w715 }) }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,w715 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { w715,e910 }),nm->mkNode(Kind::EQUAL, { n714,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { e910 }),e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_XOR_DUPLICATE, { x716, w717 }, nm->mkNode(Kind::BITVECTOR_XOR, { x716,x716 }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,w717 }), nm->mkNode(Kind::EQUAL, { w717,nm->mkNode(Kind::BITVECTOR_SIZE, { x716 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_XOR_ONES, { xs718, zs719, n720, w721 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs718,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n720,w721 }),zs719 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { xs718,zs719 }) }), nm->mkNode(Kind::EQUAL, { n720,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { w721 }),e870 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_XOR_ZERO, { xs722, zs723, n724 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs722,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,n724 }),zs723 }), nm->mkNode(Kind::BITVECTOR_XOR, { xs722,zs723 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_BITWISE_NOT_AND, { x725, w726 }, nm->mkNode(Kind::BITVECTOR_AND, { x725,nm->mkNode(Kind::BITVECTOR_NOT, { x725 }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,w726 }), nm->mkNode(Kind::EQUAL, { w726,nm->mkNode(Kind::BITVECTOR_SIZE, { x725 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_BITWISE_NOT_OR, { x727, w728 }, nm->mkNode(Kind::BITVECTOR_OR, { x727,nm->mkNode(Kind::BITVECTOR_NOT, { x727 }) }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,w728 }) }), nm->mkNode(Kind::EQUAL, { w728,nm->mkNode(Kind::BITVECTOR_SIZE, { x727 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_XOR_NOT, { x729, y730 }, nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::BITVECTOR_NOT, { x729 }),nm->mkNode(Kind::BITVECTOR_NOT, { y730 }) }), nm->mkNode(Kind::BITVECTOR_XOR, { x729,y730 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_NOT_IDEMP, { x731 }, nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_NOT, { x731 }) }), x731, e895, Node::null());
db.addRule(ProofRewriteRule::BV_ULT_ZERO_1, { x732, n733 }, nm->mkNode(Kind::BITVECTOR_ULT, { e909,x732 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { x732,e909 }) }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_ULT_ZERO_2, { x734, n735 }, nm->mkNode(Kind::BITVECTOR_ULT, { x734,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,n735 }) }), e908, e895, Node::null());
db.addRule(ProofRewriteRule::BV_ULT_SELF, { x736 }, nm->mkNode(Kind::BITVECTOR_ULT, { x736,x736 }), e908, e895, Node::null());
db.addRule(ProofRewriteRule::BV_LT_SELF, { x737 }, nm->mkNode(Kind::BITVECTOR_SLT, { x737,x737 }), e908, e895, Node::null());
db.addRule(ProofRewriteRule::BV_ULE_SELF, { x738 }, nm->mkNode(Kind::BITVECTOR_ULE, { x738,x738 }), e895, e895, Node::null());
db.addRule(ProofRewriteRule::BV_ULE_ZERO, { x739, n740 }, nm->mkNode(Kind::BITVECTOR_ULE, { x739,e907 }), nm->mkNode(Kind::EQUAL, { x739,e907 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_ZERO_ULE, { x741, n742 }, nm->mkNode(Kind::BITVECTOR_ULE, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,n742 }),x741 }), e895, e895, Node::null());
db.addRule(ProofRewriteRule::BV_SLE_SELF, { x743 }, nm->mkNode(Kind::BITVECTOR_SLE, { x743,x743 }), e895, e895, Node::null());
db.addRule(ProofRewriteRule::BV_ULE_MAX, { x744, n745, w746 }, nm->mkNode(Kind::BITVECTOR_ULE, { x744,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n745,w746 }) }), e895, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { w746,e906 }),nm->mkNode(Kind::EQUAL, { n745,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { e906 }),e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_NOT_ULT, { x747, y748 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_ULT, { x747,y748 }) }), nm->mkNode(Kind::BITVECTOR_ULE, { y748,x747 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_NOT_ULE, { x749, y750 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_ULE, { x749,y750 }) }), nm->mkNode(Kind::BITVECTOR_ULT, { y750,x749 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_NOT_SLE, { x751, y752 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_SLE, { x751,y752 }) }), nm->mkNode(Kind::BITVECTOR_SLT, { y752,x751 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_MULT_POW2_1, { xs753, ys754, z755, size756, n757, exponent758, u759 }, nm->mkNode(Kind::BITVECTOR_MULT, { xs753,z755,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n757,size756 }),ys754 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u759,e874,nm->mkNode(Kind::BITVECTOR_MULT, { xs753,z755,ys754 }) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,exponent758 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::INTS_ISPOW2, { n757 }),nm->mkNode(Kind::EQUAL, { exponent758,e905 }),nm->mkNode(Kind::EQUAL, { u759,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SUB, { size756,e905 }),e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_MULT_POW2_2, { xs760, ys761, z762, size763, n764, exponent765, u766 }, nm->mkNode(Kind::BITVECTOR_MULT, { xs760,z762,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n764,size763 }),ys761 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u766,e874,nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_MULT, { xs760,z762,ys761 }) }) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,exponent765 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::INTS_ISPOW2, { e904 }),nm->mkNode(Kind::EQUAL, { exponent765,e903 }),nm->mkNode(Kind::EQUAL, { u766,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SUB, { size763,e903 }),e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_MULT_POW2_2B, { z767, size768, n769, exponent770, u771 }, nm->mkNode(Kind::BITVECTOR_MULT, { z767,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n769,size768 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u771,e874,nm->mkNode(Kind::BITVECTOR_NEG, { z767 }) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,exponent770 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::INTS_ISPOW2, { e902 }),nm->mkNode(Kind::EQUAL, { exponent770,e901 }),nm->mkNode(Kind::EQUAL, { u771,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SUB, { size768,e901 }),e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_MULT_LEADING_BIT, { high772, low773, x1i774, x1in775, x2776, y1i777, y1in778, y2779, w780 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high772,low773,nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { x1i774,x1in775 }),x2776 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { y1i777,y1in778 }),y2779 }) }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,w780 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GT, { e900,nm->mkConstInt(Rational(64)) }),nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::MULT, { nm->mkConstInt(Rational(2)),e900 }),nm->mkNode(Kind::ADD, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { x1i774,e874 }),x1in775,nm->mkNode(Kind::SUB, { x1in775,nm->mkNode(Kind::ADD, { e870,nm->mkNode(Kind::INTS_LOG2, { x1i774 }) }) }) }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { y1i777,e874 }),y1in778,nm->mkNode(Kind::SUB, { y1in778,nm->mkNode(Kind::ADD, { e870,nm->mkNode(Kind::INTS_LOG2, { y1i777 }) }) }) }) }) }),low773 }),nm->mkNode(Kind::EQUAL, { w780,nm->mkNode(Kind::ADD, { e870,nm->mkNode(Kind::SUB, { high772,low773 }) }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_UDIV_POW2_NOT_ONE, { x781, v782, n783, power784, nm1785 }, nm->mkNode(Kind::BITVECTOR_UDIV, { x781,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { v782,n783 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,power784 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1785,power784,x781 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::INTS_ISPOW2, { v782 }),nm->mkNode(Kind::GT, { v782,e870 }),nm->mkNode(Kind::EQUAL, { power784,nm->mkNode(Kind::INTS_LOG2, { v782 }) }),nm->mkNode(Kind::EQUAL, { nm1785,nm->mkNode(Kind::SUB, { n783,e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_UDIV_ZERO, { x786, n787 }, nm->mkNode(Kind::BITVECTOR_UDIV, { x786,e899 }), nm->mkNode(Kind::BITVECTOR_NOT, { e899 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_UDIV_ONE, { x788, n789 }, nm->mkNode(Kind::BITVECTOR_UDIV, { x788,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e870,n789 }) }), x788, e895, Node::null());
db.addRule(ProofRewriteRule::BV_UREM_POW2_NOT_ONE, { x790, v791, n792, nmp793, pm1794 }, nm->mkNode(Kind::BITVECTOR_UREM, { x790,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { v791,n792 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,nmp793 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),pm1794,e874,x790 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::INTS_ISPOW2, { v791 }),nm->mkNode(Kind::GT, { v791,e870 }),nm->mkNode(Kind::EQUAL, { nmp793,nm->mkNode(Kind::SUB, { n792,e898 }) }),nm->mkNode(Kind::EQUAL, { pm1794,nm->mkNode(Kind::SUB, { e898,e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_UREM_ONE, { x795, n796 }, nm->mkNode(Kind::BITVECTOR_UREM, { x795,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e870,n796 }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,n796 }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_UREM_SELF, { x797, w798 }, nm->mkNode(Kind::BITVECTOR_UREM, { x797,x797 }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,w798 }), nm->mkNode(Kind::EQUAL, { w798,nm->mkNode(Kind::BITVECTOR_SIZE, { x797 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SHL_ZERO, { a799, n800 }, nm->mkNode(Kind::BITVECTOR_SHL, { e897,a799 }), e897, e895, Node::null());
db.addRule(ProofRewriteRule::BV_LSHR_ZERO, { a801, n802 }, nm->mkNode(Kind::BITVECTOR_LSHR, { e896,a801 }), e896, e895, Node::null());
db.addRule(ProofRewriteRule::BV_ASHR_ZERO, { a803, n804 }, nm->mkNode(Kind::BITVECTOR_ASHR, { e894,a803 }), e894, e895, Node::null());
db.addRule(ProofRewriteRule::BV_UGT_UREM, { y805, x806, w807 }, nm->mkNode(Kind::BITVECTOR_UGT, { nm->mkNode(Kind::BITVECTOR_UREM, { y805,x806 }),x806 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { x806,e893 }),nm->mkNode(Kind::BITVECTOR_UGT, { y805,e893 }) }), nm->mkNode(Kind::EQUAL, { w807,nm->mkNode(Kind::BITVECTOR_SIZE, { y805 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ULT_ONE, { x808, n809 }, nm->mkNode(Kind::BITVECTOR_ULT, { x808,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e870,n809 }) }), nm->mkNode(Kind::EQUAL, { x808,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,n809 }) }), e895, Node::null());
db.addRule(ProofRewriteRule::BV_SLT_ZERO, { x810, n811, nm1812 }, nm->mkNode(Kind::BITVECTOR_SLT, { x810,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,n811 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1812,nm1812,x810 }),e892 }), nm->mkNode(Kind::EQUAL, { nm1812,nm->mkNode(Kind::SUB, { n811,e870 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_MERGE_SIGN_EXTEND_1, { x813, i814, j815, k816 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),i814,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),j815,x813 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),k816,x813 }), nm->mkNode(Kind::EQUAL, { k816,nm->mkNode(Kind::ADD, { i814,j815 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_MERGE_SIGN_EXTEND_2, { x817, i818, j819, k820 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),i818,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),j819,x817 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),k820,x817 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GT, { j819,e870 }),nm->mkNode(Kind::EQUAL, { k820,nm->mkNode(Kind::ADD, { i818,j819 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_MERGE_SIGN_EXTEND_3, { x821, i822, n0823 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),i822,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),n0823,x821 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),i822,x821 }), nm->mkNode(Kind::EQUAL, { n0823,e874 }), Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_EQ_CONST_1, { x824, m825, c826, nm827, mp1828, nm1829, nmm1830 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m825,x824 }),e889 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { nm->mkNode(Kind::EQUAL, { e891,e890 }),nm->mkNode(Kind::EQUAL, { e891,nm->mkNode(Kind::BITVECTOR_NOT, { e890 }) }) }),nm->mkNode(Kind::EQUAL, { x824,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1829,e874,e889 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { mp1828,nm->mkNode(Kind::ADD, { m825,e870 }) }),nm->mkNode(Kind::EQUAL, { nm1829,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x824 }),e870 }) }),nm->mkNode(Kind::EQUAL, { nmm1830,nm->mkNode(Kind::SUB, { nm827,e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_EQ_CONST_2, { x831, m832, c833, nm834, mp1835, nm1836, nmm1837 }, nm->mkNode(Kind::EQUAL, { e886,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m832,x831 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { nm->mkNode(Kind::EQUAL, { e888,e887 }),nm->mkNode(Kind::EQUAL, { e888,nm->mkNode(Kind::BITVECTOR_NOT, { e887 }) }) }),nm->mkNode(Kind::EQUAL, { x831,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1836,e874,e886 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { mp1835,nm->mkNode(Kind::ADD, { m832,e870 }) }),nm->mkNode(Kind::EQUAL, { nm1836,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x831 }),e870 }) }),nm->mkNode(Kind::EQUAL, { nmm1837,nm->mkNode(Kind::SUB, { nm834,e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_EQ_CONST_1, { x838, m839, c840, nm841, nm1842, nmm1843 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),m839,x838 }),e885 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nmm1843,nm1842,e885 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,m839 }) }),nm->mkNode(Kind::EQUAL, { x838,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1842,e874,e885 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm1842,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x838 }),e870 }) }),nm->mkNode(Kind::EQUAL, { nmm1843,nm->mkNode(Kind::SUB, { nm841,e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_EQ_CONST_2, { x844, m845, c846, nm847, nm1848, nmm1849 }, nm->mkNode(Kind::EQUAL, { e884,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),m845,x844 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nmm1849,nm1848,e884 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,m845 }) }),nm->mkNode(Kind::EQUAL, { x844,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1848,e874,e884 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm1848,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x844 }),e870 }) }),nm->mkNode(Kind::EQUAL, { nmm1849,nm->mkNode(Kind::SUB, { nm847,e870 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ULT_CONST_1, { x850, m851, c852, nm853, nm1854 }, nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m851,x850 }),e881 }), nm->mkNode(Kind::BITVECTOR_ULT, { x850,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1854,e874,e881 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { nm->mkNode(Kind::BITVECTOR_ULE, { e881,nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e870,nm853 }),e883 }) }),nm->mkNode(Kind::BITVECTOR_UGE, { e881,nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,nm853 }) }),e883 }) }) }),nm->mkNode(Kind::EQUAL, { nm1854,e882 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ULT_CONST_2, { x855, m856, c857, nm858, nm1859 }, nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m856,x855 }),e879 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1859,nm1859,x855 }),e921 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e870,nm858 }),e880 }),e879 }),nm->mkNode(Kind::BITVECTOR_ULE, { e879,nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,nm858 }) }),e880 }) }),nm->mkNode(Kind::EQUAL, { nm1859,e878 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ULT_CONST_3, { x860, m861, c862, nm863, nm1864 }, nm->mkNode(Kind::BITVECTOR_ULT, { e875,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m861,x860 }) }), nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1864,e874,e875 }),x860 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { nm->mkNode(Kind::BITVECTOR_ULT, { e875,e877 }),nm->mkNode(Kind::BITVECTOR_UGE, { e875,nm->mkNode(Kind::BITVECTOR_NOT, { e877 }) }) }),nm->mkNode(Kind::EQUAL, { nm1864,e876 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ULT_CONST_4, { x865, m866, c867, nm868, nm1869 }, nm->mkNode(Kind::BITVECTOR_ULT, { e872,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m866,x865 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1869,nm1869,x865 }),e892 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::BITVECTOR_ULE, { nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e874,nm868 }) }),e873 }) }),e872 }),nm->mkNode(Kind::BITVECTOR_ULE, { e872,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e870,nm868 }),e873 }) }) }),nm->mkNode(Kind::EQUAL, { nm1869,e871 }) }), Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
