/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_bv_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node xs243 = NodeManager::mkBoundVar("xs243", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs243);
Node s244 = NodeManager::mkBoundVar("s244", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys245 = NodeManager::mkBoundVar("ys245", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys245);
Node zs246 = NodeManager::mkBoundVar("zs246", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs246);
Node t468 = NodeManager::mkBoundVar("t468", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs247 = NodeManager::mkBoundVar("xs247", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs247);
Node s248 = NodeManager::mkBoundVar("s248", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys249 = NodeManager::mkBoundVar("ys249", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys249);
Node i250 = NodeManager::mkBoundVar("i250", nm->integerType());
Node j251 = NodeManager::mkBoundVar("j251", nm->integerType());
Node j1252 = NodeManager::mkBoundVar("j1252", nm->integerType());
Node k253 = NodeManager::mkBoundVar("k253", nm->integerType());
Node x254 = NodeManager::mkBoundVar("x254", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i255 = NodeManager::mkBoundVar("i255", nm->integerType());
Node j256 = NodeManager::mkBoundVar("j256", nm->integerType());
Node k257 = NodeManager::mkBoundVar("k257", nm->integerType());
Node l258 = NodeManager::mkBoundVar("l258", nm->integerType());
Node ll259 = NodeManager::mkBoundVar("ll259", nm->integerType());
Node kk260 = NodeManager::mkBoundVar("kk260", nm->integerType());
Node x261 = NodeManager::mkBoundVar("x261", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n262 = NodeManager::mkBoundVar("n262", nm->integerType());
Node x263 = NodeManager::mkBoundVar("x263", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs264 = NodeManager::mkBoundVar("xs264", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs264);
Node y265 = NodeManager::mkBoundVar("y265", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i266 = NodeManager::mkBoundVar("i266", nm->integerType());
Node j267 = NodeManager::mkBoundVar("j267", nm->integerType());
Node x268 = NodeManager::mkBoundVar("x268", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs269 = NodeManager::mkBoundVar("xs269", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs269);
Node y270 = NodeManager::mkBoundVar("y270", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i271 = NodeManager::mkBoundVar("i271", nm->integerType());
Node j272 = NodeManager::mkBoundVar("j272", nm->integerType());
Node u1273 = NodeManager::mkBoundVar("u1273", nm->integerType());
Node u2274 = NodeManager::mkBoundVar("u2274", nm->integerType());
Node x275 = NodeManager::mkBoundVar("x275", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y276 = NodeManager::mkBoundVar("y276", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs277 = NodeManager::mkBoundVar("xs277", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs277);
Node i278 = NodeManager::mkBoundVar("i278", nm->integerType());
Node j279 = NodeManager::mkBoundVar("j279", nm->integerType());
Node u2280 = NodeManager::mkBoundVar("u2280", nm->integerType());
Node l2281 = NodeManager::mkBoundVar("l2281", nm->integerType());
Node x282 = NodeManager::mkBoundVar("x282", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y283 = NodeManager::mkBoundVar("y283", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs284 = NodeManager::mkBoundVar("xs284", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs284);
Node i285 = NodeManager::mkBoundVar("i285", nm->integerType());
Node j286 = NodeManager::mkBoundVar("j286", nm->integerType());
Node x287 = NodeManager::mkBoundVar("x287", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y288 = NodeManager::mkBoundVar("y288", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i289 = NodeManager::mkBoundVar("i289", nm->integerType());
Node j290 = NodeManager::mkBoundVar("j290", nm->integerType());
Node wm1291 = NodeManager::mkBoundVar("wm1291", nm->integerType());
Node jp1292 = NodeManager::mkBoundVar("jp1292", nm->integerType());
Node im1293 = NodeManager::mkBoundVar("im1293", nm->integerType());
Node x294 = NodeManager::mkBoundVar("x294", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y295 = NodeManager::mkBoundVar("y295", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node j296 = NodeManager::mkBoundVar("j296", nm->integerType());
Node wm1297 = NodeManager::mkBoundVar("wm1297", nm->integerType());
Node jp1298 = NodeManager::mkBoundVar("jp1298", nm->integerType());
Node x299 = NodeManager::mkBoundVar("x299", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y300 = NodeManager::mkBoundVar("y300", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i301 = NodeManager::mkBoundVar("i301", nm->integerType());
Node j302 = NodeManager::mkBoundVar("j302", nm->integerType());
Node im1303 = NodeManager::mkBoundVar("im1303", nm->integerType());
Node x304 = NodeManager::mkBoundVar("x304", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y305 = NodeManager::mkBoundVar("y305", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i306 = NodeManager::mkBoundVar("i306", nm->integerType());
Node j307 = NodeManager::mkBoundVar("j307", nm->integerType());
Node x308 = NodeManager::mkBoundVar("x308", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y309 = NodeManager::mkBoundVar("y309", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i310 = NodeManager::mkBoundVar("i310", nm->integerType());
Node j311 = NodeManager::mkBoundVar("j311", nm->integerType());
Node x312 = NodeManager::mkBoundVar("x312", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y313 = NodeManager::mkBoundVar("y313", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i314 = NodeManager::mkBoundVar("i314", nm->integerType());
Node j315 = NodeManager::mkBoundVar("j315", nm->integerType());
Node x316 = NodeManager::mkBoundVar("x316", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i317 = NodeManager::mkBoundVar("i317", nm->integerType());
Node j318 = NodeManager::mkBoundVar("j318", nm->integerType());
Node x319 = NodeManager::mkBoundVar("x319", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node low320 = NodeManager::mkBoundVar("low320", nm->integerType());
Node high321 = NodeManager::mkBoundVar("high321", nm->integerType());
Node k322 = NodeManager::mkBoundVar("k322", nm->integerType());
Node x323 = NodeManager::mkBoundVar("x323", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node low324 = NodeManager::mkBoundVar("low324", nm->integerType());
Node high325 = NodeManager::mkBoundVar("high325", nm->integerType());
Node k326 = NodeManager::mkBoundVar("k326", nm->integerType());
Node nm1327 = NodeManager::mkBoundVar("nm1327", nm->integerType());
Node sn328 = NodeManager::mkBoundVar("sn328", nm->integerType());
Node x329 = NodeManager::mkBoundVar("x329", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node low330 = NodeManager::mkBoundVar("low330", nm->integerType());
Node high331 = NodeManager::mkBoundVar("high331", nm->integerType());
Node k332 = NodeManager::mkBoundVar("k332", nm->integerType());
Node rn333 = NodeManager::mkBoundVar("rn333", nm->integerType());
Node nm1334 = NodeManager::mkBoundVar("nm1334", nm->integerType());
Node xs335 = NodeManager::mkBoundVar("xs335", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys336 = NodeManager::mkBoundVar("ys336", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n337 = NodeManager::mkBoundVar("n337", nm->integerType());
Node m338 = NodeManager::mkBoundVar("m338", nm->integerType());
Node x339 = NodeManager::mkBoundVar("x339", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y340 = NodeManager::mkBoundVar("y340", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node zs341 = NodeManager::mkBoundVar("zs341", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs341);
Node t469 = NodeManager::mkBoundVar("t469", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x342 = NodeManager::mkBoundVar("x342", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n343 = NodeManager::mkBoundVar("n343", nm->integerType());
Node m344 = NodeManager::mkBoundVar("m344", nm->integerType());
Node x345 = NodeManager::mkBoundVar("x345", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y346 = NodeManager::mkBoundVar("y346", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n347 = NodeManager::mkBoundVar("n347", nm->integerType());
Node m348 = NodeManager::mkBoundVar("m348", nm->integerType());
Node x349 = NodeManager::mkBoundVar("x349", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y350 = NodeManager::mkBoundVar("y350", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n351 = NodeManager::mkBoundVar("n351", nm->integerType());
Node m352 = NodeManager::mkBoundVar("m352", nm->integerType());
Node x1353 = NodeManager::mkBoundVar("x1353", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x2354 = NodeManager::mkBoundVar("x2354", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y355 = NodeManager::mkBoundVar("y355", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x1356 = NodeManager::mkBoundVar("x1356", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x2357 = NodeManager::mkBoundVar("x2357", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y358 = NodeManager::mkBoundVar("y358", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x359 = NodeManager::mkBoundVar("x359", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs360 = NodeManager::mkBoundVar("xs360", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs360);
Node xs361 = NodeManager::mkBoundVar("xs361", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs361);
Node ys362 = NodeManager::mkBoundVar("ys362", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys362);
Node zs363 = NodeManager::mkBoundVar("zs363", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs363);
Node x364 = NodeManager::mkBoundVar("x364", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t470 = NodeManager::mkBoundVar("t470", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs365 = NodeManager::mkBoundVar("xs365", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs365);
Node ys366 = NodeManager::mkBoundVar("ys366", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys366);
Node zs367 = NodeManager::mkBoundVar("zs367", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs367);
Node x368 = NodeManager::mkBoundVar("x368", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w369 = NodeManager::mkBoundVar("w369", nm->integerType());
Node xs370 = NodeManager::mkBoundVar("xs370", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs370);
Node ys371 = NodeManager::mkBoundVar("ys371", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys371);
Node zs372 = NodeManager::mkBoundVar("zs372", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs372);
Node x373 = NodeManager::mkBoundVar("x373", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t471 = NodeManager::mkBoundVar("t471", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs374 = NodeManager::mkBoundVar("xs374", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs374);
Node ys375 = NodeManager::mkBoundVar("ys375", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys375);
Node zs376 = NodeManager::mkBoundVar("zs376", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs376);
Node x377 = NodeManager::mkBoundVar("x377", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w378 = NodeManager::mkBoundVar("w378", nm->integerType());
Node xs379 = NodeManager::mkBoundVar("xs379", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs379);
Node ys380 = NodeManager::mkBoundVar("ys380", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys380);
Node zs381 = NodeManager::mkBoundVar("zs381", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs381);
Node x382 = NodeManager::mkBoundVar("x382", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t472 = NodeManager::mkBoundVar("t472", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs383 = NodeManager::mkBoundVar("xs383", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs383);
Node ys384 = NodeManager::mkBoundVar("ys384", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys384);
Node zs385 = NodeManager::mkBoundVar("zs385", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs385);
Node x386 = NodeManager::mkBoundVar("x386", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs387 = NodeManager::mkBoundVar("xs387", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs387);
Node ys388 = NodeManager::mkBoundVar("ys388", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys388);
Node zs389 = NodeManager::mkBoundVar("zs389", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs389);
Node x390 = NodeManager::mkBoundVar("x390", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x391 = NodeManager::mkBoundVar("x391", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y392 = NodeManager::mkBoundVar("y392", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c1393 = NodeManager::mkBoundVar("c1393", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w394 = NodeManager::mkBoundVar("w394", nm->integerType());
Node x395 = NodeManager::mkBoundVar("x395", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i396 = NodeManager::mkBoundVar("i396", nm->integerType());
Node m397 = NodeManager::mkBoundVar("m397", nm->integerType());
Node n0398 = NodeManager::mkBoundVar("n0398", nm->integerType());
Node w399 = NodeManager::mkBoundVar("w399", nm->integerType());
Node x400 = NodeManager::mkBoundVar("x400", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t401 = NodeManager::mkBoundVar("t401", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node a402 = NodeManager::mkBoundVar("a402", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n403 = NodeManager::mkBoundVar("n403", nm->integerType());
Node m404 = NodeManager::mkBoundVar("m404", nm->integerType());
Node tn405 = NodeManager::mkBoundVar("tn405", nm->integerType());
Node an406 = NodeManager::mkBoundVar("an406", nm->integerType());
Node x407 = NodeManager::mkBoundVar("x407", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t408 = NodeManager::mkBoundVar("t408", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node a409 = NodeManager::mkBoundVar("a409", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n410 = NodeManager::mkBoundVar("n410", nm->integerType());
Node m411 = NodeManager::mkBoundVar("m411", nm->integerType());
Node tn412 = NodeManager::mkBoundVar("tn412", nm->integerType());
Node an413 = NodeManager::mkBoundVar("an413", nm->integerType());
Node x414 = NodeManager::mkBoundVar("x414", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y415 = NodeManager::mkBoundVar("y415", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x416 = NodeManager::mkBoundVar("x416", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y417 = NodeManager::mkBoundVar("y417", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x418 = NodeManager::mkBoundVar("x418", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y419 = NodeManager::mkBoundVar("y419", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x420 = NodeManager::mkBoundVar("x420", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y421 = NodeManager::mkBoundVar("y421", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x422 = NodeManager::mkBoundVar("x422", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n423 = NodeManager::mkBoundVar("n423", nm->integerType());
Node x424 = NodeManager::mkBoundVar("x424", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w425 = NodeManager::mkBoundVar("w425", nm->integerType());
Node x426 = NodeManager::mkBoundVar("x426", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w427 = NodeManager::mkBoundVar("w427", nm->integerType());
Node x428 = NodeManager::mkBoundVar("x428", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w429 = NodeManager::mkBoundVar("w429", nm->integerType());
Node x430 = NodeManager::mkBoundVar("x430", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w431 = NodeManager::mkBoundVar("w431", nm->integerType());
Node x432 = NodeManager::mkBoundVar("x432", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x433 = NodeManager::mkBoundVar("x433", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x434 = NodeManager::mkBoundVar("x434", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x435 = NodeManager::mkBoundVar("x435", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n436 = NodeManager::mkBoundVar("n436", nm->integerType());
Node w437 = NodeManager::mkBoundVar("w437", nm->integerType());
Node xs438 = NodeManager::mkBoundVar("xs438", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs438);
Node s439 = NodeManager::mkBoundVar("s439", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys440 = NodeManager::mkBoundVar("ys440", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys440);
Node zs441 = NodeManager::mkBoundVar("zs441", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs441);
Node t473 = NodeManager::mkBoundVar("t473", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs442 = NodeManager::mkBoundVar("xs442", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs442);
Node s443 = NodeManager::mkBoundVar("s443", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys444 = NodeManager::mkBoundVar("ys444", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys444);
Node zs445 = NodeManager::mkBoundVar("zs445", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs445);
Node t474 = NodeManager::mkBoundVar("t474", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs446 = NodeManager::mkBoundVar("xs446", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs446);
Node s447 = NodeManager::mkBoundVar("s447", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys448 = NodeManager::mkBoundVar("ys448", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys448);
Node zs449 = NodeManager::mkBoundVar("zs449", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs449);
Node t475 = NodeManager::mkBoundVar("t475", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs450 = NodeManager::mkBoundVar("xs450", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs450);
Node s451 = NodeManager::mkBoundVar("s451", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys452 = NodeManager::mkBoundVar("ys452", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys452);
Node zs453 = NodeManager::mkBoundVar("zs453", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs453);
Node t476 = NodeManager::mkBoundVar("t476", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs454 = NodeManager::mkBoundVar("xs454", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs454);
Node n1455 = NodeManager::mkBoundVar("n1455", nm->integerType());
Node w1456 = NodeManager::mkBoundVar("w1456", nm->integerType());
Node n2457 = NodeManager::mkBoundVar("n2457", nm->integerType());
Node w2458 = NodeManager::mkBoundVar("w2458", nm->integerType());
Node ww459 = NodeManager::mkBoundVar("ww459", nm->integerType());
Node zs460 = NodeManager::mkBoundVar("zs460", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs460);
Node x461 = NodeManager::mkBoundVar("x461", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y462 = NodeManager::mkBoundVar("y462", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x463 = NodeManager::mkBoundVar("x463", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y464 = NodeManager::mkBoundVar("y464", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x465 = NodeManager::mkBoundVar("x465", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x466 = NodeManager::mkBoundVar("x466", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y467 = NodeManager::mkBoundVar("y467", nm->mkAbstractType(Kind::BITVECTOR_TYPE));

  // Definitions
Node e477 = nm->mkConst(true);
Node e478 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n436,w437 });
Node e479 = nm->mkConstInt(Rational(0));
Node e480 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),w427 });
Node e481 = nm->mkConstInt(Rational(1));
Node e482 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),an413 });
Node e483 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m411,a409 });
Node e484 = nm->mkNode(Kind::BITVECTOR_ADD, { x407,t408 });
Node e485 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),an406 });
Node e486 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m404,a402 });
Node e487 = nm->mkNode(Kind::BITVECTOR_ADD, { x400,t401 });
Node e488 = nm->mkNode(Kind::BITVECTOR_SIZE, { x395 });
Node e489 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n351,m352 });
Node e490 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n347,m348 });
Node e491 = nm->mkNode(Kind::BITVECTOR_SIZE, { x329 });
Node e492 = nm->mkNode(Kind::BITVECTOR_SIZE, { x323 });
Node e493 = nm->mkNode(Kind::BITVECTOR_CONCAT, { x282,xs284,y283 });
Node e494 = nm->mkNode(Kind::BITVECTOR_SIZE, { x275 });
Node e495 = nm->mkNode(Kind::BITVECTOR_SIZE, { x268 });

  // Rules

        {
            // from rewrites-bv-rewrites.cpp
            db.addRule(ProofRewriteRule::BV_CONCAT_FLATTEN, { xs243, s244, ys245, zs246 }, nm->mkNode(Kind::BITVECTOR_CONCAT, { xs243,nm->mkNode(Kind::BITVECTOR_CONCAT, { s244,ys245 }),zs246 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { xs243,s244,ys245,zs246 }), e477, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t468 }),t468 }));
db.addRule(ProofRewriteRule::BV_CONCAT_EXTRACT_MERGE, { xs247, s248, ys249, i250, j251, j1252, k253 }, nm->mkNode(Kind::BITVECTOR_CONCAT, { xs247,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),k253,j1252,s248 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j251,i250,s248 }),ys249 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { xs247,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),k253,i250,s248 }),ys249 }), nm->mkNode(Kind::EQUAL, { j1252,nm->mkNode(Kind::ADD, { j251,e481 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_EXTRACT, { x254, i255, j256, k257, l258, ll259, kk260 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),l258,k257,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j256,i255,x254 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),ll259,kk260,x254 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { ll259,nm->mkNode(Kind::ADD, { i255,l258 }) }),nm->mkNode(Kind::EQUAL, { kk260,nm->mkNode(Kind::ADD, { i255,k257 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_WHOLE, { x261, n262 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),n262,e479,x261 }), x261, nm->mkNode(Kind::GEQ, { n262,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x261 }),e481 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_CONCAT_1, { x263, xs264, y265, i266, j267 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j267,i266,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs264,y265,x263 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j267,i266,x263 }), nm->mkNode(Kind::LEQ, { j267,nm->mkNode(Kind::BITVECTOR_SIZE, { x263 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_CONCAT_2, { x268, xs269, y270, i271, j272, u1273, u2274 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j272,i271,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs269,y270,x268 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u1273,e479,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs269,y270 }) }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u2274,i271,x268 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { i271,e495 }),nm->mkNode(Kind::GEQ, { j272,e495 }),nm->mkNode(Kind::EQUAL, { u1273,nm->mkNode(Kind::SUB, { j272,e495 }) }),nm->mkNode(Kind::EQUAL, { u2274,nm->mkNode(Kind::SUB, { e495,e481 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_CONCAT_3, { x275, y276, xs277, i278, j279, u2280, l2281 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j279,i278,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs277,y276,x275 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u2280,l2281,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs277,y276 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { i278,e494 }),nm->mkNode(Kind::EQUAL, { u2280,nm->mkNode(Kind::SUB, { j279,e494 }) }),nm->mkNode(Kind::EQUAL, { l2281,nm->mkNode(Kind::SUB, { i278,e494 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_CONCAT_4, { x282, y283, xs284, i285, j286 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j286,i285,e493 }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j286,i285,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs284,y283 }) }), nm->mkNode(Kind::LT, { j286,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { e493 }),nm->mkNode(Kind::BITVECTOR_SIZE, { x282 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EQ_EXTRACT_ELIM1, { x287, y288, i289, j290, wm1291, jp1292, im1293 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j290,i289,x287 }),y288 }), nm->mkNode(Kind::EQUAL, { x287,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1291,jp1292,x287 }),y288,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),im1293,e479,x287 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { wm1291,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x287 }),e481 }) }),nm->mkNode(Kind::EQUAL, { jp1292,nm->mkNode(Kind::ADD, { j290,e481 }) }),nm->mkNode(Kind::EQUAL, { im1293,nm->mkNode(Kind::SUB, { i289,e481 }) }),nm->mkNode(Kind::GT, { wm1291,j290 }),nm->mkNode(Kind::GT, { i289,e479 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EQ_EXTRACT_ELIM2, { x294, y295, j296, wm1297, jp1298 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j296,e479,x294 }),y295 }), nm->mkNode(Kind::EQUAL, { x294,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1297,jp1298,x294 }),y295 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { wm1297,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x294 }),e481 }) }),nm->mkNode(Kind::EQUAL, { jp1298,nm->mkNode(Kind::ADD, { j296,e481 }) }),nm->mkNode(Kind::GT, { wm1297,j296 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EQ_EXTRACT_ELIM3, { x299, y300, i301, j302, im1303 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j302,i301,x299 }),y300 }), nm->mkNode(Kind::EQUAL, { x299,nm->mkNode(Kind::BITVECTOR_CONCAT, { y300,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),im1303,e479,x299 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { j302,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x299 }),e481 }) }),nm->mkNode(Kind::EQUAL, { im1303,nm->mkNode(Kind::SUB, { i301,e481 }) }),nm->mkNode(Kind::GT, { i301,e479 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_BITWISE_AND, { x304, y305, i306, j307 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j307,i306,nm->mkNode(Kind::BITVECTOR_AND, { x304,y305 }) }), nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j307,i306,x304 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j307,i306,y305 }) }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_BITWISE_OR, { x308, y309, i310, j311 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j311,i310,nm->mkNode(Kind::BITVECTOR_OR, { x308,y309 }) }), nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j311,i310,x308 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j311,i310,y309 }) }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_BITWISE_XOR, { x312, y313, i314, j315 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j315,i314,nm->mkNode(Kind::BITVECTOR_XOR, { x312,y313 }) }), nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j315,i314,x312 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j315,i314,y313 }) }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_NOT, { x316, i317, j318 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j318,i317,nm->mkNode(Kind::BITVECTOR_NOT, { x316 }) }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j318,i317,x316 }) }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_SIGN_EXTEND_1, { x319, low320, high321, k322 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high321,low320,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),k322,x319 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high321,low320,x319 }), nm->mkNode(Kind::LT, { high321,nm->mkNode(Kind::BITVECTOR_SIZE, { x319 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_SIGN_EXTEND_2, { x323, low324, high325, k326, nm1327, sn328 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high325,low324,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),k326,x323 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),sn328,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1327,low324,x323 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { low324,e492 }),nm->mkNode(Kind::GEQ, { high325,e492 }),nm->mkNode(Kind::EQUAL, { nm1327,nm->mkNode(Kind::SUB, { e492,e481 }) }),nm->mkNode(Kind::EQUAL, { sn328,nm->mkNode(Kind::ADD, { e481,nm->mkNode(Kind::SUB, { high325,e492 }) }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_SIGN_EXTEND_3, { x329, low330, high331, k332, rn333, nm1334 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high331,low330,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),k332,x329 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),rn333,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1334,nm1334,x329 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { low330,e491 }),nm->mkNode(Kind::EQUAL, { rn333,nm->mkNode(Kind::ADD, { e481,nm->mkNode(Kind::SUB, { high331,low330 }) }) }),nm->mkNode(Kind::EQUAL, { nm1334,nm->mkNode(Kind::SUB, { e491,e481 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_NEG_MULT, { xs335, ys336, n337, m338 }, nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_MULT, { xs335,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n337,m338 }),ys336 }) }), nm->mkNode(Kind::BITVECTOR_MULT, { xs335,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::NEG, { n337 }),m338 }),ys336 }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_NEG_ADD, { x339, y340, zs341 }, nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_ADD, { x339,y340,zs341 }) }), nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_ADD, { y340,zs341 }) }), e477, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t469 }),nm->mkNode(Kind::BITVECTOR_ADD, { nm->mkNode(Kind::BITVECTOR_NEG, { x339 }),t469 }) }));
db.addRule(ProofRewriteRule::BV_MULT_DISTRIB_CONST_NEG, { x342, n343, m344 }, nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::BITVECTOR_NEG, { x342 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n343,m344 }) }), nm->mkNode(Kind::BITVECTOR_MULT, { x342,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::NEG, { n343 }),m344 }) }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_MULT_DISTRIB_CONST_ADD, { x345, y346, n347, m348 }, nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::BITVECTOR_ADD, { x345,y346 }),e490 }), nm->mkNode(Kind::BITVECTOR_ADD, { nm->mkNode(Kind::BITVECTOR_MULT, { x345,e490 }),nm->mkNode(Kind::BITVECTOR_MULT, { y346,e490 }) }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_MULT_DISTRIB_CONST_SUB, { x349, y350, n351, m352 }, nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::BITVECTOR_SUB, { x349,y350 }),e489 }), nm->mkNode(Kind::BITVECTOR_SUB, { nm->mkNode(Kind::BITVECTOR_MULT, { x349,e489 }),nm->mkNode(Kind::BITVECTOR_MULT, { y350,e489 }) }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_MULT_DISTRIB_1, { x1353, x2354, y355 }, nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::BITVECTOR_ADD, { x1353,x2354 }),y355 }), nm->mkNode(Kind::BITVECTOR_ADD, { nm->mkNode(Kind::BITVECTOR_MULT, { x1353,y355 }),nm->mkNode(Kind::BITVECTOR_MULT, { x2354,y355 }) }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_MULT_DISTRIB_2, { x1356, x2357, y358 }, nm->mkNode(Kind::BITVECTOR_MULT, { y358,nm->mkNode(Kind::BITVECTOR_ADD, { x1356,x2357 }) }), nm->mkNode(Kind::BITVECTOR_ADD, { nm->mkNode(Kind::BITVECTOR_MULT, { y358,x1356 }),nm->mkNode(Kind::BITVECTOR_MULT, { y358,x2357 }) }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_NOT_XOR, { x359, xs360 }, nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { x359,xs360 }) }), nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::BITVECTOR_NOT, { x359 }),xs360 }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_AND_SIMPLIFY_1, { xs361, ys362, zs363, x364 }, nm->mkNode(Kind::BITVECTOR_AND, { xs361,x364,ys362,x364,zs363 }), nm->mkNode(Kind::BITVECTOR_AND, { xs361,x364,ys362,zs363 }), e477, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t470 }),t470 }));
db.addRule(ProofRewriteRule::BV_AND_SIMPLIFY_2, { xs365, ys366, zs367, x368, w369 }, nm->mkNode(Kind::BITVECTOR_AND, { xs365,x368,ys366,nm->mkNode(Kind::BITVECTOR_NOT, { x368 }),zs367 }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e479,w369 }), nm->mkNode(Kind::EQUAL, { w369,nm->mkNode(Kind::BITVECTOR_SIZE, { x368 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_OR_SIMPLIFY_1, { xs370, ys371, zs372, x373 }, nm->mkNode(Kind::BITVECTOR_OR, { xs370,x373,ys371,x373,zs372 }), nm->mkNode(Kind::BITVECTOR_OR, { xs370,x373,ys371,zs372 }), e477, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t471 }),t471 }));
db.addRule(ProofRewriteRule::BV_OR_SIMPLIFY_2, { xs374, ys375, zs376, x377, w378 }, nm->mkNode(Kind::BITVECTOR_OR, { xs374,x377,ys375,nm->mkNode(Kind::BITVECTOR_NOT, { x377 }),zs376 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e479,w378 }) }), nm->mkNode(Kind::EQUAL, { w378,nm->mkNode(Kind::BITVECTOR_SIZE, { x377 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_XOR_SIMPLIFY_1, { xs379, ys380, zs381, x382 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs379,x382,ys380,x382,zs381 }), nm->mkNode(Kind::BITVECTOR_XOR, { xs379,ys380,zs381 }), e477, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t472 }),t472 }));
db.addRule(ProofRewriteRule::BV_XOR_SIMPLIFY_2, { xs383, ys384, zs385, x386 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs383,x386,ys384,nm->mkNode(Kind::BITVECTOR_NOT, { x386 }),zs385 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { xs383,ys384,zs385 }) }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_XOR_SIMPLIFY_3, { xs387, ys388, zs389, x390 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs387,nm->mkNode(Kind::BITVECTOR_NOT, { x390 }),ys388,x390,zs389 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { xs387,ys388,zs389 }) }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_ULT_ADD_ONE, { x391, y392, c1393, w394 }, nm->mkNode(Kind::BITVECTOR_ULT, { x391,nm->mkNode(Kind::BITVECTOR_ADD, { y392,c1393 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { y392,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e479,w394 }) }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_ULT, { y392,x391 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { c1393,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e481,w394 }) }),nm->mkNode(Kind::EQUAL, { w394,nm->mkNode(Kind::BITVECTOR_SIZE, { y392 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_CONCAT_TO_MULT, { x395, i396, m397, n0398, w399 }, nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),i396,n0398,x395 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n0398,m397 }) }), nm->mkNode(Kind::BITVECTOR_MULT, { x395,nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e481,w399 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { m397,w399 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::ADD, { e481,i396,m397 }),e488 }),nm->mkNode(Kind::EQUAL, { n0398,e479 }),nm->mkNode(Kind::EQUAL, { w399,e488 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_MULT_SLT_MULT_1, { x400, t401, a402, n403, m404, tn405, an406 }, nm->mkNode(Kind::BITVECTOR_SLT, { nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),n403,e487 }),e486 }),nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),n403,x400 }),e486 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { t401,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e479,tn405 }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { a402,e485 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::BITVECTOR_SLT, { e487,x400 }),nm->mkNode(Kind::BITVECTOR_SGT, { a402,e485 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { tn405,nm->mkNode(Kind::BITVECTOR_SIZE, { t401 }) }),nm->mkNode(Kind::EQUAL, { an406,nm->mkNode(Kind::BITVECTOR_SIZE, { a402 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_MULT_SLT_MULT_2, { x407, t408, a409, n410, m411, tn412, an413 }, nm->mkNode(Kind::BITVECTOR_SLT, { nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),n410,e484 }),e483 }),nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),n410,x407 }),e483 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { t408,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e479,tn412 }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { a409,e482 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::BITVECTOR_ULT, { e484,x407 }),nm->mkNode(Kind::BITVECTOR_SGT, { a409,e482 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { tn412,nm->mkNode(Kind::BITVECTOR_SIZE, { t408 }) }),nm->mkNode(Kind::EQUAL, { an413,nm->mkNode(Kind::BITVECTOR_SIZE, { a409 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_AND, { x414, y415 }, nm->mkNode(Kind::BITVECTOR_AND, { x414,y415 }), nm->mkNode(Kind::BITVECTOR_AND, { y415,x414 }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_OR, { x416, y417 }, nm->mkNode(Kind::BITVECTOR_OR, { x416,y417 }), nm->mkNode(Kind::BITVECTOR_OR, { y417,x416 }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_XOR, { x418, y419 }, nm->mkNode(Kind::BITVECTOR_XOR, { x418,y419 }), nm->mkNode(Kind::BITVECTOR_XOR, { y419,x418 }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_MUL, { x420, y421 }, nm->mkNode(Kind::BITVECTOR_MULT, { x420,y421 }), nm->mkNode(Kind::BITVECTOR_MULT, { y421,x420 }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_OR_ZERO, { x422, n423 }, nm->mkNode(Kind::BITVECTOR_OR, { x422,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e479,n423 }) }), x422, e477, Node::null());
db.addRule(ProofRewriteRule::BV_MUL_ONE, { x424, w425 }, nm->mkNode(Kind::BITVECTOR_MULT, { x424,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e481,w425 }) }), x424, nm->mkNode(Kind::EQUAL, { w425,nm->mkNode(Kind::BITVECTOR_SIZE, { x424 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_MUL_ZERO, { x426, w427 }, nm->mkNode(Kind::BITVECTOR_MULT, { x426,e480 }), e480, nm->mkNode(Kind::EQUAL, { w427,nm->mkNode(Kind::BITVECTOR_SIZE, { x426 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ADD_ZERO, { x428, w429 }, nm->mkNode(Kind::BITVECTOR_ADD, { x428,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e479,w429 }) }), x428, nm->mkNode(Kind::EQUAL, { w429,nm->mkNode(Kind::BITVECTOR_SIZE, { x428 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ADD_TWO, { x430, w431 }, nm->mkNode(Kind::BITVECTOR_ADD, { x430,x430 }), nm->mkNode(Kind::BITVECTOR_MULT, { x430,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(2)),w431 }) }), nm->mkNode(Kind::EQUAL, { w431,nm->mkNode(Kind::BITVECTOR_SIZE, { x430 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_ELIMINATE_0, { x432 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),e479,x432 }), x432, e477, Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ELIMINATE_0, { x433 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),e479,x433 }), x433, e477, Node::null());
db.addRule(ProofRewriteRule::BV_NOT_NEQ, { x434 }, nm->mkNode(Kind::EQUAL, { x434,nm->mkNode(Kind::BITVECTOR_NOT, { x434 }) }), nm->mkConst(false), nm->mkNode(Kind::GT, { nm->mkNode(Kind::BITVECTOR_SIZE, { x434 }),e479 }), Node::null());
db.addRule(ProofRewriteRule::BV_ULT_ONES, { x435, n436, w437 }, nm->mkNode(Kind::BITVECTOR_ULT, { x435,e478 }), nm->mkNode(Kind::DISTINCT, { x435,e478 }), nm->mkNode(Kind::EQUAL, { n436,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { w437 }),e481 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_OR_FLATTEN, { xs438, s439, ys440, zs441 }, nm->mkNode(Kind::BITVECTOR_OR, { xs438,nm->mkNode(Kind::BITVECTOR_OR, { s439,ys440 }),zs441 }), nm->mkNode(Kind::BITVECTOR_OR, { xs438,s439,ys440,zs441 }), e477, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t473 }),t473 }));
db.addRule(ProofRewriteRule::BV_XOR_FLATTEN, { xs442, s443, ys444, zs445 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs442,nm->mkNode(Kind::BITVECTOR_XOR, { s443,ys444 }),zs445 }), nm->mkNode(Kind::BITVECTOR_XOR, { xs442,s443,ys444,zs445 }), e477, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t474 }),t474 }));
db.addRule(ProofRewriteRule::BV_AND_FLATTEN, { xs446, s447, ys448, zs449 }, nm->mkNode(Kind::BITVECTOR_AND, { xs446,nm->mkNode(Kind::BITVECTOR_AND, { s447,ys448 }),zs449 }), nm->mkNode(Kind::BITVECTOR_AND, { xs446,s447,ys448,zs449 }), e477, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t475 }),t475 }));
db.addRule(ProofRewriteRule::BV_MUL_FLATTEN, { xs450, s451, ys452, zs453 }, nm->mkNode(Kind::BITVECTOR_MULT, { xs450,nm->mkNode(Kind::BITVECTOR_MULT, { s451,ys452 }),zs453 }), nm->mkNode(Kind::BITVECTOR_MULT, { xs450,s451,ys452,zs453 }), e477, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t476 }),t476 }));
db.addRule(ProofRewriteRule::BV_CONCAT_MERGE_CONST, { xs454, n1455, w1456, n2457, w2458, ww459, zs460 }, nm->mkNode(Kind::BITVECTOR_CONCAT, { xs454,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n1455,w1456 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n2457,w2458 }),zs460 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { xs454,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::ADD, { nm->mkNode(Kind::MULT, { n1455,nm->mkNode(Kind::POW2, { w2458 }) }),n2457 }),ww459 }),zs460 }), nm->mkNode(Kind::EQUAL, { ww459,nm->mkNode(Kind::ADD, { w1456,w2458 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_ADD, { x461, y462 }, nm->mkNode(Kind::BITVECTOR_ADD, { x461,y462 }), nm->mkNode(Kind::BITVECTOR_ADD, { y462,x461 }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_NEG_SUB, { x463, y464 }, nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_SUB, { x463,y464 }) }), nm->mkNode(Kind::BITVECTOR_SUB, { y464,x463 }), e477, Node::null());
db.addRule(ProofRewriteRule::BV_NEG_IDEMP, { x465 }, nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_NEG, { x465 }) }), x465, e477, Node::null());
db.addRule(ProofRewriteRule::BV_SUB_ELIMINATE, { x466, y467 }, nm->mkNode(Kind::BITVECTOR_SUB, { x466,y467 }), nm->mkNode(Kind::BITVECTOR_ADD, { x466,nm->mkNode(Kind::BITVECTOR_NEG, { y467 }) }), e477, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
