/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_sets_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node x922 = NodeManager::mkBoundVar("x922", nm->mkAbstractType(Kind::SET_TYPE));
Node y923 = NodeManager::mkBoundVar("y923", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x924 = NodeManager::mkBoundVar("x924", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y925 = NodeManager::mkBoundVar("y925", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x926 = NodeManager::mkBoundVar("x926", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y927 = NodeManager::mkBoundVar("y927", nm->mkAbstractType(Kind::SET_TYPE));
Node x928 = NodeManager::mkBoundVar("x928", nm->mkAbstractType(Kind::SET_TYPE));
Node y929 = NodeManager::mkBoundVar("y929", nm->mkAbstractType(Kind::SET_TYPE));
Node x930 = NodeManager::mkBoundVar("x930", nm->mkAbstractType(Kind::SET_TYPE));
Node y931 = NodeManager::mkBoundVar("y931", nm->mkAbstractType(Kind::SET_TYPE));
Node x932 = NodeManager::mkBoundVar("x932", nm->mkAbstractType(Kind::SET_TYPE));
Node y933 = NodeManager::mkBoundVar("y933", nm->mkAbstractType(Kind::SET_TYPE));
Node x934 = NodeManager::mkBoundVar("x934", nm->mkAbstractType(Kind::SET_TYPE));
Node y935 = NodeManager::mkBoundVar("y935", nm->mkAbstractType(Kind::SET_TYPE));
Node x936 = NodeManager::mkBoundVar("x936", nm->mkAbstractType(Kind::SET_TYPE));
Node y937 = NodeManager::mkBoundVar("y937", nm->mkAbstractType(Kind::SET_TYPE));
Node x938 = NodeManager::mkBoundVar("x938", nm->mkAbstractType(Kind::SET_TYPE));
Node y939 = NodeManager::mkBoundVar("y939", nm->mkAbstractType(Kind::SET_TYPE));
Node x940 = NodeManager::mkBoundVar("x940", nm->mkAbstractType(Kind::SET_TYPE));
Node y941 = NodeManager::mkBoundVar("y941", nm->mkAbstractType(Kind::SET_TYPE));
Node x942 = NodeManager::mkBoundVar("x942", nm->mkAbstractType(Kind::SET_TYPE));
Node y943 = NodeManager::mkBoundVar("y943", nm->mkAbstractType(Kind::SET_TYPE));
Node x944 = NodeManager::mkBoundVar("x944", nm->mkAbstractType(Kind::SET_TYPE));
Node y945 = NodeManager::mkBoundVar("y945", nm->mkAbstractType(Kind::SET_TYPE));
Node x946 = NodeManager::mkBoundVar("x946", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y947 = NodeManager::mkBoundVar("y947", nm->mkAbstractType(Kind::SET_TYPE));
Node z948 = NodeManager::mkBoundVar("z948", nm->mkAbstractType(Kind::SET_TYPE));
Node x949 = NodeManager::mkBoundVar("x949", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y950 = NodeManager::mkBoundVar("y950", nm->mkAbstractType(Kind::SET_TYPE));
Node z951 = NodeManager::mkBoundVar("z951", nm->mkAbstractType(Kind::SET_TYPE));
Node x952 = NodeManager::mkBoundVar("x952", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y953 = NodeManager::mkBoundVar("y953", nm->mkAbstractType(Kind::SET_TYPE));
Node z954 = NodeManager::mkBoundVar("z954", nm->mkAbstractType(Kind::SET_TYPE));
Node x955 = NodeManager::mkBoundVar("x955", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x956 = NodeManager::mkBoundVar("x956", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s957 = NodeManager::mkBoundVar("s957", nm->mkAbstractType(Kind::SET_TYPE));
Node t958 = NodeManager::mkBoundVar("t958", nm->mkAbstractType(Kind::SET_TYPE));
Node s959 = NodeManager::mkBoundVar("s959", nm->mkAbstractType(Kind::SET_TYPE));
Node t960 = NodeManager::mkBoundVar("t960", nm->mkAbstractType(Kind::SET_TYPE));
Node x961 = NodeManager::mkBoundVar("x961", nm->mkAbstractType(Kind::SET_TYPE));
Node x962 = NodeManager::mkBoundVar("x962", nm->mkAbstractType(Kind::SET_TYPE));
Node x963 = NodeManager::mkBoundVar("x963", nm->mkAbstractType(Kind::SET_TYPE));

  // Definitions
Node e964 = nm->mkConst(true);
Node e965 = nm->mkConst(false);

  // Rules

        {
            // from rewrites-sets-rewrites.cpp
            db.addRule(ProofRewriteRule::SETS_EQ_SINGLETON_EMP, { x922, y923 }, nm->mkNode(Kind::EQUAL, { x922,nm->mkNode(Kind::SET_SINGLETON, { y923 }) }), e965, nm->mkNode(Kind::EQUAL, { x922,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x922 }) }) }), Node::null());
db.addRule(ProofRewriteRule::SETS_MEMBER_SINGLETON, { x924, y925 }, nm->mkNode(Kind::SET_MEMBER, { x924,nm->mkNode(Kind::SET_SINGLETON, { y925 }) }), nm->mkNode(Kind::EQUAL, { x924,y925 }), e964, Node::null());
db.addRule(ProofRewriteRule::SETS_MEMBER_EMP, { x926, y927 }, nm->mkNode(Kind::SET_MEMBER, { x926,y927 }), e965, nm->mkNode(Kind::EQUAL, { y927,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { y927 }) }) }), Node::null());
db.addRule(ProofRewriteRule::SETS_SUBSET_ELIM, { x928, y929 }, nm->mkNode(Kind::SET_SUBSET, { x928,y929 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::SET_UNION, { x928,y929 }),y929 }), e964, Node::null());
db.addRule(ProofRewriteRule::SETS_UNION_COMM, { x930, y931 }, nm->mkNode(Kind::SET_UNION, { x930,y931 }), nm->mkNode(Kind::SET_UNION, { y931,x930 }), e964, Node::null());
db.addRule(ProofRewriteRule::SETS_INTER_COMM, { x932, y933 }, nm->mkNode(Kind::SET_INTER, { x932,y933 }), nm->mkNode(Kind::SET_INTER, { y933,x932 }), e964, Node::null());
db.addRule(ProofRewriteRule::SETS_INTER_EMP1, { x934, y935 }, nm->mkNode(Kind::SET_INTER, { x934,y935 }), x934, nm->mkNode(Kind::EQUAL, { x934,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x934 }) }) }), Node::null());
db.addRule(ProofRewriteRule::SETS_INTER_EMP2, { x936, y937 }, nm->mkNode(Kind::SET_INTER, { x936,y937 }), y937, nm->mkNode(Kind::EQUAL, { y937,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { y937 }) }) }), Node::null());
db.addRule(ProofRewriteRule::SETS_MINUS_EMP1, { x938, y939 }, nm->mkNode(Kind::SET_MINUS, { x938,y939 }), x938, nm->mkNode(Kind::EQUAL, { x938,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x938 }) }) }), Node::null());
db.addRule(ProofRewriteRule::SETS_MINUS_EMP2, { x940, y941 }, nm->mkNode(Kind::SET_MINUS, { x940,y941 }), x940, nm->mkNode(Kind::EQUAL, { y941,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { y941 }) }) }), Node::null());
db.addRule(ProofRewriteRule::SETS_UNION_EMP1, { x942, y943 }, nm->mkNode(Kind::SET_UNION, { x942,y943 }), y943, nm->mkNode(Kind::EQUAL, { x942,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x942 }) }) }), Node::null());
db.addRule(ProofRewriteRule::SETS_UNION_EMP2, { x944, y945 }, nm->mkNode(Kind::SET_UNION, { x944,y945 }), x944, nm->mkNode(Kind::EQUAL, { y945,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { y945 }) }) }), Node::null());
db.addRule(ProofRewriteRule::SETS_INTER_MEMBER, { x946, y947, z948 }, nm->mkNode(Kind::SET_MEMBER, { x946,nm->mkNode(Kind::SET_INTER, { y947,z948 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::SET_MEMBER, { x946,y947 }),nm->mkNode(Kind::SET_MEMBER, { x946,z948 }) }), e964, Node::null());
db.addRule(ProofRewriteRule::SETS_MINUS_MEMBER, { x949, y950, z951 }, nm->mkNode(Kind::SET_MEMBER, { x949,nm->mkNode(Kind::SET_MINUS, { y950,z951 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::SET_MEMBER, { x949,y950 }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::SET_MEMBER, { x949,z951 }) }) }), e964, Node::null());
db.addRule(ProofRewriteRule::SETS_UNION_MEMBER, { x952, y953, z954 }, nm->mkNode(Kind::SET_MEMBER, { x952,nm->mkNode(Kind::SET_UNION, { y953,z954 }) }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::SET_MEMBER, { x952,y953 }),nm->mkNode(Kind::SET_MEMBER, { x952,z954 }) }), e964, Node::null());
db.addRule(ProofRewriteRule::SETS_CHOOSE_SINGLETON, { x955 }, nm->mkNode(Kind::SET_CHOOSE, { nm->mkNode(Kind::SET_SINGLETON, { x955 }) }), x955, e964, Node::null());
db.addRule(ProofRewriteRule::SETS_CARD_SINGLETON, { x956 }, nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_SINGLETON, { x956 }) }), nm->mkConstInt(Rational(1)), e964, Node::null());
db.addRule(ProofRewriteRule::SETS_CARD_UNION, { s957, t958 }, nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_UNION, { s957,t958 }) }), nm->mkNode(Kind::SUB, { nm->mkNode(Kind::ADD, { nm->mkNode(Kind::SET_CARD, { s957 }),nm->mkNode(Kind::SET_CARD, { t958 }) }),nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_INTER, { s957,t958 }) }) }), e964, Node::null());
db.addRule(ProofRewriteRule::SETS_CARD_MINUS, { s959, t960 }, nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_MINUS, { s959,t960 }) }), nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SET_CARD, { s959 }),nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_INTER, { s959,t960 }) }) }), e964, Node::null());
db.addRule(ProofRewriteRule::SETS_CARD_EMP, { x961 }, nm->mkNode(Kind::SET_CARD, { x961 }), nm->mkConstInt(Rational(0)), nm->mkNode(Kind::EQUAL, { x961,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x961 }) }) }), Node::null());
db.addRule(ProofRewriteRule::SETS_MINUS_SELF, { x962 }, nm->mkNode(Kind::SET_MINUS, { x962,x962 }), nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x962 }) }), e964, Node::null());
db.addRule(ProofRewriteRule::SETS_IS_EMPTY_ELIM, { x963 }, nm->mkNode(Kind::SET_IS_EMPTY, { x963 }), nm->mkNode(Kind::EQUAL, { x963,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x963 }) }) }), e964, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
