/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_strings_rewrites_regexp_membership(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node t1298 = NodeManager::mkBoundVar("t1298", nm->stringType());
Node t1299 = NodeManager::mkBoundVar("t1299", nm->stringType());
Node t1300 = NodeManager::mkBoundVar("t1300", nm->stringType());
Node t1301 = NodeManager::mkBoundVar("t1301", nm->stringType());
Node s1302 = NodeManager::mkBoundVar("s1302", nm->stringType());
Node t1303 = NodeManager::mkBoundVar("t1303", nm->stringType());
Node r1304 = NodeManager::mkBoundVar("r1304", nm->regExpType());
Node s1305 = NodeManager::mkBoundVar("s1305", nm->stringType());
Node r11306 = NodeManager::mkBoundVar("r11306", nm->regExpType());
Node r21307 = NodeManager::mkBoundVar("r21307", nm->regExpType());
Node rs1308 = NodeManager::mkBoundVar("rs1308", nm->regExpType());expr::markListVar(rs1308);
Node t1474 = NodeManager::mkBoundVar("t1474", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1309 = NodeManager::mkBoundVar("s1309", nm->stringType());
Node r11310 = NodeManager::mkBoundVar("r11310", nm->regExpType());
Node r21311 = NodeManager::mkBoundVar("r21311", nm->regExpType());
Node rs1312 = NodeManager::mkBoundVar("rs1312", nm->regExpType());expr::markListVar(rs1312);
Node t1475 = NodeManager::mkBoundVar("t1475", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1313 = NodeManager::mkBoundVar("s1313", nm->stringType());
Node c11314 = NodeManager::mkBoundVar("c11314", nm->stringType());
Node c21315 = NodeManager::mkBoundVar("c21315", nm->stringType());
Node t1316 = NodeManager::mkBoundVar("t1316", nm->stringType());
Node s1317 = NodeManager::mkBoundVar("s1317", nm->stringType());
Node s1318 = NodeManager::mkBoundVar("s1318", nm->stringType());
Node s11319 = NodeManager::mkBoundVar("s11319", nm->stringType());
Node s21320 = NodeManager::mkBoundVar("s21320", nm->stringType());expr::markListVar(s21320);
Node sr11321 = NodeManager::mkBoundVar("sr11321", nm->stringType());
Node sr21322 = NodeManager::mkBoundVar("sr21322", nm->stringType());expr::markListVar(sr21322);
Node r1323 = NodeManager::mkBoundVar("r1323", nm->regExpType());expr::markListVar(r1323);
Node t1476 = NodeManager::mkBoundVar("t1476", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1324 = NodeManager::mkBoundVar("s1324", nm->stringType());
Node t1325 = NodeManager::mkBoundVar("t1325", nm->stringType());
Node s11326 = NodeManager::mkBoundVar("s11326", nm->stringType());
Node s21327 = NodeManager::mkBoundVar("s21327", nm->stringType());expr::markListVar(s21327);
Node sr11328 = NodeManager::mkBoundVar("sr11328", nm->stringType());
Node sr21329 = NodeManager::mkBoundVar("sr21329", nm->stringType());expr::markListVar(sr21329);
Node r1330 = NodeManager::mkBoundVar("r1330", nm->regExpType());expr::markListVar(r1330);
Node s1331 = NodeManager::mkBoundVar("s1331", nm->stringType());
Node s11332 = NodeManager::mkBoundVar("s11332", nm->stringType());
Node s21333 = NodeManager::mkBoundVar("s21333", nm->stringType());expr::markListVar(s21333);
Node r11334 = NodeManager::mkBoundVar("r11334", nm->regExpType());
Node r21335 = NodeManager::mkBoundVar("r21335", nm->regExpType());expr::markListVar(r21335);
Node t1477 = NodeManager::mkBoundVar("t1477", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1336 = NodeManager::mkBoundVar("s1336", nm->stringType());
Node t1337 = NodeManager::mkBoundVar("t1337", nm->stringType());
Node s11338 = NodeManager::mkBoundVar("s11338", nm->stringType());
Node s21339 = NodeManager::mkBoundVar("s21339", nm->stringType());expr::markListVar(s21339);
Node r11340 = NodeManager::mkBoundVar("r11340", nm->regExpType());
Node r21341 = NodeManager::mkBoundVar("r21341", nm->regExpType());expr::markListVar(r21341);
Node s1342 = NodeManager::mkBoundVar("s1342", nm->stringType());
Node r11343 = NodeManager::mkBoundVar("r11343", nm->regExpType());
Node r21344 = NodeManager::mkBoundVar("r21344", nm->regExpType());expr::markListVar(r21344);
Node s1345 = NodeManager::mkBoundVar("s1345", nm->stringType());
Node t1346 = NodeManager::mkBoundVar("t1346", nm->stringType());
Node r11347 = NodeManager::mkBoundVar("r11347", nm->regExpType());
Node r21348 = NodeManager::mkBoundVar("r21348", nm->regExpType());expr::markListVar(r21348);
Node s1349 = NodeManager::mkBoundVar("s1349", nm->stringType());
Node sr11350 = NodeManager::mkBoundVar("sr11350", nm->stringType());
Node sr21351 = NodeManager::mkBoundVar("sr21351", nm->stringType());expr::markListVar(sr21351);
Node r1352 = NodeManager::mkBoundVar("r1352", nm->regExpType());expr::markListVar(r1352);
Node s1353 = NodeManager::mkBoundVar("s1353", nm->stringType());
Node t1354 = NodeManager::mkBoundVar("t1354", nm->stringType());
Node sr11355 = NodeManager::mkBoundVar("sr11355", nm->stringType());
Node sr21356 = NodeManager::mkBoundVar("sr21356", nm->stringType());expr::markListVar(sr21356);
Node r1357 = NodeManager::mkBoundVar("r1357", nm->regExpType());expr::markListVar(r1357);
Node s1358 = NodeManager::mkBoundVar("s1358", nm->stringType());
Node s11359 = NodeManager::mkBoundVar("s11359", nm->stringType());
Node s21360 = NodeManager::mkBoundVar("s21360", nm->stringType());expr::markListVar(s21360);
Node sr11361 = NodeManager::mkBoundVar("sr11361", nm->stringType());
Node sr21362 = NodeManager::mkBoundVar("sr21362", nm->stringType());expr::markListVar(sr21362);
Node t1478 = NodeManager::mkBoundVar("t1478", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1363 = NodeManager::mkBoundVar("s1363", nm->stringType());
Node t1364 = NodeManager::mkBoundVar("t1364", nm->stringType());
Node s11365 = NodeManager::mkBoundVar("s11365", nm->stringType());
Node s21366 = NodeManager::mkBoundVar("s21366", nm->stringType());expr::markListVar(s21366);
Node sr11367 = NodeManager::mkBoundVar("sr11367", nm->stringType());
Node sr21368 = NodeManager::mkBoundVar("sr21368", nm->stringType());expr::markListVar(sr21368);
Node s1369 = NodeManager::mkBoundVar("s1369", nm->stringType());
Node sr11370 = NodeManager::mkBoundVar("sr11370", nm->stringType());
Node sr21371 = NodeManager::mkBoundVar("sr21371", nm->stringType());expr::markListVar(sr21371);
Node s1372 = NodeManager::mkBoundVar("s1372", nm->stringType());
Node t1373 = NodeManager::mkBoundVar("t1373", nm->stringType());
Node sr11374 = NodeManager::mkBoundVar("sr11374", nm->stringType());
Node sr21375 = NodeManager::mkBoundVar("sr21375", nm->stringType());expr::markListVar(sr21375);
Node s1376 = NodeManager::mkBoundVar("s1376", nm->stringType());
Node s11377 = NodeManager::mkBoundVar("s11377", nm->stringType());
Node s21378 = NodeManager::mkBoundVar("s21378", nm->stringType());expr::markListVar(s21378);
Node r11379 = NodeManager::mkBoundVar("r11379", nm->regExpType());
Node r21380 = NodeManager::mkBoundVar("r21380", nm->regExpType());expr::markListVar(r21380);
Node s1381 = NodeManager::mkBoundVar("s1381", nm->stringType());
Node r11382 = NodeManager::mkBoundVar("r11382", nm->regExpType());
Node r21383 = NodeManager::mkBoundVar("r21383", nm->regExpType());expr::markListVar(r21383);
Node s1384 = NodeManager::mkBoundVar("s1384", nm->stringType());
Node s11385 = NodeManager::mkBoundVar("s11385", nm->stringType());
Node s21386 = NodeManager::mkBoundVar("s21386", nm->stringType());expr::markListVar(s21386);
Node sr11387 = NodeManager::mkBoundVar("sr11387", nm->stringType());
Node sr21388 = NodeManager::mkBoundVar("sr21388", nm->stringType());expr::markListVar(sr21388);
Node r1389 = NodeManager::mkBoundVar("r1389", nm->regExpType());expr::markListVar(r1389);
Node t1479 = NodeManager::mkBoundVar("t1479", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1390 = NodeManager::mkBoundVar("s1390", nm->stringType());
Node t1391 = NodeManager::mkBoundVar("t1391", nm->stringType());
Node s11392 = NodeManager::mkBoundVar("s11392", nm->stringType());
Node s21393 = NodeManager::mkBoundVar("s21393", nm->stringType());expr::markListVar(s21393);
Node sr11394 = NodeManager::mkBoundVar("sr11394", nm->stringType());
Node sr21395 = NodeManager::mkBoundVar("sr21395", nm->stringType());expr::markListVar(sr21395);
Node r1396 = NodeManager::mkBoundVar("r1396", nm->regExpType());expr::markListVar(r1396);
Node s1397 = NodeManager::mkBoundVar("s1397", nm->stringType());
Node s11398 = NodeManager::mkBoundVar("s11398", nm->stringType());
Node s21399 = NodeManager::mkBoundVar("s21399", nm->stringType());expr::markListVar(s21399);
Node r11400 = NodeManager::mkBoundVar("r11400", nm->regExpType());
Node r21401 = NodeManager::mkBoundVar("r21401", nm->regExpType());expr::markListVar(r21401);
Node t1480 = NodeManager::mkBoundVar("t1480", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1402 = NodeManager::mkBoundVar("s1402", nm->stringType());
Node t1403 = NodeManager::mkBoundVar("t1403", nm->stringType());
Node s11404 = NodeManager::mkBoundVar("s11404", nm->stringType());
Node s21405 = NodeManager::mkBoundVar("s21405", nm->stringType());expr::markListVar(s21405);
Node r11406 = NodeManager::mkBoundVar("r11406", nm->regExpType());
Node r21407 = NodeManager::mkBoundVar("r21407", nm->regExpType());expr::markListVar(r21407);
Node s1408 = NodeManager::mkBoundVar("s1408", nm->stringType());
Node r11409 = NodeManager::mkBoundVar("r11409", nm->regExpType());
Node r21410 = NodeManager::mkBoundVar("r21410", nm->regExpType());expr::markListVar(r21410);
Node s1411 = NodeManager::mkBoundVar("s1411", nm->stringType());
Node t1412 = NodeManager::mkBoundVar("t1412", nm->stringType());
Node r11413 = NodeManager::mkBoundVar("r11413", nm->regExpType());
Node r21414 = NodeManager::mkBoundVar("r21414", nm->regExpType());expr::markListVar(r21414);
Node s1415 = NodeManager::mkBoundVar("s1415", nm->stringType());
Node sr11416 = NodeManager::mkBoundVar("sr11416", nm->stringType());
Node sr21417 = NodeManager::mkBoundVar("sr21417", nm->stringType());expr::markListVar(sr21417);
Node r1418 = NodeManager::mkBoundVar("r1418", nm->regExpType());expr::markListVar(r1418);
Node s1419 = NodeManager::mkBoundVar("s1419", nm->stringType());
Node t1420 = NodeManager::mkBoundVar("t1420", nm->stringType());
Node sr11421 = NodeManager::mkBoundVar("sr11421", nm->stringType());
Node sr21422 = NodeManager::mkBoundVar("sr21422", nm->stringType());expr::markListVar(sr21422);
Node r1423 = NodeManager::mkBoundVar("r1423", nm->regExpType());expr::markListVar(r1423);
Node s1424 = NodeManager::mkBoundVar("s1424", nm->stringType());
Node s11425 = NodeManager::mkBoundVar("s11425", nm->stringType());
Node s21426 = NodeManager::mkBoundVar("s21426", nm->stringType());expr::markListVar(s21426);
Node sr11427 = NodeManager::mkBoundVar("sr11427", nm->stringType());
Node sr21428 = NodeManager::mkBoundVar("sr21428", nm->stringType());expr::markListVar(sr21428);
Node t1481 = NodeManager::mkBoundVar("t1481", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1429 = NodeManager::mkBoundVar("s1429", nm->stringType());
Node t1430 = NodeManager::mkBoundVar("t1430", nm->stringType());
Node s11431 = NodeManager::mkBoundVar("s11431", nm->stringType());
Node s21432 = NodeManager::mkBoundVar("s21432", nm->stringType());expr::markListVar(s21432);
Node sr11433 = NodeManager::mkBoundVar("sr11433", nm->stringType());
Node sr21434 = NodeManager::mkBoundVar("sr21434", nm->stringType());expr::markListVar(sr21434);
Node s1435 = NodeManager::mkBoundVar("s1435", nm->stringType());
Node sr11436 = NodeManager::mkBoundVar("sr11436", nm->stringType());
Node sr21437 = NodeManager::mkBoundVar("sr21437", nm->stringType());expr::markListVar(sr21437);
Node s1438 = NodeManager::mkBoundVar("s1438", nm->stringType());
Node t1439 = NodeManager::mkBoundVar("t1439", nm->stringType());
Node sr11440 = NodeManager::mkBoundVar("sr11440", nm->stringType());
Node sr21441 = NodeManager::mkBoundVar("sr21441", nm->stringType());expr::markListVar(sr21441);
Node s1442 = NodeManager::mkBoundVar("s1442", nm->stringType());
Node s11443 = NodeManager::mkBoundVar("s11443", nm->stringType());
Node s21444 = NodeManager::mkBoundVar("s21444", nm->stringType());expr::markListVar(s21444);
Node r11445 = NodeManager::mkBoundVar("r11445", nm->regExpType());
Node r21446 = NodeManager::mkBoundVar("r21446", nm->regExpType());expr::markListVar(r21446);
Node s1447 = NodeManager::mkBoundVar("s1447", nm->stringType());
Node r11448 = NodeManager::mkBoundVar("r11448", nm->regExpType());
Node r21449 = NodeManager::mkBoundVar("r21449", nm->regExpType());expr::markListVar(r21449);
Node s1450 = NodeManager::mkBoundVar("s1450", nm->stringType());
Node r11451 = NodeManager::mkBoundVar("r11451", nm->regExpType());
Node r21452 = NodeManager::mkBoundVar("r21452", nm->regExpType());
Node r31453 = NodeManager::mkBoundVar("r31453", nm->regExpType());expr::markListVar(r31453);
Node s1454 = NodeManager::mkBoundVar("s1454", nm->stringType());
Node r11455 = NodeManager::mkBoundVar("r11455", nm->regExpType());
Node r21456 = NodeManager::mkBoundVar("r21456", nm->regExpType());expr::markListVar(r21456);
Node r31457 = NodeManager::mkBoundVar("r31457", nm->regExpType());
Node s1458 = NodeManager::mkBoundVar("s1458", nm->stringType());
Node r11459 = NodeManager::mkBoundVar("r11459", nm->regExpType());
Node r21460 = NodeManager::mkBoundVar("r21460", nm->regExpType());
Node r31461 = NodeManager::mkBoundVar("r31461", nm->regExpType());expr::markListVar(r31461);
Node s1462 = NodeManager::mkBoundVar("s1462", nm->stringType());
Node r11463 = NodeManager::mkBoundVar("r11463", nm->regExpType());
Node r21464 = NodeManager::mkBoundVar("r21464", nm->regExpType());expr::markListVar(r21464);
Node r31465 = NodeManager::mkBoundVar("r31465", nm->regExpType());
Node s1466 = NodeManager::mkBoundVar("s1466", nm->stringType());
Node r11467 = NodeManager::mkBoundVar("r11467", nm->regExpType());
Node r21468 = NodeManager::mkBoundVar("r21468", nm->regExpType());
Node r31469 = NodeManager::mkBoundVar("r31469", nm->regExpType());expr::markListVar(r31469);
Node s1470 = NodeManager::mkBoundVar("s1470", nm->stringType());
Node r11471 = NodeManager::mkBoundVar("r11471", nm->regExpType());
Node r21472 = NodeManager::mkBoundVar("r21472", nm->regExpType());expr::markListVar(r21472);
Node r31473 = NodeManager::mkBoundVar("r31473", nm->regExpType());

  // Definitions
Node e1482 = nm->mkNode(Kind::REGEXP_STAR, { r31473 });
Node e1483 = nm->mkConst(false);
Node e1484 = nm->mkNode(Kind::REGEXP_STAR, { r11467 });
Node e1485 = nm->mkNode(Kind::REGEXP_STAR, { r31465 });
Node e1486 = nm->mkNode(Kind::REGEXP_STAR, { r11459 });
Node e1487 = nm->mkNode(Kind::REGEXP_STAR, { r31457 });
Node e1488 = nm->mkNode(Kind::REGEXP_STAR, { r11451 });
Node e1489 = nm->mkNode(Kind::REGEXP_ALLCHAR, {  });
Node e1490 = nm->mkConstInt(Rational(1));
Node e1491 = nm->mkConst(String(""));
Node e1492 = nm->mkConst(true);
Node e1493 = nm->mkNode(Kind::REGEXP_STAR, { nm->mkNode(Kind::REGEXP_ALLCHAR, {  }) });
Node e1494 = nm->mkNode(Kind::STRING_TO_CODE, { s1313 });

  // Rules

        {
            // from rewrites-strings-rewrites-regexp-membership.cpp
            db.addRule(ProofRewriteRule::RE_IN_EMPTY, { t1298 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1298,nm->mkNode(Kind::REGEXP_NONE, {  }) }), e1483, e1492, Node::null());
db.addRule(ProofRewriteRule::RE_IN_SIGMA, { t1299 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1299,e1489 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t1299 }),e1490 }), e1492, Node::null());
db.addRule(ProofRewriteRule::RE_IN_SIGMA_STAR, { t1300 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1300,e1493 }), e1492, e1492, Node::null());
db.addRule(ProofRewriteRule::RE_IN_CSTRING, { t1301, s1302 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1301,nm->mkNode(Kind::STRING_TO_REGEXP, { s1302 }) }), nm->mkNode(Kind::EQUAL, { t1301,s1302 }), e1492, Node::null());
db.addRule(ProofRewriteRule::RE_IN_COMP, { t1303, r1304 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1303,nm->mkNode(Kind::REGEXP_COMPLEMENT, { r1304 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { t1303,r1304 }) }), e1492, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_UNION_ELIM, { s1305, r11306, r21307, rs1308 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1305,nm->mkNode(Kind::REGEXP_UNION, { r11306,r21307,rs1308 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1305,nm->mkNode(Kind::REGEXP_UNION, { r21307,rs1308 }) }), e1492, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1474 }),nm->mkNode(Kind::OR, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1305,r11306 }),t1474 }) }));
db.addRule(ProofRewriteRule::STR_IN_RE_INTER_ELIM, { s1309, r11310, r21311, rs1312 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1309,nm->mkNode(Kind::REGEXP_INTER, { r11310,r21311,rs1312 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1309,nm->mkNode(Kind::REGEXP_INTER, { r21311,rs1312 }) }), e1492, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1475 }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1309,r11310 }),t1475 }) }));
db.addRule(ProofRewriteRule::STR_IN_RE_RANGE_ELIM, { s1313, c11314, c21315 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1313,nm->mkNode(Kind::REGEXP_RANGE, { c11314,c21315 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::STRING_TO_CODE, { c11314 }),e1494 }),nm->mkNode(Kind::LEQ, { e1494,nm->mkNode(Kind::STRING_TO_CODE, { c21315 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { c11314 }),e1490 }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { c21315 }),e1490 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_CONTAINS, { t1316, s1317 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1316,nm->mkNode(Kind::REGEXP_CONCAT, { e1493,nm->mkNode(Kind::STRING_TO_REGEXP, { s1317 }),e1493 }) }), nm->mkNode(Kind::STRING_CONTAINS, { t1316,s1317 }), e1492, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX, { s1318, s11319, s21320, sr11321, sr21322, r1323 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1318,s11319,s21320 }),nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1318,sr11321,sr21322 }) }),r1323 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11319,s21320 }),nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11321,sr21322 }) }),r1323 }) }), e1492, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1476 }),t1476 }));
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_NEG, { s1324, t1325, s11326, s21327, sr11328, sr21329, r1330 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1324,s11326,s21327 }),nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { t1325,sr11328,sr21329 }) }),r1330 }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1324 }),nm->mkNode(Kind::STRING_LENGTH, { t1325 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1324,t1325 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SR_SINGLE, { s1331, s11332, s21333, r11334, r21335 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1331,s11332,s21333 }),nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { s1331 }),r11334,r21335 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11332,s21333 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11334,r21335 }) }), e1492, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1477 }),t1477 }));
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SR_SINGLE_NEG, { s1336, t1337, s11338, s21339, r11340, r21341 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1336,s11338,s21339 }),nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { t1337 }),r11340,r21341 }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1336 }),nm->mkNode(Kind::STRING_LENGTH, { t1337 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1336,t1337 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SRS_SINGLE, { s1342, r11343, r21344 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1342,nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { s1342 }),r11343,r21344 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1491,nm->mkNode(Kind::REGEXP_CONCAT, { r11343,r21344 }) }), e1492, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SRS_SINGLE_NEG, { s1345, t1346, r11347, r21348 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1345,nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { t1346 }),r11347,r21348 }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1345 }),nm->mkNode(Kind::STRING_LENGTH, { t1346 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1345,t1346 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_S_SINGLE, { s1349, sr11350, sr21351, r1352 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1349,nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1349,sr11350,sr21351 }) }),r1352 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1491,nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11350,sr21351 }) }),r1352 }) }), e1492, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_S_SINGLE_NEG, { s1353, t1354, sr11355, sr21356, r1357 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1353,nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { t1354,sr11355,sr21356 }) }),r1357 }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1353 }),nm->mkNode(Kind::STRING_LENGTH, { t1354 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1353,t1354 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE, { s1358, s11359, s21360, sr11361, sr21362 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1358,s11359,s21360 }),nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1358,sr11361,sr21362 }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11359,s21360 }),nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11361,sr21362 }) }) }), e1492, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1478 }),t1478 }));
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_NEG, { s1363, t1364, s11365, s21366, sr11367, sr21368 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1363,s11365,s21366 }),nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { t1364,sr11367,sr21368 }) }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1363 }),nm->mkNode(Kind::STRING_LENGTH, { t1364 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1363,t1364 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_S_SINGLE, { s1369, sr11370, sr21371 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1369,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1369,sr11370,sr21371 }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1491,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11370,sr21371 }) }) }), e1492, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_S_SINGLE_NEG, { s1372, t1373, sr11374, sr21375 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1372,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { t1373,sr11374,sr21375 }) }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1372 }),nm->mkNode(Kind::STRING_LENGTH, { t1373 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1372,t1373 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_CHAR, { s1376, s11377, s21378, r11379, r21380 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1376,s11377,s21378 }),nm->mkNode(Kind::REGEXP_CONCAT, { e1489,r11379,r21380 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11377,s21378 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11379,r21380 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1376 }),e1490 }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_CHAR_S_SINGLE, { s1381, r11382, r21383 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1381,nm->mkNode(Kind::REGEXP_CONCAT, { e1489,r11382,r21383 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1491,nm->mkNode(Kind::REGEXP_CONCAT, { r11382,r21383 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1381 }),e1490 }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_REV, { s1384, s11385, s21386, sr11387, sr21388, r1389 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11385,s21386,s1384 }),nm->mkNode(Kind::REGEXP_CONCAT, { r1389,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11387,sr21388,s1384 }) }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11385,s21386 }),nm->mkNode(Kind::REGEXP_CONCAT, { r1389,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11387,sr21388 }) }) }) }), e1492, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1479 }),t1479 }));
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_NEG_REV, { s1390, t1391, s11392, s21393, sr11394, sr21395, r1396 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11392,s21393,s1390 }),nm->mkNode(Kind::REGEXP_CONCAT, { r1396,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11394,sr21395,t1391 }) }) }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1390 }),nm->mkNode(Kind::STRING_LENGTH, { t1391 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1390,t1391 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SR_SINGLE_REV, { s1397, s11398, s21399, r11400, r21401 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11398,s21399,s1397 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11400,r21401,nm->mkNode(Kind::STRING_TO_REGEXP, { s1397 }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11398,s21399 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11400,r21401 }) }), e1492, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1480 }),t1480 }));
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SR_SINGLE_NEG_REV, { s1402, t1403, s11404, s21405, r11406, r21407 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11404,s21405,s1402 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11406,r21407,nm->mkNode(Kind::STRING_TO_REGEXP, { t1403 }) }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1402 }),nm->mkNode(Kind::STRING_LENGTH, { t1403 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1402,t1403 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SRS_SINGLE_REV, { s1408, r11409, r21410 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1408,nm->mkNode(Kind::REGEXP_CONCAT, { r11409,r21410,nm->mkNode(Kind::STRING_TO_REGEXP, { s1408 }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1491,nm->mkNode(Kind::REGEXP_CONCAT, { r11409,r21410 }) }), e1492, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SRS_SINGLE_NEG_REV, { s1411, t1412, r11413, r21414 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1411,nm->mkNode(Kind::REGEXP_CONCAT, { r11413,r21414,nm->mkNode(Kind::STRING_TO_REGEXP, { t1412 }) }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1411 }),nm->mkNode(Kind::STRING_LENGTH, { t1412 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1411,t1412 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_S_SINGLE_REV, { s1415, sr11416, sr21417, r1418 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1415,nm->mkNode(Kind::REGEXP_CONCAT, { r1418,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11416,sr21417,s1415 }) }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1491,nm->mkNode(Kind::REGEXP_CONCAT, { r1418,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11416,sr21417 }) }) }) }), e1492, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_S_SINGLE_NEG_REV, { s1419, t1420, sr11421, sr21422, r1423 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1419,nm->mkNode(Kind::REGEXP_CONCAT, { r1423,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11421,sr21422,t1420 }) }) }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1419 }),nm->mkNode(Kind::STRING_LENGTH, { t1420 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1419,t1420 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_REV, { s1424, s11425, s21426, sr11427, sr21428 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11425,s21426,s1424 }),nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11427,sr21428,s1424 }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11425,s21426 }),nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11427,sr21428 }) }) }), e1492, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1481 }),t1481 }));
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_NEG_REV, { s1429, t1430, s11431, s21432, sr11433, sr21434 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11431,s21432,s1429 }),nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11433,sr21434,t1430 }) }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1429 }),nm->mkNode(Kind::STRING_LENGTH, { t1430 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1429,t1430 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_S_SINGLE_REV, { s1435, sr11436, sr21437 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1435,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11436,sr21437,s1435 }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1491,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11436,sr21437 }) }) }), e1492, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_S_SINGLE_NEG_REV, { s1438, t1439, sr11440, sr21441 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1438,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11440,sr21441,t1439 }) }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1438 }),nm->mkNode(Kind::STRING_LENGTH, { t1439 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1438,t1439 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_CHAR_REV, { s1442, s11443, s21444, r11445, r21446 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11443,s21444,s1442 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11445,r21446,e1489 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11443,s21444 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11445,r21446 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1442 }),e1490 }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_CHAR_S_SINGLE_REV, { s1447, r11448, r21449 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1447,nm->mkNode(Kind::REGEXP_CONCAT, { r11448,r21449,e1489 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1491,nm->mkNode(Kind::REGEXP_CONCAT, { r11448,r21449 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1447 }),e1490 }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_REQ_UNFOLD, { s1450, r11451, r21452, r31453 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1450,nm->mkNode(Kind::REGEXP_CONCAT, { e1488,r21452,r31453 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1450,nm->mkNode(Kind::REGEXP_CONCAT, { r11451,e1488,r21452,r31453 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1450,nm->mkNode(Kind::REGEXP_CONCAT, { r21452,r31453 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_REQ_UNFOLD_REV, { s1454, r11455, r21456, r31457 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1454,nm->mkNode(Kind::REGEXP_CONCAT, { r11455,r21456,e1487 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1454,nm->mkNode(Kind::REGEXP_CONCAT, { r11455,r21456,e1487,r31457 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1454,nm->mkNode(Kind::REGEXP_CONCAT, { r11455,r21456 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_SKIP_UNFOLD, { s1458, r11459, r21460, r31461 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1458,nm->mkNode(Kind::REGEXP_CONCAT, { e1486,r21460,r31461 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1458,nm->mkNode(Kind::REGEXP_CONCAT, { r21460,r31461 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1458,nm->mkNode(Kind::REGEXP_CONCAT, { r11459,e1486,r21460,r31461 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_SKIP_UNFOLD_REV, { s1462, r11463, r21464, r31465 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1462,nm->mkNode(Kind::REGEXP_CONCAT, { r11463,r21464,e1485 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1462,nm->mkNode(Kind::REGEXP_CONCAT, { r11463,r21464 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1462,nm->mkNode(Kind::REGEXP_CONCAT, { r11463,r21464,e1485,r31465 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_TEST_UNFOLD, { s1466, r11467, r21468, r31469 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1466,nm->mkNode(Kind::REGEXP_CONCAT, { e1484,r21468,r31469 }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1466,nm->mkNode(Kind::REGEXP_CONCAT, { r21468,r31469 }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1466,nm->mkNode(Kind::REGEXP_CONCAT, { r11467,e1484,r21468,r31469 }) }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_TEST_UNFOLD_REV, { s1470, r11471, r21472, r31473 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1470,nm->mkNode(Kind::REGEXP_CONCAT, { r11471,r21472,e1482 }) }), e1483, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1470,nm->mkNode(Kind::REGEXP_CONCAT, { r11471,r21472 }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1470,nm->mkNode(Kind::REGEXP_CONCAT, { r11471,r21472,e1482,r31473 }) }) }) }), Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
