/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_strings_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node x1966 = NodeManager::mkBoundVar("x1966", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x1966);
Node x967 = NodeManager::mkBoundVar("x967", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x2968 = NodeManager::mkBoundVar("x2968", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x2968);
Node y969 = NodeManager::mkBoundVar("y969", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x970 = NodeManager::mkBoundVar("x970", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y971 = NodeManager::mkBoundVar("y971", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x972 = NodeManager::mkBoundVar("x972", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y973 = NodeManager::mkBoundVar("y973", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node xs974 = NodeManager::mkBoundVar("xs974", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(xs974);
Node s975 = NodeManager::mkBoundVar("s975", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node ys976 = NodeManager::mkBoundVar("ys976", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(ys976);
Node zs977 = NodeManager::mkBoundVar("zs977", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(zs977);
Node x978 = NodeManager::mkBoundVar("x978", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1979 = NodeManager::mkBoundVar("x1979", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x1979);
Node x2980 = NodeManager::mkBoundVar("x2980", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x2980);
Node y981 = NodeManager::mkBoundVar("y981", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x982 = NodeManager::mkBoundVar("x982", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1983 = NodeManager::mkBoundVar("x1983", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x1983);
Node x2984 = NodeManager::mkBoundVar("x2984", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x2984);
Node y985 = NodeManager::mkBoundVar("y985", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x986 = NodeManager::mkBoundVar("x986", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n987 = NodeManager::mkBoundVar("n987", nm->integerType());
Node m988 = NodeManager::mkBoundVar("m988", nm->integerType());
Node x989 = NodeManager::mkBoundVar("x989", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n990 = NodeManager::mkBoundVar("n990", nm->integerType());
Node m991 = NodeManager::mkBoundVar("m991", nm->integerType());
Node x992 = NodeManager::mkBoundVar("x992", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n993 = NodeManager::mkBoundVar("n993", nm->integerType());
Node m994 = NodeManager::mkBoundVar("m994", nm->integerType());
Node x995 = NodeManager::mkBoundVar("x995", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n996 = NodeManager::mkBoundVar("n996", nm->integerType());
Node m997 = NodeManager::mkBoundVar("m997", nm->integerType());
Node s998 = NodeManager::mkBoundVar("s998", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r999 = NodeManager::mkBoundVar("r999", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1000 = NodeManager::mkBoundVar("n1000", nm->integerType());
Node m1001 = NodeManager::mkBoundVar("m1001", nm->integerType());
Node t1002 = NodeManager::mkBoundVar("t1002", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1003 = NodeManager::mkBoundVar("s1003", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1004 = NodeManager::mkBoundVar("r1004", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1005 = NodeManager::mkBoundVar("t1005", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1006 = NodeManager::mkBoundVar("n1006", nm->integerType());
Node r1007 = NodeManager::mkBoundVar("r1007", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1008 = NodeManager::mkBoundVar("s1008", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1009 = NodeManager::mkBoundVar("n1009", nm->integerType());
Node m1010 = NodeManager::mkBoundVar("m1010", nm->integerType());
Node s1011 = NodeManager::mkBoundVar("s1011", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1012 = NodeManager::mkBoundVar("n1012", nm->integerType());
Node m1013 = NodeManager::mkBoundVar("m1013", nm->integerType());
Node k1014 = NodeManager::mkBoundVar("k1014", nm->integerType());
Node s1015 = NodeManager::mkBoundVar("s1015", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1016 = NodeManager::mkBoundVar("n1016", nm->integerType());
Node m1017 = NodeManager::mkBoundVar("m1017", nm->integerType());
Node k1018 = NodeManager::mkBoundVar("k1018", nm->integerType());
Node s11019 = NodeManager::mkBoundVar("s11019", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21020 = NodeManager::mkBoundVar("s21020", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s21020);
Node t11021 = NodeManager::mkBoundVar("t11021", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t21022 = NodeManager::mkBoundVar("t21022", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t21022);
Node s11023 = NodeManager::mkBoundVar("s11023", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21024 = NodeManager::mkBoundVar("s21024", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s21024);
Node t11025 = NodeManager::mkBoundVar("t11025", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t21026 = NodeManager::mkBoundVar("t21026", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t21026);
Node s11027 = NodeManager::mkBoundVar("s11027", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t11028 = NodeManager::mkBoundVar("t11028", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t21029 = NodeManager::mkBoundVar("t21029", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t21029);
Node s11030 = NodeManager::mkBoundVar("s11030", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t11031 = NodeManager::mkBoundVar("t11031", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t21032 = NodeManager::mkBoundVar("t21032", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t21032);
Node s11033 = NodeManager::mkBoundVar("s11033", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21034 = NodeManager::mkBoundVar("s21034", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31035 = NodeManager::mkBoundVar("s31035", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31035);
Node t21036 = NodeManager::mkBoundVar("t21036", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t31037 = NodeManager::mkBoundVar("t31037", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t31037);
Node t1262 = NodeManager::mkBoundVar("t1262", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s11038 = NodeManager::mkBoundVar("s11038", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21039 = NodeManager::mkBoundVar("s21039", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31040 = NodeManager::mkBoundVar("s31040", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31040);
Node t21041 = NodeManager::mkBoundVar("t21041", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t31042 = NodeManager::mkBoundVar("t31042", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t31042);
Node t1263 = NodeManager::mkBoundVar("t1263", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1043 = NodeManager::mkBoundVar("s1043", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t11044 = NodeManager::mkBoundVar("t11044", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t21045 = NodeManager::mkBoundVar("t21045", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t21045);
Node s1046 = NodeManager::mkBoundVar("s1046", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t11047 = NodeManager::mkBoundVar("t11047", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t21048 = NodeManager::mkBoundVar("t21048", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t21048);
Node s11049 = NodeManager::mkBoundVar("s11049", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21050 = NodeManager::mkBoundVar("s21050", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s21050);
Node s31051 = NodeManager::mkBoundVar("s31051", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31051);
Node t11052 = NodeManager::mkBoundVar("t11052", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t21053 = NodeManager::mkBoundVar("t21053", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t21053);
Node t31054 = NodeManager::mkBoundVar("t31054", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t31054);
Node s11055 = NodeManager::mkBoundVar("s11055", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21056 = NodeManager::mkBoundVar("s21056", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s21056);
Node s31057 = NodeManager::mkBoundVar("s31057", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31057);
Node t11058 = NodeManager::mkBoundVar("t11058", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t21059 = NodeManager::mkBoundVar("t21059", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t21059);
Node t31060 = NodeManager::mkBoundVar("t31060", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t31060);
Node s1061 = NodeManager::mkBoundVar("s1061", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1062 = NodeManager::mkBoundVar("t1062", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1063 = NodeManager::mkBoundVar("s1063", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1064 = NodeManager::mkBoundVar("t1064", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1065 = NodeManager::mkBoundVar("s1065", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1066 = NodeManager::mkBoundVar("t1066", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1067 = NodeManager::mkBoundVar("s1067", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1068 = NodeManager::mkBoundVar("t1068", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1069 = NodeManager::mkBoundVar("s1069", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n11070 = NodeManager::mkBoundVar("n11070", nm->integerType());
Node m11071 = NodeManager::mkBoundVar("m11071", nm->integerType());
Node n21072 = NodeManager::mkBoundVar("n21072", nm->integerType());
Node m21073 = NodeManager::mkBoundVar("m21073", nm->integerType());
Node s1074 = NodeManager::mkBoundVar("s1074", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n11075 = NodeManager::mkBoundVar("n11075", nm->integerType());
Node m11076 = NodeManager::mkBoundVar("m11076", nm->integerType());
Node n21077 = NodeManager::mkBoundVar("n21077", nm->integerType());
Node m21078 = NodeManager::mkBoundVar("m21078", nm->integerType());
Node s1079 = NodeManager::mkBoundVar("s1079", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n11080 = NodeManager::mkBoundVar("n11080", nm->integerType());
Node m11081 = NodeManager::mkBoundVar("m11081", nm->integerType());
Node n21082 = NodeManager::mkBoundVar("n21082", nm->integerType());
Node m21083 = NodeManager::mkBoundVar("m21083", nm->integerType());
Node s1084 = NodeManager::mkBoundVar("s1084", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n11085 = NodeManager::mkBoundVar("n11085", nm->integerType());
Node m11086 = NodeManager::mkBoundVar("m11086", nm->integerType());
Node n21087 = NodeManager::mkBoundVar("n21087", nm->integerType());
Node m21088 = NodeManager::mkBoundVar("m21088", nm->integerType());
Node s11089 = NodeManager::mkBoundVar("s11089", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21090 = NodeManager::mkBoundVar("s21090", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s21090);
Node n1091 = NodeManager::mkBoundVar("n1091", nm->integerType());
Node m1092 = NodeManager::mkBoundVar("m1092", nm->integerType());
Node s11093 = NodeManager::mkBoundVar("s11093", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21094 = NodeManager::mkBoundVar("s21094", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31095 = NodeManager::mkBoundVar("s31095", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31095);
Node n1096 = NodeManager::mkBoundVar("n1096", nm->integerType());
Node m1097 = NodeManager::mkBoundVar("m1097", nm->integerType());
Node s1098 = NodeManager::mkBoundVar("s1098", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1099 = NodeManager::mkBoundVar("n1099", nm->integerType());
Node s1100 = NodeManager::mkBoundVar("s1100", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1101 = NodeManager::mkBoundVar("n1101", nm->integerType());
Node x1102 = NodeManager::mkBoundVar("x1102", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node xs1103 = NodeManager::mkBoundVar("xs1103", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(xs1103);
Node z1104 = NodeManager::mkBoundVar("z1104", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1105 = NodeManager::mkBoundVar("y1105", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node zs1106 = NodeManager::mkBoundVar("zs1106", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(zs1106);
Node x1107 = NodeManager::mkBoundVar("x1107", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1108 = NodeManager::mkBoundVar("y1108", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1109 = NodeManager::mkBoundVar("z1109", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(z1109);
Node w1110 = NodeManager::mkBoundVar("w1110", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1111 = NodeManager::mkBoundVar("x1111", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1112 = NodeManager::mkBoundVar("y1112", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1113 = NodeManager::mkBoundVar("x1113", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1114 = NodeManager::mkBoundVar("y1114", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1115 = NodeManager::mkBoundVar("x1115", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1116 = NodeManager::mkBoundVar("y1116", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1117 = NodeManager::mkBoundVar("x1117", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1118 = NodeManager::mkBoundVar("y1118", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1119 = NodeManager::mkBoundVar("x1119", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1120 = NodeManager::mkBoundVar("n1120", nm->integerType());
Node t1121 = NodeManager::mkBoundVar("t1121", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1122 = NodeManager::mkBoundVar("s1122", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1123 = NodeManager::mkBoundVar("t1123", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1124 = NodeManager::mkBoundVar("r1124", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(r1124);
Node s1125 = NodeManager::mkBoundVar("s1125", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1126 = NodeManager::mkBoundVar("t1126", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1127 = NodeManager::mkBoundVar("s1127", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1128 = NodeManager::mkBoundVar("r1128", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1129 = NodeManager::mkBoundVar("t1129", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1130 = NodeManager::mkBoundVar("s1130", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1131 = NodeManager::mkBoundVar("r1131", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t11132 = NodeManager::mkBoundVar("t11132", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t21133 = NodeManager::mkBoundVar("t21133", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t21133);
Node s1134 = NodeManager::mkBoundVar("s1134", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1135 = NodeManager::mkBoundVar("r1135", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1136 = NodeManager::mkBoundVar("t1136", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1137 = NodeManager::mkBoundVar("s1137", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1138 = NodeManager::mkBoundVar("r1138", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1139 = NodeManager::mkBoundVar("t1139", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1140 = NodeManager::mkBoundVar("r1140", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1141 = NodeManager::mkBoundVar("t1141", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1142 = NodeManager::mkBoundVar("r1142", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s11143 = NodeManager::mkBoundVar("s11143", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21144 = NodeManager::mkBoundVar("s21144", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31145 = NodeManager::mkBoundVar("s31145", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31145);
Node t1264 = NodeManager::mkBoundVar("t1264", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t1146 = NodeManager::mkBoundVar("t1146", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1147 = NodeManager::mkBoundVar("n1147", nm->integerType());
Node t1148 = NodeManager::mkBoundVar("t1148", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1149 = NodeManager::mkBoundVar("s1149", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1150 = NodeManager::mkBoundVar("n1150", nm->integerType());
Node t11151 = NodeManager::mkBoundVar("t11151", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t21152 = NodeManager::mkBoundVar("t21152", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t21152);
Node s1153 = NodeManager::mkBoundVar("s1153", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1154 = NodeManager::mkBoundVar("n1154", nm->integerType());
Node t1155 = NodeManager::mkBoundVar("t1155", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1156 = NodeManager::mkBoundVar("n1156", nm->integerType());
Node s11157 = NodeManager::mkBoundVar("s11157", nm->stringType());
Node s21158 = NodeManager::mkBoundVar("s21158", nm->stringType());
Node s31159 = NodeManager::mkBoundVar("s31159", nm->stringType());expr::markListVar(s31159);
Node t1265 = NodeManager::mkBoundVar("t1265", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s11160 = NodeManager::mkBoundVar("s11160", nm->stringType());
Node s21161 = NodeManager::mkBoundVar("s21161", nm->stringType());
Node s31162 = NodeManager::mkBoundVar("s31162", nm->stringType());expr::markListVar(s31162);
Node t1266 = NodeManager::mkBoundVar("t1266", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1163 = NodeManager::mkBoundVar("s1163", nm->stringType());
Node s1164 = NodeManager::mkBoundVar("s1164", nm->stringType());
Node s1165 = NodeManager::mkBoundVar("s1165", nm->stringType());
Node s1166 = NodeManager::mkBoundVar("s1166", nm->stringType());
Node n1167 = NodeManager::mkBoundVar("n1167", nm->integerType());
Node n1168 = NodeManager::mkBoundVar("n1168", nm->integerType());
Node s11169 = NodeManager::mkBoundVar("s11169", nm->stringType());expr::markListVar(s11169);
Node s21170 = NodeManager::mkBoundVar("s21170", nm->stringType());
Node s31171 = NodeManager::mkBoundVar("s31171", nm->stringType());expr::markListVar(s31171);
Node s1172 = NodeManager::mkBoundVar("s1172", nm->stringType());
Node s1173 = NodeManager::mkBoundVar("s1173", nm->stringType());
Node s1174 = NodeManager::mkBoundVar("s1174", nm->stringType());expr::markListVar(s1174);
Node t11175 = NodeManager::mkBoundVar("t11175", nm->stringType());
Node s11176 = NodeManager::mkBoundVar("s11176", nm->stringType());
Node t21177 = NodeManager::mkBoundVar("t21177", nm->stringType());expr::markListVar(t21177);
Node s21178 = NodeManager::mkBoundVar("s21178", nm->stringType());expr::markListVar(s21178);
Node s1179 = NodeManager::mkBoundVar("s1179", nm->stringType());expr::markListVar(s1179);
Node t11180 = NodeManager::mkBoundVar("t11180", nm->stringType());
Node s11181 = NodeManager::mkBoundVar("s11181", nm->stringType());
Node t21182 = NodeManager::mkBoundVar("t21182", nm->stringType());expr::markListVar(t21182);
Node s21183 = NodeManager::mkBoundVar("s21183", nm->stringType());expr::markListVar(s21183);
Node s1184 = NodeManager::mkBoundVar("s1184", nm->stringType());
Node t1185 = NodeManager::mkBoundVar("t1185", nm->stringType());
Node x1186 = NodeManager::mkBoundVar("x1186", nm->regExpType());
Node x1187 = NodeManager::mkBoundVar("x1187", nm->regExpType());
Node y1188 = NodeManager::mkBoundVar("y1188", nm->regExpType());
Node xs1189 = NodeManager::mkBoundVar("xs1189", nm->regExpType());expr::markListVar(xs1189);
Node ys1190 = NodeManager::mkBoundVar("ys1190", nm->regExpType());expr::markListVar(ys1190);
Node xs1191 = NodeManager::mkBoundVar("xs1191", nm->regExpType());expr::markListVar(xs1191);
Node ys1192 = NodeManager::mkBoundVar("ys1192", nm->regExpType());expr::markListVar(ys1192);
Node xs1193 = NodeManager::mkBoundVar("xs1193", nm->regExpType());expr::markListVar(xs1193);
Node s1194 = NodeManager::mkBoundVar("s1194", nm->regExpType());
Node ys1195 = NodeManager::mkBoundVar("ys1195", nm->regExpType());expr::markListVar(ys1195);
Node zs1196 = NodeManager::mkBoundVar("zs1196", nm->regExpType());expr::markListVar(zs1196);
Node xs1197 = NodeManager::mkBoundVar("xs1197", nm->regExpType());expr::markListVar(xs1197);
Node r1198 = NodeManager::mkBoundVar("r1198", nm->regExpType());
Node ys1199 = NodeManager::mkBoundVar("ys1199", nm->regExpType());expr::markListVar(ys1199);
Node xs1200 = NodeManager::mkBoundVar("xs1200", nm->regExpType());expr::markListVar(xs1200);
Node r1201 = NodeManager::mkBoundVar("r1201", nm->regExpType());
Node ys1202 = NodeManager::mkBoundVar("ys1202", nm->regExpType());expr::markListVar(ys1202);
Node xs1203 = NodeManager::mkBoundVar("xs1203", nm->regExpType());expr::markListVar(xs1203);
Node s1204 = NodeManager::mkBoundVar("s1204", nm->stringType());
Node t1205 = NodeManager::mkBoundVar("t1205", nm->stringType());
Node ys1206 = NodeManager::mkBoundVar("ys1206", nm->regExpType());expr::markListVar(ys1206);
Node t1267 = NodeManager::mkBoundVar("t1267", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1207 = NodeManager::mkBoundVar("xs1207", nm->regExpType());expr::markListVar(xs1207);
Node ys1208 = NodeManager::mkBoundVar("ys1208", nm->regExpType());expr::markListVar(ys1208);
Node xs1209 = NodeManager::mkBoundVar("xs1209", nm->regExpType());expr::markListVar(xs1209);
Node ys1210 = NodeManager::mkBoundVar("ys1210", nm->regExpType());expr::markListVar(ys1210);
Node t1268 = NodeManager::mkBoundVar("t1268", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1211 = NodeManager::mkBoundVar("xs1211", nm->regExpType());expr::markListVar(xs1211);
Node b1212 = NodeManager::mkBoundVar("b1212", nm->regExpType());
Node ys1213 = NodeManager::mkBoundVar("ys1213", nm->regExpType());expr::markListVar(ys1213);
Node zs1214 = NodeManager::mkBoundVar("zs1214", nm->regExpType());expr::markListVar(zs1214);
Node t1269 = NodeManager::mkBoundVar("t1269", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1215 = NodeManager::mkBoundVar("xs1215", nm->regExpType());expr::markListVar(xs1215);
Node b1216 = NodeManager::mkBoundVar("b1216", nm->regExpType());
Node ys1217 = NodeManager::mkBoundVar("ys1217", nm->regExpType());expr::markListVar(ys1217);
Node zs1218 = NodeManager::mkBoundVar("zs1218", nm->regExpType());expr::markListVar(zs1218);
Node t1270 = NodeManager::mkBoundVar("t1270", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1219 = NodeManager::mkBoundVar("xs1219", nm->regExpType());expr::markListVar(xs1219);
Node ys1220 = NodeManager::mkBoundVar("ys1220", nm->regExpType());expr::markListVar(ys1220);
Node t1271 = NodeManager::mkBoundVar("t1271", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1221 = NodeManager::mkBoundVar("xs1221", nm->regExpType());expr::markListVar(xs1221);
Node ys1222 = NodeManager::mkBoundVar("ys1222", nm->regExpType());expr::markListVar(ys1222);
Node xs1223 = NodeManager::mkBoundVar("xs1223", nm->regExpType());expr::markListVar(xs1223);
Node b1224 = NodeManager::mkBoundVar("b1224", nm->regExpType());
Node ys1225 = NodeManager::mkBoundVar("ys1225", nm->regExpType());expr::markListVar(ys1225);
Node zs1226 = NodeManager::mkBoundVar("zs1226", nm->regExpType());expr::markListVar(zs1226);
Node t1272 = NodeManager::mkBoundVar("t1272", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1227 = NodeManager::mkBoundVar("xs1227", nm->regExpType());expr::markListVar(xs1227);
Node b1228 = NodeManager::mkBoundVar("b1228", nm->regExpType());
Node ys1229 = NodeManager::mkBoundVar("ys1229", nm->regExpType());expr::markListVar(ys1229);
Node zs1230 = NodeManager::mkBoundVar("zs1230", nm->regExpType());expr::markListVar(zs1230);
Node t1273 = NodeManager::mkBoundVar("t1273", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node n1231 = NodeManager::mkBoundVar("n1231", nm->integerType());
Node m1232 = NodeManager::mkBoundVar("m1232", nm->integerType());
Node r1233 = NodeManager::mkBoundVar("r1233", nm->regExpType());
Node xs1234 = NodeManager::mkBoundVar("xs1234", nm->regExpType());expr::markListVar(xs1234);
Node ys1235 = NodeManager::mkBoundVar("ys1235", nm->regExpType());expr::markListVar(ys1235);
Node s1236 = NodeManager::mkBoundVar("s1236", nm->stringType());
Node xs1237 = NodeManager::mkBoundVar("xs1237", nm->regExpType());expr::markListVar(xs1237);
Node ys1238 = NodeManager::mkBoundVar("ys1238", nm->regExpType());expr::markListVar(ys1238);
Node s1239 = NodeManager::mkBoundVar("s1239", nm->stringType());
Node s11240 = NodeManager::mkBoundVar("s11240", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21241 = NodeManager::mkBoundVar("s21241", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s21241);
Node n1242 = NodeManager::mkBoundVar("n1242", nm->integerType());
Node m1243 = NodeManager::mkBoundVar("m1243", nm->integerType());
Node s11244 = NodeManager::mkBoundVar("s11244", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21245 = NodeManager::mkBoundVar("s21245", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31246 = NodeManager::mkBoundVar("s31246", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31246);
Node n1247 = NodeManager::mkBoundVar("n1247", nm->integerType());
Node s11248 = NodeManager::mkBoundVar("s11248", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21249 = NodeManager::mkBoundVar("s21249", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31250 = NodeManager::mkBoundVar("s31250", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31250);
Node n1251 = NodeManager::mkBoundVar("n1251", nm->integerType());
Node m1252 = NodeManager::mkBoundVar("m1252", nm->integerType());
Node x1253 = NodeManager::mkBoundVar("x1253", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1254 = NodeManager::mkBoundVar("x1254", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1255 = NodeManager::mkBoundVar("x1255", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1256 = NodeManager::mkBoundVar("y1256", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(y1256);
Node z1257 = NodeManager::mkBoundVar("z1257", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1274 = NodeManager::mkBoundVar("t1274", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1258 = NodeManager::mkBoundVar("x1258", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1259 = NodeManager::mkBoundVar("x1259", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1260 = NodeManager::mkBoundVar("x1260", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1261 = NodeManager::mkBoundVar("x1261", nm->mkAbstractType(Kind::SEQUENCE_TYPE));

  // Definitions
Node e1275 = nm->mkNode(Kind::SEQ_UNIT, { x1260 });
Node e1276 = nm->mkConstInt(Rational(0));
Node e1277 = nm->mkConst(true);
Node e1278 = nm->mkNode(Kind::STRING_LENGTH, { s11248 });
Node e1279 = nm->mkNode(Kind::STRING_LENGTH, { s11244 });
Node e1280 = nm->mkNode(Kind::STRING_TO_REGEXP, { s1236 });
Node e1281 = nm->mkNode(Kind::REGEXP_NONE, {  });
Node e1282 = nm->mkNode(Kind::REGEXP_STAR, { nm->mkNode(Kind::REGEXP_ALLCHAR, {  }) });
Node e1283 = nm->mkNode(Kind::REGEXP_STAR, { r1201 });
Node e1284 = nm->mkNode(Kind::REGEXP_STAR, { r1198 });
Node e1285 = nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkConst(String("")) });
Node e1286 = nm->mkConst(false);
Node e1287 = nm->mkConst(String(""));
Node e1288 = nm->mkConstInt(Rational(1));
Node e1289 = nm->mkConstInt(-(Rational(1)));
Node e1290 = nm->mkNode(Kind::STRING_ITOS, { n1168 });
Node e1291 = nm->mkNode(Kind::STRING_ITOS, { n1167 });
Node e1292 = nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { t1146 }) });
Node e1293 = nm->mkNode(Kind::STRING_LENGTH, { s11093 });
Node e1294 = nm->mkNode(Kind::STRING_SUBSTR, { s1084,n11085,m11086 });
Node e1295 = nm->mkNode(Kind::STRING_SUBSTR, { s1079,n11080,m11081 });
Node e1296 = nm->mkNode(Kind::SUB, { m11071,n21072 });
Node e1297 = nm->mkNode(Kind::STRING_LENGTH, { s1063 });

  // Rules

        {
            // from rewrites-strings-rewrites.cpp
            db.addRule(ProofRewriteRule::STR_EQ_CTN_FALSE, { x1966, x967, x2968, y969 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { x1966,x967,x2968 }),y969 }), e1286, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONTAINS, { y969,x967 }),e1286 }), Node::null());
db.addRule(ProofRewriteRule::STR_EQ_CTN_FULL_FALSE1, { x970, y971 }, nm->mkNode(Kind::EQUAL, { x970,y971 }), e1286, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONTAINS, { y971,x970 }),e1286 }), Node::null());
db.addRule(ProofRewriteRule::STR_EQ_CTN_FULL_FALSE2, { x972, y973 }, nm->mkNode(Kind::EQUAL, { x972,y973 }), e1286, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONTAINS, { x972,y973 }),e1286 }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_FLATTEN, { xs974, s975, ys976, zs977 }, nm->mkNode(Kind::STRING_CONCAT, { xs974,nm->mkNode(Kind::STRING_CONCAT, { s975,ys976 }),zs977 }), nm->mkNode(Kind::STRING_CONCAT, { xs974,s975,ys976,zs977 }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_FLATTEN_EQ, { x978, x1979, x2980, y981 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_CONCAT, { x978,x1979 }),x2980 }),y981 }), nm->mkNode(Kind::EQUAL, { y981,nm->mkNode(Kind::STRING_CONCAT, { x978,x1979,x2980 }) }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_FLATTEN_EQ_REV, { x982, x1983, x2984, y985 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { x2984,nm->mkNode(Kind::STRING_CONCAT, { x1983,x982 }) }),y985 }), nm->mkNode(Kind::EQUAL, { y985,nm->mkNode(Kind::STRING_CONCAT, { x2984,x1983,x982 }) }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_EMPTY_STR, { x986, n987, m988 }, nm->mkNode(Kind::STRING_SUBSTR, { x986,n987,m988 }), x986, nm->mkNode(Kind::EQUAL, { x986,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x986 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_EMPTY_RANGE, { x989, n990, m991 }, nm->mkNode(Kind::STRING_SUBSTR, { x989,n990,m991 }), nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x989 }) }), nm->mkNode(Kind::GEQ, { e1276,m991 }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_EMPTY_START, { x992, n993, m994 }, nm->mkNode(Kind::STRING_SUBSTR, { x992,n993,m994 }), nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x992 }) }), nm->mkNode(Kind::GEQ, { n993,nm->mkNode(Kind::STRING_LENGTH, { x992 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_EMPTY_START_NEG, { x995, n996, m997 }, nm->mkNode(Kind::STRING_SUBSTR, { x995,n996,m997 }), nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x995 }) }), nm->mkNode(Kind::LT, { n996,e1276 }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_EQ_EMPTY, { s998, r999, n1000, m1001 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_SUBSTR, { s998,n1000,m1001 }),r999 }), nm->mkNode(Kind::EQUAL, { s998,r999 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { n1000,e1276 }),nm->mkNode(Kind::GT, { m1001,n1000 }),nm->mkNode(Kind::EQUAL, { r999,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { r999 }) }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_LEN_REPLACE_INV, { t1002, s1003, r1004 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_REPLACE, { t1002,s1003,r1004 }) }), nm->mkNode(Kind::STRING_LENGTH, { t1002 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1003 }),nm->mkNode(Kind::STRING_LENGTH, { r1004 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_LEN_UPDATE_INV, { t1005, n1006, r1007 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_UPDATE, { t1005,n1006,r1007 }) }), nm->mkNode(Kind::STRING_LENGTH, { t1005 }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_LEN_SUBSTR_IN_RANGE, { s1008, n1009, m1010 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_SUBSTR, { s1008,n1009,m1010 }) }), m1010, nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n1009,e1276 }),nm->mkNode(Kind::GEQ, { m1010,e1276 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { s1008 }),nm->mkNode(Kind::ADD, { n1009,m1010 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_LEN_SUBSTR_UB1, { s1011, n1012, m1013, k1014 }, nm->mkNode(Kind::GEQ, { k1014,nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_SUBSTR, { s1011,n1012,m1013 }) }) }), e1277, nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { k1014,e1276 }),nm->mkNode(Kind::GEQ, { k1014,m1013 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_LEN_SUBSTR_UB2, { s1015, n1016, m1017, k1018 }, nm->mkNode(Kind::GEQ, { k1018,nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_SUBSTR, { s1015,n1016,m1017 }) }) }), e1277, nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { k1018,e1276 }),nm->mkNode(Kind::GEQ, { k1018,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::STRING_LENGTH, { s1015 }),n1016 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH, { s11019, s21020, t11021, t21022 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s11019,s21020 }),nm->mkNode(Kind::STRING_CONCAT, { t11021,t21022 }) }), e1286, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s11019,t11021 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s11019 }),nm->mkNode(Kind::STRING_LENGTH, { t11021 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH_REV, { s11023, s21024, t11025, t21026 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s21024,s11023 }),nm->mkNode(Kind::STRING_CONCAT, { t21026,t11025 }) }), e1286, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s11023,t11025 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s11023 }),nm->mkNode(Kind::STRING_LENGTH, { t11025 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH2, { s11027, t11028, t21029 }, nm->mkNode(Kind::EQUAL, { s11027,nm->mkNode(Kind::STRING_CONCAT, { t11028,t21029 }) }), e1286, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s11027,t11028 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s11027 }),nm->mkNode(Kind::STRING_LENGTH, { t11028 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH2_REV, { s11030, t11031, t21032 }, nm->mkNode(Kind::EQUAL, { s11030,nm->mkNode(Kind::STRING_CONCAT, { t21032,t11031 }) }), e1286, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s11030,t11031 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s11030 }),nm->mkNode(Kind::STRING_LENGTH, { t11031 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_UNIFY, { s11033, s21034, s31035, t21036, t31037 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s11033,s21034,s31035 }),nm->mkNode(Kind::STRING_CONCAT, { s11033,t21036,t31037 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s21034,s31035 }),nm->mkNode(Kind::STRING_CONCAT, { t21036,t31037 }) }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1262 }),t1262 }));
db.addRule(ProofRewriteRule::STR_CONCAT_UNIFY_REV, { s11038, s21039, s31040, t21041, t31042 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s21039,s31040,s11038 }),nm->mkNode(Kind::STRING_CONCAT, { t21041,t31042,s11038 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s21039,s31040 }),nm->mkNode(Kind::STRING_CONCAT, { t21041,t31042 }) }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1263 }),t1263 }));
db.addRule(ProofRewriteRule::STR_CONCAT_UNIFY_BASE, { s1043, t11044, t21045 }, nm->mkNode(Kind::EQUAL, { s1043,nm->mkNode(Kind::STRING_CONCAT, { s1043,t11044,t21045 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { s1043 }) }),nm->mkNode(Kind::STRING_CONCAT, { t11044,t21045 }) }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_UNIFY_BASE_REV, { s1046, t11047, t21048 }, nm->mkNode(Kind::EQUAL, { s1046,nm->mkNode(Kind::STRING_CONCAT, { t11047,t21048,s1046 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { s1046 }) }),nm->mkNode(Kind::STRING_CONCAT, { t11047,t21048 }) }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH_CHAR, { s11049, s21050, s31051, t11052, t21053, t31054 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_CONCAT, { s11049,s21050 }),s31051 }),nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_CONCAT, { t11052,t21053 }),t31054 }) }), e1286, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s11049,t11052 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s11049 }),nm->mkNode(Kind::STRING_LENGTH, { t11052 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH_CHAR_REV, { s11055, s21056, s31057, t11058, t21059, t31060 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s31057,nm->mkNode(Kind::STRING_CONCAT, { s21056,s11055 }) }),nm->mkNode(Kind::STRING_CONCAT, { t31060,nm->mkNode(Kind::STRING_CONCAT, { t21059,t11058 }) }) }), e1286, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s11055,t11058 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s11055 }),nm->mkNode(Kind::STRING_LENGTH, { t11058 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_PREFIXOF_ELIM, { s1061, t1062 }, nm->mkNode(Kind::STRING_PREFIX, { s1061,t1062 }), nm->mkNode(Kind::EQUAL, { s1061,nm->mkNode(Kind::STRING_SUBSTR, { t1062,e1276,nm->mkNode(Kind::STRING_LENGTH, { s1061 }) }) }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_SUFFIXOF_ELIM, { s1063, t1064 }, nm->mkNode(Kind::STRING_SUFFIX, { s1063,t1064 }), nm->mkNode(Kind::EQUAL, { s1063,nm->mkNode(Kind::STRING_SUBSTR, { t1064,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::STRING_LENGTH, { t1064 }),e1297 }),e1297 }) }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_PREFIXOF_ONE, { s1065, t1066 }, nm->mkNode(Kind::STRING_PREFIX, { s1065,t1066 }), nm->mkNode(Kind::STRING_CONTAINS, { t1066,s1065 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t1066 }),e1288 }), Node::null());
db.addRule(ProofRewriteRule::STR_SUFFIXOF_ONE, { s1067, t1068 }, nm->mkNode(Kind::STRING_SUFFIX, { s1067,t1068 }), nm->mkNode(Kind::STRING_CONTAINS, { t1068,s1067 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t1068 }),e1288 }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_COMBINE1, { s1069, n11070, m11071, n21072, m21073 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_SUBSTR, { s1069,n11070,m11071 }),n21072,m21073 }), nm->mkNode(Kind::STRING_SUBSTR, { s1069,nm->mkNode(Kind::ADD, { n11070,n21072 }),e1296 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n11070,e1276 }),nm->mkNode(Kind::GEQ, { n21072,e1276 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::SUB, { m21073,e1296 }),e1276 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_COMBINE2, { s1074, n11075, m11076, n21077, m21078 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_SUBSTR, { s1074,n11075,m11076 }),n21077,m21078 }), nm->mkNode(Kind::STRING_SUBSTR, { s1074,nm->mkNode(Kind::ADD, { n11075,n21077 }),m21078 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n11075,e1276 }),nm->mkNode(Kind::GEQ, { n21077,e1276 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SUB, { m11076,n21077 }),m21078 }),e1276 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_COMBINE3, { s1079, n11080, m11081, n21082, m21083 }, nm->mkNode(Kind::STRING_SUBSTR, { e1295,n21082,m21083 }), nm->mkNode(Kind::STRING_SUBSTR, { s1079,nm->mkNode(Kind::ADD, { n11080,n21082 }),m21083 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n11080,e1276 }),nm->mkNode(Kind::GEQ, { n21082,e1276 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { e1295 }),nm->mkNode(Kind::ADD, { n21082,m21083 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_COMBINE4, { s1084, n11085, m11086, n21087, m21088 }, nm->mkNode(Kind::STRING_SUBSTR, { e1294,n21087,m21088 }), nm->mkNode(Kind::STRING_SUBSTR, { s1084,nm->mkNode(Kind::ADD, { n11085,n21087 }),nm->mkNode(Kind::SUB, { m11086,n21087 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n11085,e1276 }),nm->mkNode(Kind::GEQ, { n21087,e1276 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::ADD, { n21087,m21088 }),nm->mkNode(Kind::STRING_LENGTH, { e1294 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_CONCAT1, { s11089, s21090, n1091, m1092 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s11089,s21090 }),n1091,m1092 }), nm->mkNode(Kind::STRING_SUBSTR, { s11089,n1091,m1092 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n1091,e1276 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { s11089 }),nm->mkNode(Kind::ADD, { n1091,m1092 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_CONCAT2, { s11093, s21094, s31095, n1096, m1097 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s11093,s21094,s31095 }),n1096,m1097 }), nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s21094,s31095 }),nm->mkNode(Kind::SUB, { n1096,e1293 }),m1097 }), nm->mkNode(Kind::GEQ, { n1096,e1293 }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_FULL, { s1098, n1099 }, nm->mkNode(Kind::STRING_SUBSTR, { s1098,e1276,n1099 }), s1098, nm->mkNode(Kind::GEQ, { n1099,nm->mkNode(Kind::STRING_LENGTH, { s1098 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_FULL_EQ, { s1100, n1101 }, nm->mkNode(Kind::STRING_SUBSTR, { s1100,e1276,n1101 }), s1100, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1100 }),n1101 }), Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_REFL, { x1102 }, nm->mkNode(Kind::STRING_CONTAINS, { x1102,x1102 }), e1277, e1277, Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_CONCAT_FIND, { xs1103, z1104, y1105, zs1106 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_CONCAT, { xs1103,z1104,zs1106 }),y1105 }), e1277, nm->mkNode(Kind::STRING_CONTAINS, { z1104,y1105 }), Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_SPLIT_CHAR, { x1107, y1108, z1109, w1110 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_CONCAT, { x1107,y1108,z1109 }),w1110 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::STRING_CONTAINS, { x1107,w1110 }),nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_CONCAT, { y1108,z1109 }),w1110 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { w1110 }),e1288 }), Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_LT_LEN, { x1111, y1112 }, nm->mkNode(Kind::STRING_CONTAINS, { x1111,y1112 }), e1286, nm->mkNode(Kind::GT, { nm->mkNode(Kind::STRING_LENGTH, { y1112 }),nm->mkNode(Kind::STRING_LENGTH, { x1111 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_LEQ_LEN_EQ, { x1113, y1114 }, nm->mkNode(Kind::STRING_CONTAINS, { x1113,y1114 }), nm->mkNode(Kind::EQUAL, { x1113,y1114 }), nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { y1114 }),nm->mkNode(Kind::STRING_LENGTH, { x1113 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_EMP, { x1115, y1116 }, nm->mkNode(Kind::STRING_CONTAINS, { x1115,y1116 }), e1277, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { y1116 }),e1276 }), Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_IS_EMP, { x1117, y1118 }, nm->mkNode(Kind::STRING_CONTAINS, { x1117,y1118 }), nm->mkNode(Kind::EQUAL, { x1117,y1118 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { x1117 }),e1276 }), Node::null());
db.addRule(ProofRewriteRule::STR_AT_ELIM, { x1119, n1120 }, nm->mkNode(Kind::STRING_CHARAT, { x1119,n1120 }), nm->mkNode(Kind::STRING_SUBSTR, { x1119,n1120,e1288 }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_REPLACE_SELF, { t1121, s1122 }, nm->mkNode(Kind::STRING_REPLACE, { t1121,t1121,s1122 }), s1122, e1277, Node::null());
db.addRule(ProofRewriteRule::STR_REPLACE_PREFIX, { t1123, r1124, s1125 }, nm->mkNode(Kind::STRING_REPLACE, { nm->mkNode(Kind::STRING_CONCAT, { t1123,r1124 }),t1123,s1125 }), nm->mkNode(Kind::STRING_CONCAT, { s1125,r1124 }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_REPLACE_NO_CONTAINS, { t1126, s1127, r1128 }, nm->mkNode(Kind::STRING_REPLACE, { t1126,s1127,r1128 }), t1126, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { t1126,s1127 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_REPLACE_EMPTY, { t1129, s1130, r1131 }, nm->mkNode(Kind::STRING_REPLACE, { t1129,r1131,s1130 }), nm->mkNode(Kind::STRING_CONCAT, { s1130,t1129 }), nm->mkNode(Kind::EQUAL, { r1131,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { r1131 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_REPLACE_CONTAINS_PRE, { t11132, t21133, s1134, r1135 }, nm->mkNode(Kind::STRING_REPLACE, { nm->mkNode(Kind::STRING_CONCAT, { t11132,t21133 }),s1134,r1135 }), nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_REPLACE, { t11132,s1134,r1135 }),t21133 }), nm->mkNode(Kind::STRING_CONTAINS, { t11132,s1134 }), Node::null());
db.addRule(ProofRewriteRule::STR_REPLACE_ALL_NO_CONTAINS, { t1136, s1137, r1138 }, nm->mkNode(Kind::STRING_REPLACE_ALL, { t1136,s1137,r1138 }), t1136, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { t1136,s1137 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_REPLACE_RE_NONE, { t1139, r1140 }, nm->mkNode(Kind::STRING_REPLACE_RE, { t1139,e1281,r1140 }), t1139, e1277, Node::null());
db.addRule(ProofRewriteRule::STR_REPLACE_RE_ALL_NONE, { t1141, r1142 }, nm->mkNode(Kind::STRING_REPLACE_RE_ALL, { t1141,e1281,r1142 }), t1141, e1277, Node::null());
db.addRule(ProofRewriteRule::STR_LEN_CONCAT_REC, { s11143, s21144, s31145 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_CONCAT, { s11143,s21144,s31145 }) }), nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_CONCAT, { s21144,s31145 }) }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1264 }),nm->mkNode(Kind::ADD, { nm->mkNode(Kind::STRING_LENGTH, { s11143 }),t1264 }) }));
db.addRule(ProofRewriteRule::STR_INDEXOF_SELF, { t1146, n1147 }, nm->mkNode(Kind::STRING_INDEXOF, { t1146,t1146,n1147 }), nm->mkNode(Kind::STRING_INDEXOF, { e1292,e1292,n1147 }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_INDEXOF_NO_CONTAINS, { t1148, s1149, n1150 }, nm->mkNode(Kind::STRING_INDEXOF, { t1148,s1149,n1150 }), e1289, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_SUBSTR, { t1148,n1150,nm->mkNode(Kind::STRING_LENGTH, { t1148 }) }),s1149 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_INDEXOF_CONTAINS_PRE, { t11151, t21152, s1153, n1154 }, nm->mkNode(Kind::STRING_INDEXOF, { nm->mkNode(Kind::STRING_CONCAT, { t11151,t21152 }),s1153,n1154 }), nm->mkNode(Kind::STRING_INDEXOF, { t11151,s1153,n1154 }), nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_SUBSTR, { t11151,n1154,nm->mkNode(Kind::STRING_LENGTH, { t11151 }) }),s1153 }), Node::null());
db.addRule(ProofRewriteRule::STR_INDEXOF_RE_NONE, { t1155, n1156 }, nm->mkNode(Kind::STRING_INDEXOF_RE, { t1155,e1281,n1156 }), e1289, e1277, Node::null());
db.addRule(ProofRewriteRule::STR_TO_LOWER_CONCAT, { s11157, s21158, s31159 }, nm->mkNode(Kind::STRING_TO_LOWER, { nm->mkNode(Kind::STRING_CONCAT, { s11157,s21158,s31159 }) }), nm->mkNode(Kind::STRING_TO_LOWER, { nm->mkNode(Kind::STRING_CONCAT, { s21158,s31159 }) }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1265 }),nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_TO_LOWER, { s11157 }),t1265 }) }));
db.addRule(ProofRewriteRule::STR_TO_UPPER_CONCAT, { s11160, s21161, s31162 }, nm->mkNode(Kind::STRING_TO_UPPER, { nm->mkNode(Kind::STRING_CONCAT, { s11160,s21161,s31162 }) }), nm->mkNode(Kind::STRING_TO_UPPER, { nm->mkNode(Kind::STRING_CONCAT, { s21161,s31162 }) }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1266 }),nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_TO_UPPER, { s11160 }),t1266 }) }));
db.addRule(ProofRewriteRule::STR_TO_LOWER_UPPER, { s1163 }, nm->mkNode(Kind::STRING_TO_LOWER, { nm->mkNode(Kind::STRING_TO_UPPER, { s1163 }) }), nm->mkNode(Kind::STRING_TO_LOWER, { s1163 }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_TO_UPPER_LOWER, { s1164 }, nm->mkNode(Kind::STRING_TO_UPPER, { nm->mkNode(Kind::STRING_TO_LOWER, { s1164 }) }), nm->mkNode(Kind::STRING_TO_UPPER, { s1164 }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_TO_LOWER_LEN, { s1165 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_TO_LOWER, { s1165 }) }), nm->mkNode(Kind::STRING_LENGTH, { s1165 }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_TO_UPPER_LEN, { s1166 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_TO_UPPER, { s1166 }) }), nm->mkNode(Kind::STRING_LENGTH, { s1166 }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_TO_LOWER_FROM_INT, { n1167 }, nm->mkNode(Kind::STRING_TO_LOWER, { e1291 }), e1291, e1277, Node::null());
db.addRule(ProofRewriteRule::STR_TO_UPPER_FROM_INT, { n1168 }, nm->mkNode(Kind::STRING_TO_UPPER, { e1290 }), e1290, e1277, Node::null());
db.addRule(ProofRewriteRule::STR_TO_INT_CONCAT_NEG_ONE, { s11169, s21170, s31171 }, nm->mkNode(Kind::STRING_STOI, { nm->mkNode(Kind::STRING_CONCAT, { s11169,s21170,s31171 }) }), e1289, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_STOI, { s21170 }),e1289 }), Node::null());
db.addRule(ProofRewriteRule::STR_LEQ_EMPTY, { s1172 }, nm->mkNode(Kind::STRING_LEQ, { e1287,s1172 }), e1277, e1277, Node::null());
db.addRule(ProofRewriteRule::STR_LEQ_EMPTY_EQ, { s1173 }, nm->mkNode(Kind::STRING_LEQ, { s1173,e1287 }), nm->mkNode(Kind::EQUAL, { s1173,e1287 }), e1277, Node::null());
db.addRule(ProofRewriteRule::STR_LEQ_CONCAT_FALSE, { s1174, t11175, s11176, t21177, s21178 }, nm->mkNode(Kind::STRING_LEQ, { nm->mkNode(Kind::STRING_CONCAT, { s1174,t11175,t21177 }),nm->mkNode(Kind::STRING_CONCAT, { s1174,s11176,s21178 }) }), e1286, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t11175 }),nm->mkNode(Kind::STRING_LENGTH, { s11176 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LEQ, { t11175,s11176 }),e1286 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_LEQ_CONCAT_TRUE, { s1179, t11180, s11181, t21182, s21183 }, nm->mkNode(Kind::STRING_LEQ, { nm->mkNode(Kind::STRING_CONCAT, { s1179,t11180,t21182 }),nm->mkNode(Kind::STRING_CONCAT, { s1179,s11181,s21183 }) }), e1277, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t11180 }),nm->mkNode(Kind::STRING_LENGTH, { s11181 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { t11180,s11181 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LEQ, { t11180,s11181 }),e1277 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_LT_ELIM, { s1184, t1185 }, nm->mkNode(Kind::STRING_LT, { s1184,t1185 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1184,t1185 }) }),nm->mkNode(Kind::STRING_LEQ, { s1184,t1185 }) }), e1277, Node::null());
db.addRule(ProofRewriteRule::RE_ALL_ELIM, {  }, nm->mkNode(Kind::REGEXP_ALL, {  }), e1282, e1277, Node::null());
db.addRule(ProofRewriteRule::RE_OPT_ELIM, { x1186 }, nm->mkNode(Kind::REGEXP_OPT, { x1186 }), nm->mkNode(Kind::REGEXP_UNION, { e1285,x1186 }), e1277, Node::null());
db.addRule(ProofRewriteRule::RE_DIFF_ELIM, { x1187, y1188 }, nm->mkNode(Kind::REGEXP_DIFF, { x1187,y1188 }), nm->mkNode(Kind::REGEXP_INTER, { x1187,nm->mkNode(Kind::REGEXP_COMPLEMENT, { y1188 }) }), e1277, Node::null());
db.addRule(ProofRewriteRule::RE_CONCAT_EMP, { xs1189, ys1190 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1189,e1285,ys1190 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1189,ys1190 }), e1277, Node::null());
db.addRule(ProofRewriteRule::RE_CONCAT_NONE, { xs1191, ys1192 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1191,e1281,ys1192 }), e1281, e1277, Node::null());
db.addRule(ProofRewriteRule::RE_CONCAT_FLATTEN, { xs1193, s1194, ys1195, zs1196 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1193,nm->mkNode(Kind::REGEXP_CONCAT, { s1194,ys1195 }),zs1196 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1193,s1194,ys1195,zs1196 }), e1277, Node::null());
db.addRule(ProofRewriteRule::RE_CONCAT_STAR_SWAP, { xs1197, r1198, ys1199 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1197,e1284,r1198,ys1199 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1197,r1198,e1284,ys1199 }), e1277, Node::null());
db.addRule(ProofRewriteRule::RE_CONCAT_STAR_REPEAT, { xs1200, r1201, ys1202 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1200,e1283,e1283,ys1202 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1200,e1283,ys1202 }), e1277, Node::null());
db.addRule(ProofRewriteRule::RE_CONCAT_MERGE, { xs1203, s1204, t1205, ys1206 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1203,nm->mkNode(Kind::STRING_TO_REGEXP, { s1204 }),nm->mkNode(Kind::STRING_TO_REGEXP, { t1205 }),ys1206 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1203,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1204,t1205 }) }),ys1206 }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1267 }),t1267 }));
db.addRule(ProofRewriteRule::RE_UNION_ALL, { xs1207, ys1208 }, nm->mkNode(Kind::REGEXP_UNION, { xs1207,e1282,ys1208 }), e1282, e1277, Node::null());
db.addRule(ProofRewriteRule::RE_UNION_NONE, { xs1209, ys1210 }, nm->mkNode(Kind::REGEXP_UNION, { xs1209,e1281,ys1210 }), nm->mkNode(Kind::REGEXP_UNION, { xs1209,ys1210 }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1268 }),t1268 }));
db.addRule(ProofRewriteRule::RE_UNION_FLATTEN, { xs1211, b1212, ys1213, zs1214 }, nm->mkNode(Kind::REGEXP_UNION, { xs1211,nm->mkNode(Kind::REGEXP_UNION, { b1212,ys1213 }),zs1214 }), nm->mkNode(Kind::REGEXP_UNION, { xs1211,b1212,ys1213,zs1214 }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1269 }),t1269 }));
db.addRule(ProofRewriteRule::RE_UNION_DUP, { xs1215, b1216, ys1217, zs1218 }, nm->mkNode(Kind::REGEXP_UNION, { xs1215,b1216,ys1217,b1216,zs1218 }), nm->mkNode(Kind::REGEXP_UNION, { xs1215,b1216,ys1217,zs1218 }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1270 }),t1270 }));
db.addRule(ProofRewriteRule::RE_INTER_ALL, { xs1219, ys1220 }, nm->mkNode(Kind::REGEXP_INTER, { xs1219,e1282,ys1220 }), nm->mkNode(Kind::REGEXP_INTER, { xs1219,ys1220 }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1271 }),t1271 }));
db.addRule(ProofRewriteRule::RE_INTER_NONE, { xs1221, ys1222 }, nm->mkNode(Kind::REGEXP_INTER, { xs1221,e1281,ys1222 }), e1281, e1277, Node::null());
db.addRule(ProofRewriteRule::RE_INTER_FLATTEN, { xs1223, b1224, ys1225, zs1226 }, nm->mkNode(Kind::REGEXP_INTER, { xs1223,nm->mkNode(Kind::REGEXP_INTER, { b1224,ys1225 }),zs1226 }), nm->mkNode(Kind::REGEXP_INTER, { xs1223,b1224,ys1225,zs1226 }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1272 }),t1272 }));
db.addRule(ProofRewriteRule::RE_INTER_DUP, { xs1227, b1228, ys1229, zs1230 }, nm->mkNode(Kind::REGEXP_INTER, { xs1227,b1228,ys1229,b1228,zs1230 }), nm->mkNode(Kind::REGEXP_INTER, { xs1227,b1228,ys1229,zs1230 }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1273 }),t1273 }));
db.addRule(ProofRewriteRule::RE_STAR_NONE, {  }, nm->mkNode(Kind::REGEXP_STAR, { e1281 }), e1285, e1277, Node::null());
db.addRule(ProofRewriteRule::RE_LOOP_NEG, { n1231, m1232, r1233 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::REGEXP_LOOP)),n1231,m1232,r1233 }), e1281, nm->mkNode(Kind::GT, { n1231,m1232 }), Node::null());
db.addRule(ProofRewriteRule::RE_INTER_CSTRING, { xs1234, ys1235, s1236 }, nm->mkNode(Kind::REGEXP_INTER, { xs1234,e1280,ys1235 }), e1280, nm->mkNode(Kind::STRING_IN_REGEXP, { s1236,nm->mkNode(Kind::REGEXP_INTER, { xs1234,ys1235 }) }), Node::null());
db.addRule(ProofRewriteRule::RE_INTER_CSTRING_NEG, { xs1237, ys1238, s1239 }, nm->mkNode(Kind::REGEXP_INTER, { xs1237,nm->mkNode(Kind::STRING_TO_REGEXP, { s1239 }),ys1238 }), e1281, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1239,nm->mkNode(Kind::REGEXP_INTER, { xs1237,ys1238 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_LEN_INCLUDE, { s11240, s21241, n1242, m1243 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s11240,s21241 }),n1242,m1243 }), nm->mkNode(Kind::STRING_SUBSTR, { s11240,n1242,m1243 }), nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { s11240 }),nm->mkNode(Kind::ADD, { n1242,m1243 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_LEN_INCLUDE_PRE, { s11244, s21245, s31246, n1247 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s11244,s21245,s31246 }),e1276,n1247 }), nm->mkNode(Kind::STRING_CONCAT, { s11244,nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s21245,s31246 }),e1276,nm->mkNode(Kind::SUB, { n1247,e1279 }) }) }), nm->mkNode(Kind::GEQ, { n1247,e1279 }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_LEN_SKIP, { s11248, s21249, s31250, n1251, m1252 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s11248,s21249,s31250 }),n1251,m1252 }), nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s21249,s31250 }),nm->mkNode(Kind::SUB, { n1251,e1278 }),m1252 }), nm->mkNode(Kind::GEQ, { n1251,e1278 }), Node::null());
db.addRule(ProofRewriteRule::SEQ_LEN_REV, { x1253 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_REV, { x1253 }) }), nm->mkNode(Kind::STRING_LENGTH, { x1253 }), e1277, Node::null());
db.addRule(ProofRewriteRule::SEQ_REV_REV, { x1254 }, nm->mkNode(Kind::STRING_REV, { nm->mkNode(Kind::STRING_REV, { x1254 }) }), x1254, e1277, Node::null());
db.addRule(ProofRewriteRule::SEQ_REV_CONCAT, { x1255, y1256, z1257 }, nm->mkNode(Kind::STRING_REV, { nm->mkNode(Kind::STRING_CONCAT, { x1255,y1256,z1257 }) }), nm->mkNode(Kind::STRING_REV, { nm->mkNode(Kind::STRING_CONCAT, { x1255,y1256 }) }), e1277, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1274 }),nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_REV, { z1257 }),t1274 }) }));
db.addRule(ProofRewriteRule::SEQ_LEN_UNIT, { x1258 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::SEQ_UNIT, { x1258 }) }), e1288, e1277, Node::null());
db.addRule(ProofRewriteRule::SEQ_NTH_UNIT, { x1259 }, nm->mkNode(Kind::SEQ_NTH, { nm->mkNode(Kind::SEQ_UNIT, { x1259 }),e1276 }), x1259, e1277, Node::null());
db.addRule(ProofRewriteRule::SEQ_REV_UNIT, { x1260 }, nm->mkNode(Kind::STRING_REV, { e1275 }), e1275, e1277, Node::null());
db.addRule(ProofRewriteRule::SEQ_LEN_EMPTY, { x1261 }, nm->mkNode(Kind::STRING_LENGTH, { x1261 }), e1276, nm->mkNode(Kind::EQUAL, { x1261,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x1261 }) }) }), Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
