/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_uf_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node t1495 = NodeManager::mkBoundVar("t1495", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t1496 = NodeManager::mkBoundVar("t1496", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1497 = NodeManager::mkBoundVar("s1497", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t1498 = NodeManager::mkBoundVar("t1498", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1499 = NodeManager::mkBoundVar("s1499", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node r1500 = NodeManager::mkBoundVar("r1500", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node C1501 = NodeManager::mkBoundVar("C1501", nm->booleanType());
Node t1502 = NodeManager::mkBoundVar("t1502", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1503 = NodeManager::mkBoundVar("s1503", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node r1504 = NodeManager::mkBoundVar("r1504", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t1505 = NodeManager::mkBoundVar("t1505", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1506 = NodeManager::mkBoundVar("s1506", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node w1507 = NodeManager::mkBoundVar("w1507", nm->integerType());
Node t1508 = NodeManager::mkBoundVar("t1508", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w1509 = NodeManager::mkBoundVar("w1509", nm->integerType());
Node t1510 = NodeManager::mkBoundVar("t1510", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n1511 = NodeManager::mkBoundVar("n1511", nm->integerType());
Node w1512 = NodeManager::mkBoundVar("w1512", nm->integerType());
Node t1513 = NodeManager::mkBoundVar("t1513", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node wm11514 = NodeManager::mkBoundVar("wm11514", nm->integerType());
Node w1515 = NodeManager::mkBoundVar("w1515", nm->integerType());
Node t1516 = NodeManager::mkBoundVar("t1516", nm->integerType());
Node x1517 = NodeManager::mkBoundVar("x1517", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n1518 = NodeManager::mkBoundVar("n1518", nm->integerType());
Node w1519 = NodeManager::mkBoundVar("w1519", nm->integerType());
Node t1520 = NodeManager::mkBoundVar("t1520", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node s1521 = NodeManager::mkBoundVar("s1521", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t1522 = NodeManager::mkBoundVar("t1522", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node s1523 = NodeManager::mkBoundVar("s1523", nm->mkAbstractType(Kind::BITVECTOR_TYPE));

  // Definitions
Node e1524 = nm->mkConst(true);
Node e1525 = nm->mkConstInt(Rational(0));
Node e1526 = nm->mkNode(Kind::BITVECTOR_SIZE, { t1510 });
Node e1527 = nm->mkNode(Kind::EQUAL, { t1498,r1500 });
Node e1528 = nm->mkNode(Kind::EQUAL, { t1498,s1499 });
Node e1529 = nm->mkConst(false);

  // Rules

        {
            // from rewrites-uf-rewrites.cpp
            db.addRule(ProofRewriteRule::EQ_REFL, { t1495 }, nm->mkNode(Kind::EQUAL, { t1495,t1495 }), e1524, e1524, Node::null());
db.addRule(ProofRewriteRule::EQ_SYMM, { t1496, s1497 }, nm->mkNode(Kind::EQUAL, { t1496,s1497 }), nm->mkNode(Kind::EQUAL, { s1497,t1496 }), e1524, Node::null());
db.addRule(ProofRewriteRule::EQ_COND_DEQ, { t1498, s1499, r1500 }, nm->mkNode(Kind::EQUAL, { e1528,e1527 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { e1528 }),nm->mkNode(Kind::NOT, { e1527 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::EQUAL, { s1499,r1500 }),e1529 }), Node::null());
db.addRule(ProofRewriteRule::EQ_ITE_LIFT, { C1501, t1502, s1503, r1504 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::ITE, { C1501,t1502,s1503 }),r1504 }), nm->mkNode(Kind::ITE, { C1501,nm->mkNode(Kind::EQUAL, { t1502,r1504 }),nm->mkNode(Kind::EQUAL, { s1503,r1504 }) }), e1524, Node::null());
db.addRule(ProofRewriteRule::DISTINCT_BINARY_ELIM, { t1505, s1506 }, nm->mkNode(Kind::DISTINCT, { t1505,s1506 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { t1505,s1506 }) }), e1524, Node::null());
db.addRule(ProofRewriteRule::UF_BV2NAT_INT2BV, { w1507, t1508 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::INT_TO_BITVECTOR)),w1507,nm->mkNode(Kind::BITVECTOR_TO_NAT, { t1508 }) }), t1508, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::BITVECTOR_SIZE, { t1508 }),w1507 }), Node::null());
db.addRule(ProofRewriteRule::UF_BV2NAT_INT2BV_EXTEND, { w1509, t1510, n1511 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::INT_TO_BITVECTOR)),w1509,nm->mkNode(Kind::BITVECTOR_TO_NAT, { t1510 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e1525,n1511 }),t1510 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GT, { w1509,e1526 }),nm->mkNode(Kind::EQUAL, { n1511,nm->mkNode(Kind::SUB, { w1509,e1526 }) }) }), Node::null());
db.addRule(ProofRewriteRule::UF_BV2NAT_INT2BV_EXTRACT, { w1512, t1513, wm11514 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::INT_TO_BITVECTOR)),w1512,nm->mkNode(Kind::BITVECTOR_TO_NAT, { t1513 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm11514,e1525,t1513 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { w1512,nm->mkNode(Kind::BITVECTOR_SIZE, { t1513 }) }),nm->mkNode(Kind::EQUAL, { wm11514,nm->mkNode(Kind::SUB, { w1512,nm->mkConstInt(Rational(1)) }) }) }), Node::null());
db.addRule(ProofRewriteRule::UF_INT2BV_BV2NAT, { w1515, t1516 }, nm->mkNode(Kind::BITVECTOR_TO_NAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::INT_TO_BITVECTOR)),w1515,t1516 }) }), nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t1516,nm->mkNode(Kind::POW2, { w1515 }) }), e1524, Node::null());
db.addRule(ProofRewriteRule::UF_BV2NAT_GEQ_ELIM, { x1517, n1518, w1519 }, nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::BITVECTOR_TO_NAT, { x1517 }),n1518 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::GEQ, { n1518,w1519 }),e1529,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::LT, { n1518,e1525 }),e1524,nm->mkNode(Kind::BITVECTOR_UGE, { x1517,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::INT_TO_BITVECTOR)),w1519,n1518 }) }) }) }), nm->mkNode(Kind::EQUAL, { w1519,nm->mkNode(Kind::BITVECTOR_SIZE, { x1517 }) }), Node::null());
db.addRule(ProofRewriteRule::UF_INT2BV_BVULT_EQUIV, { t1520, s1521 }, nm->mkNode(Kind::BITVECTOR_ULT, { t1520,s1521 }), nm->mkNode(Kind::LT, { nm->mkNode(Kind::BITVECTOR_TO_NAT, { t1520 }),nm->mkNode(Kind::BITVECTOR_TO_NAT, { s1521 }) }), e1524, Node::null());
db.addRule(ProofRewriteRule::UF_INT2BV_BVULE_EQUIV, { t1522, s1523 }, nm->mkNode(Kind::BITVECTOR_ULE, { t1522,s1523 }), nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::BITVECTOR_TO_NAT, { t1522 }),nm->mkNode(Kind::BITVECTOR_TO_NAT, { s1523 }) }), e1524, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
